﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var ColorConvert =
{
    rgbToHex: function (rgbColor) {
        var rgb = rgbColor.match(/\d+/g);
        var hex = '#' + String('0' + Number(rgb[0]).toString(16)).slice(-2) + String('0' + Number(rgb[1]).toString(16)).slice(-2) + String('0' + Number(rgb[2]).toString(16)).slice(-2);
        return hex;
    },

    rgbValToHex: function (r, g, b) {
        var hex = '#' + String('0' + Number(r).toString(16)).slice(-2) + String('0' + Number(g).toString(16)).slice(-2) + String('0' + Number(b).toString(16)).slice(-2);
        return hex;
    },

    hexToRgb: function (hex) {
        if (hex[0] === '#') {
            hex = hex.substring(1, hex.length);
        }
        var bigint = parseInt(hex, 16);
        var r = (bigint >> 16) & 255;
        var g = (bigint >> 8) & 255;
        var b = bigint & 255;

        return [r, g, b];
    },
    hexIsLight: function (hex) {
        var rgb = ColorConvert.hexToRgb(hex);
        return ColorConvert.rgbIsLight(rgb);
    },

    rgbIsLight: function (rgb) {
        //rgb = [255, 255, 255]; // read-only  [0-255, 0-255, 0-255]
        return (
				0.213 * rgb[0] +
				0.715 * rgb[1] +
				0.072 * rgb[2] >
				255 / 2
			);
    }
};