// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var Bead = {

    // draw a bead
    drawBead: function (ctx, x, y, width, height, colorHex, radius, lineWidth, fill, stroke) {

        var grd = ctx.createLinearGradient(x, y, x, y + height);

        if (colorHex.toLowerCase() === "#ffffff") {
            grd.addColorStop(0, "#DDDDDD");
            grd.addColorStop(.3, "white");
            grd.addColorStop(1, "#DDDDDD");
        }
        else {
            grd.addColorStop(0, colorHex);
            grd.addColorStop(.3, "white");
            grd.addColorStop(1, colorHex);
        }

        ctx.fillStyle = grd;
        ctx.lineWidth = lineWidth;
        Bead.roundRect(ctx, x, y, width, height, radius, fill, stroke);
    },
    roundRect: function (ctx, x, y, width, height, radius, fill, stroke) {
        if (typeof stroke == "undefined") {
            stroke = true;
        }
        if (typeof radius === "undefined") {
            radius = 5;
        }
        ctx.beginPath();
        ctx.moveTo(x + radius, y);
        ctx.lineTo(x + width - radius, y);
        ctx.quadraticCurveTo(x + width, y, x + width, y + radius);
        ctx.lineTo(x + width, y + height - radius);
        ctx.quadraticCurveTo(x + width, y + height, x + width - radius, y + height);
        ctx.lineTo(x + radius, y + height);
        ctx.quadraticCurveTo(x, y + height, x, y + height - radius);
        ctx.lineTo(x, y + radius);
        ctx.quadraticCurveTo(x, y, x + radius, y);
        ctx.closePath();
        if (fill) {
            ctx.fill();
        }
        if (stroke) {
            ctx.stroke();
        }
    },

    drawSymbolOnBead: function (ctx, symbol, x, y, width, height, colorHex) {
        if (width - 2 > 0) {
            ctx.font = width - 2 + "px crochetdesignsfont";

            var fgColor = ColorConvert.hexIsLight(colorHex) ? '#000' : '#FFF';
            ctx.fillStyle = fgColor;
            ctx.fillText(symbol, x, y);
        }
    },
    drawSymbol: function (ctx, symbol, x, y, width, height, colorHex) {
        if (width - 2 > 0) {
            ctx.font = width - 2 + "px crochetdesignsfont";
            ctx.fillStyle = "black";
            ctx.fillText(symbol, x, y);
        }
    }
}