﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var borders = {

    rows: 3,
    cols: 2,
    padding: 4,
    pat: [],
    //patCnt: 0,
    borderOnPat: null,
    borderWidth: 180,
    firstTime: true,
    buttonsHeight: 0,
    page: 1,

    canvasOffset: { "top": 0, "left": 0 },
    // current index into completePatList/freePatList
    // can only read one pattern at a time
    // use this to keep track of which pattern we just read
    borderIndex: -1,
    selectedBorder: -1,
    cancel: false,

    border: { "totalFiles": 12, "files": [
        { "filename": "b2010072218414576.bds" },
        { "filename": "b2010083017173025.bds" },
        { "filename": "b2010083017214044.bds" },
        { "filename": "b2010083017280241.bds" },
        { "filename": "b2010090219031081.bds" },
        { "filename": "b2010090312372894.bds" },
        { "filename": "b2010090312415335.bds" },
        { "filename": "b2010090413270291.bds" },
        { "filename": "b2010090811580613.bds" },
        { "filename": "b2010090919233131.bds" },
        { "filename": "b2010090919425104.bds" },
        { "filename": "b2010090919465937.bds" },
        { "filename": "b2010090920004946.bds" },
        { "filename": "b2010090920131040.bds" },
        { "filename": "b2010090920241736.bds" },
        { "filename": "b2010091217382702.bds" },
        { "filename": "b2010092619072580.bds" },
        { "filename": "b2010092818242368.bds" },
        { "filename": "b2010092818510374.bds" },
        { "filename": "b2010092819091913.bds" },
        { "filename": "b2010092819192564.bds" },
        { "filename": "b2010092917141653.bds" },
        { "filename": "b2010100119294239.bds" },
        { "filename": "b2010100119564167.bds" },
        { "filename": "b2013012920154655.bds" },
        { "filename": "b2013031517570252.bds" },
        { "filename": "b2013031520383388.bds" },
        { "filename": "b2013031614461880.bds" },
        { "filename": "b2013031715574482.bds" },
        { "filename": "b2013031716213455.bds" },
        { "filename": "b2013031716321891.bds" },
        { "filename": "b2013031716464064.bds" },
        { "filename": "b2013031716535026.bds" },
        { "filename": "b2013032619085271.bds" },
        ]
    },

    initPage: function () {
        borders.page = 1;
        borders.displayNextPrevBtns();
    },

    // copy all patterns to application folder file:////data/data/com.SandCastleDesings.filetcrochet/files/
    getBorderFiles: function () {
        if (borders.firstTime) {
            borders.pat = [];

            borders.borderIndex = (borders.page - 1) * borders.rows * borders.cols;
            // start with first one, when it is done a call is made to get the next one myPat.getMyPatFile(1);

            borders.getBorderFile(borders.borderIndex);
            borders.firstTime = false;
        }
    },

    // get a pattern file from www/data folder that can be purchased
    getBorderFile: function (i) {

        var end = borders.page * borders.rows * borders.cols;
        var files = borders.border.files;
        // for each file listed in the completPatList array
        if (i < files.length) {// && i < end) {

            // read the .bds file
            $.ajax({
                url: 'data/borders/' + files[i].filename,
                type: "get",
                dataType: "text",

                success: function (data, textStatus, jqXHR) {

                    // read the title from the pattern
                    borders.displayBorder(i, files[i].filename, data);
                    borders.getNextBorderFile();
                },

                // just continue if could not read this file
                error: function (jqXHR, textStatus, errorThrown) {
                    borders.getNextBorderFile();
                }
            });
        }
    },
    // get the next pattern from the list
    // if no more patterns to read then refresh the list
    getNextBorderFile: function () {
        borders.borderIndex++;
        var end = borders.page * borders.rows * borders.cols;
        var files = borders.border.files;
        // read next pattern
        if (borders.borderIndex < files.length) {// && borders.borderIndex < end) {
            borders.getBorderFile(borders.borderIndex);
        }
        else {
            borders.displayNextPrevBtns();
        }
    },

    setCanvasSize: function (size) {

        var deviceWidth = app.deviceWidth();
        var deviceHeight = app.deviceHeight();

        if (borders.buttonsHeight === 0) {
            var headerHeight = $("#boarderHeader").height();
            var closeHeight = $("#bordersclosebutton").height();
            var borderButtonbar = $("#borderButtonbar").height();

            borders.buttonsHeight = headerHeight + closeHeight + (3 * borderButtonbar)
        }

        borders.cols = Math.floor(deviceWidth / (borders.borderWidth + borders.padding));
        if (borders.cols < 1)
            borders.cols = 1;
        borders.rows = Math.floor((deviceHeight - borders.buttonsHeight) / (borders.borderWidth + borders.padding));
        if (borders.rows < 1)
            borders.rows = 1;

        var w = (borders.cols * borders.borderWidth) + (borders.cols * borders.padding);
        var h = (borders.rows * borders.borderWidth) + (borders.rows * borders.padding);
        var canvas = $("#bordersCanvas");
        canvas.width(w);
        canvas.height(h);
        canvas[0].width = w;
        canvas[0].height = h;
    },
    resetPageNumber: function () {
        while (borders.page > 1 && borders.page * borders.rows * borders.cols > borders.border.files.length) {
            borders.page = borders.page - 1;
        }
    },
    redisplayBorders: function () {
        var canvas = $("#bordersCanvas");
        var cols = borders.cols;
        var rows = borders.rows;
        var x = 0;
        var y = 0;
        var r = 0;
        var c = 0;

        for (var i = 0; i < borders.pat.length; i++) {
            var row = cols === 0 ? 0 : parseInt(i / cols);
            if (row < rows * borders.page && row >= rows * (borders.page - 1)) {
                x = c * (borders.borderWidth + borders.padding);
                y = r * (borders.borderWidth + borders.padding);
                c++;
                if (c >= cols) {
                    c = 0;
                    r++;

                }
                borders.pat[i].drawBorder(canvas, x, y, borders.borderWidth);

            }
        }
    },
    // draw the border on the borders dialog box
    displayBorder: function (i, filename, content) {

        var row = parseInt(i / borders.cols);

        var canvas = $("#bordersCanvas");
        borders.pat[i] = new Pattern(canvas);
        borders.pat[i].readPattern(content);

        // if will fit on this page
        // if row for pattern  <  total rows that fit on a page * page number
        // and row for pattern >= total rows that fit on a page * previous page number
        if (row < borders.rows * borders.page && row >= borders.rows * (borders.page - 1)) {
            var col = i % borders.cols;
            var w = borders.borderWidth;
            var x = (col * w) + (col * borders.padding);
            var y = (row * w) + (row * borders.padding);
            borders.pat[i].drawBorder(canvas, x, y, w);
        }
    },

    displayNextPrevBtns: function () {

        // if on first page
        if (borders.page <= 1) {
            $("#bordersPrevious").prop("disabled", true);
        }
        else {
            $("#bordersPrevious").prop("disabled", false);
        }
        // no more borders to display
        if (borders.page * borders.rows * borders.cols < borders.border.files.length) {
            $("#bordersNext").prop("disabled", false);
        }
        else {
            $("#bordersNext").prop("disabled", true);
        }
    },

    nextPrevPage: function (next) {
        var bordersCanvas = $("#bordersCanvas");

        // clear the canvas
        var canvas = bordersCanvas[0];
        var context = canvas.getContext('2d');
        context.clearRect(0, 0, canvas.width, canvas.height);

        // going to next page
        borders.page = next ? borders.page + 1 : borders.page - 1;

        var startIdx = (borders.page - 1) * borders.rows * borders.cols;
        var endIdx = borders.page * borders.rows * borders.cols;
        for (var i = startIdx; i < endIdx; i++) {
            var row = parseInt(i / borders.cols) - (borders.rows * (borders.page - 1));
            var col = i % borders.cols;
            var w = borders.borderWidth;

            var x = (col * w) + (col * borders.padding);
            var y = (row * w) + (row * borders.padding);
            if (i < borders.pat.length) {
                borders.pat[i].drawBorder(bordersCanvas, x, y, w);
            }
            else {
                break;
            }
        }
        borders.displayNextPrevBtns();
    },

    selected: function (x, y) {
        var bordersCanvas = $("#bordersCanvas");
        var offset = bordersCanvas.offset();
        x -= offset.left;
        y -= offset.top;

        var colSelected = Math.floor(x / (borders.borderWidth + borders.padding));
        var rowSelected = Math.floor(y / (borders.borderWidth + borders.padding));
        var selected = colSelected + (rowSelected * borders.cols);
        selected += borders.rows * borders.cols * (borders.page - 1);

        // if user selected on a stamp and not blank space
        if (selected < borders.pat.length) {
            borders.selectedBorder = selected; // colSelected + (rowSelected * stamps.cols);
            history.back();
        }
    },

    displayBorderOnPattern: function () {
        if (borders.selectedBorder >= 0 && borders.selectedBorder < borders.pat.length) {
            
            var pat = borders.pat[borders.selectedBorder];
            
            var btns = pat.getBtns();
            var rows = pat.getRows();
            var cols = pat.getCols();
            var axis = pat.getBorderAxis();

            var borderLeftWidth = axis.left;
            var borderRightWidth = cols - axis.right;
            var borderMiddleLRWidth = cols - borderLeftWidth - borderRightWidth;
            var borderTopHeight = axis.top;
            var borderBottomHeight = rows - axis.bottom;
            var borderMiddelTBHeight = rows - borderTopHeight - borderBottomHeight;
            _pat.placeBorderOnPattern(borderLeftWidth, borderRightWidth, borderMiddleLRWidth, borderTopHeight, borderBottomHeight, borderMiddelTBHeight, rows, cols, btns);
            editor.modified = true;
            app.enableIconbar(true);
        }
    }
};
