﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var buy = {
    purchaseError: '',
    boughtFilename: '',
    boughtContent: '',
    patFolder: 'beadloompatterns',
    enableCreateFilename: 'enablecreate.txt', //enablecreate1.txt used for testing
    enableCreateContent: 'enablecreate',

    backNeeded: true,

    updateEnableCreateFile: function () {

        //cordova.file.applicationDirectory file:///android_asset
        //cordova.file.applicationStorageDirectory file:///data/data/com.crochetdesigns.fcreator/
        //cordova.file.documentsDirectory);  null
        //store = cordova.file.applicationStorageDirectory;
        document.addEventListener('deviceready', buy.updateEnableCreateFileDeviceReady, false);
    },

    updateEnableCreateFileDeviceReady: function () {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, buy.fsWriteEnableCreateFile, buy.writeFail);
    },

    fsWriteEnableCreateFile: function (fileSystem) {
        try {
            fileSystem.root.getDirectory(buy.patFolder, { create: true, exclusive: false }, buy.fsWriteEnableCreateFileF, buy.writeFail);
        }
        catch (err) {
            alert('Error locating file ' + buy.enableCreateFilename + " " + err.message);
            buy.purchaseError = "Purchase Error: " + err.message;
        }
    },
    fsWriteEnableCreateFileF: function (directoryEntry) {
        try {
            directoryEntry.getFile(buy.enableCreateFilename, { create: true, exclusive: false }, buy.writeEnableCreateFile, buy.writeFail);
        }
        catch (err) {
            alert('Error locating file ' + buy.enableCreateFilename + " " + err.message);
            buy.purchaseError = "Purchase Error: " + err.message;
        }
    },
    writeEnableCreateFile: function (fileEntry) {
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function (evt) {
                if (buy.backNeeded)
                    history.back();
            }
            fileWriter.write(buy.enableCreateContent);
        }, buy.writeFail);
    },

    getEnableCreateFile: function () {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, buy.fsReadEnableCreateFile, buy.readFail);
    },

    fsReadEnableCreateFile: function (directoryEntry) {
        directoryEntry.root.getFile(buy.patFolder + '/' + buy.enableCreateFilename, null, buy.feReadEnableCreateFile, buy.readFail);
    },

    feReadEnableCreateFile: function (fileEntry) {
        fileEntry.file(buy.frEnableCreateFile, buy.readFail);
    },
    frEnableCreateFile: function (file) {
        buy.readEnableCreateFile(file);
    },
    readEnableCreateFile: function (file) {
        var reader = new FileReader();
        reader.onloadend = function (evt) {
            // store settings in memory
            app.enableCreateButton(true);
        };
        reader.readAsText(file);
    },
    readFail: function (error) {
        googlePay.restorePurchase();
    },

    writeFail: function (error) {
        alert("An severe error has occured. You can contant help at CrochetDesigns.com or press the info icon on main page. Error code:" + error.code);
    }
};


