// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var camera = {

    targetWidth: 500,
    targetHeight: 500,

    getPicture: function () {

        // Retrieve image file location from specified source
        // this one works
        navigator.camera.getPicture(camera.onPictureURISuccess, camera.onFail, {
            quality: 30,
            targetWidth: 300,
            targetHeight: 500,
            correctOrientation: true,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY
        });
    },
    capturePhotoEdit: function () {
        //https://github.com/remoorejr/cordova-plugin-camera-with-exif
        // Take picture using device camera, allow edit, and retrieve image as base64-encoded string  
        navigator.camera.getPicture(camera.onPictureURISuccess, camera.onFail, {
            quality: 30,
            targetWidth: 300,
            targetHeight: 500,
            correctOrientation: true,
            allowEdit: false, // get error if set to true (why?) works on graphgan
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            saveToPhotoAlbum: false
        });
    },
    onPictureURISuccess: function (imageURI) {
        if (trace.traceBtnSelected) {
            trace.displayImageUriOnPattern(imageURI);
            trace.traceBtnSelected = false;
        }
        else {
            importImage.displayImageUriOnPattern(imageURI);
        }
    },
    getImagePixels: function (imgData) {
        var idx = 0;
        var pixels = new Array(imgData.data.length);
        for (var i = 0; i < imgData.data.length; i += 4) {
            var red = imgData.data[i];
            var green = imgData.data[i + 1];
            var blue = imgData.data[i + 2];
            var alpha = imgData.data[i + 3];
            var pix = [red, green, blue];
            pixels[idx++] = pix;
        }
        return pixels;
    },
    convertToImage: function (rgbdata, width, height) {
        importImage.displayImageOnPattern(rgbdata, width, height);

    },
    reduceColors: function (maxColors, pixels) {
        var cmap = MMCQ.quantize(pixels, maxColors);
        var newPixels = pixels.map(function (p) {
            return cmap.map(p);
        });
        return newPixels;
    },

    // Called if something bad happens.
    onFail: function (message) {
        alert('Failed because: ' + message);
        trace.traceBtnSelected = false;
    }
};