// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var cutBox = {
    btnsBox: [],
    btnRows: 0,
    btnCols: 0,

    cut: function () {
        // copy the btns on the pattern inside the drag box
        cutBox.copyBtns();
        _pat.ClearRowsColsRange(selectionBox.sizeSqrs.r1, selectionBox.sizeSqrs.c1, cutBox.btnsRows, cutBox.btnsCols);
        selectionBox.removeBoxCanvas();
        _pat.redrawPattern();
        tempFile.save();
        $("#undo").removeAttr('disabled');
        ColorSelector.updateColorCounts();
    },
    copy: function () {
        // copy the btns on the pattern inside the drag box
        cutBox.copyBtns();
    },
    paste: function () {
        var left = selectionBox.size.x1 < selectionBox.size.x2 ? selectionBox.size.x1 : selectionBox.size.x2;
        var right = selectionBox.size.x2 > selectionBox.size.x1 ? selectionBox.size.x2 : selectionBox.size.x1;
        var top = selectionBox.size.y1 < selectionBox.size.y2 ? selectionBox.size.y1 : selectionBox.size.y2;
        var bottom = selectionBox.size.y2 > selectionBox.size.y1 ? selectionBox.size.y2 : selectionBox.size.y1;
        selectionBox.drawMoveBox(cutBox.btnsBox, cutBox.btnsRows, cutBox.btnsCols, left, top, right, bottom, false);
    },
    rotate: function () {
        var rows = cutBox.btnsCols;
        var cols = cutBox.btnsRows;
        var box = [];

        // rotate the box
        for (var j = 0; j < cutBox.btnsCols; j++) {
            box[j] = [];
            for (var i = 0; i < cutBox.btnsRows; i++) {
                box[j][i] = cutBox.btnsBox[cutBox.btnsRows - i-1][j];
            }
        }
        cutBox.btnsRows = rows;
        cutBox.btnsCols = cols;
        cutBox.btnsBox = box;

        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();

        var left = selectionBox.sizeSqrs.c1 < selectionBox.sizeSqrs.c2 ? selectionBox.sizeSqrs.c1 : selectionBox.sizeSqrs.c2;
        var right = selectionBox.sizeSqrs.c2 > selectionBox.sizeSqrs.c1 ? selectionBox.sizeSqrs.c2 : selectionBox.sizeSqrs.c1;
        var top = selectionBox.sizeSqrs.r1 < selectionBox.sizeSqrs.r2 ? selectionBox.sizeSqrs.r1 : selectionBox.sizeSqrs.r2;
        var bottom = selectionBox.sizeSqrs.r2 > selectionBox.sizeSqrs.r1 ? selectionBox.sizeSqrs.r2 : selectionBox.sizeSqrs.r1;

        var rows = right - left;
        var cols = bottom - top;


        selectionBox.sizeSqrs.c1 = left;
        selectionBox.sizeSqrs.c2 = left + (rows * sqrW);

        selectionBox.sizeSqrs.r1 = top;
        selectionBox.sizeSqrs.r2 = top + (cols * sqrH);

        selectionBox.sizeSqrs.c2 = bottom;

        var loc = _pat.btnijToxy(selectionBox.sizeSqrs.r1, selectionBox.sizeSqrs.c1);

        selectionBox.size.x1 = loc.x - _pat.getLeftOffset();
        selectionBox.size.y1 = loc.y - _pat.getTopOffset();
        selectionBox.size.x2 = selectionBox.size.x1 + (rows * sqrW);
        selectionBox.size.y2 = selectionBox.size.y1 + (cols * sqrH);
    },

    copyBtns: function () {

        cutBox.btnsRows = selectionBox.sizeSqrs.r2 - selectionBox.sizeSqrs.r1;
        cutBox.btnsCols = selectionBox.sizeSqrs.c2 - selectionBox.sizeSqrs.c1;
        cutBox.btnsBox = [];
        var btns = _pat.getBtns();
        for (var i = 0; i < cutBox.btnsRows; i++) {
            cutBox.btnsBox[i] = [];
            for (var j = 0; j < cutBox.btnsCols; j++) {
                cutBox.btnsBox[i][j] = btns[selectionBox.sizeSqrs.r1 + i][selectionBox.sizeSqrs.c1 + j];
            }
        }
    }
};