﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var delPat = {

    deleteFilename: '',
    boughtPattern: false,
    patfile: '',
    listitem: null,

    initDialog: function () {
        // add functions to confirmation buttons
        $("#confirm #yes").on("click", function () {
            delPat.deletePatternfile(delPat.patfile);
            delPat.listitem.remove();
            $("#list").listview("refresh");

        });
        // Remove active state and unbind when the cancel button is clicked
        $("#confirm #cancel").on("click", function () {
            delPat.listitem.children(".ui-btn").removeClass("ui-btn-active");
            $("#confirm #yes").off();
        });
    },

    deletePattern: function (selected, patfile) {
        var item = $(selected);
        delPat.listitem = item.parent("li");
        delPat.patfile = patfile;
        delPat.confirmAndDelete();
    },
    confirmAndDelete: function () {
        // Highlight the list item that will be removed
        delPat.listitem.children(".ui-btn").addClass("ui-btn-active");

        delPat.boughtPattern = false;
        var id = $(delPat.listitem).attr("id");
        if (id.indexOf("id_b_") >= 0) {
            delPat.boughtPattern = true;
        }

        // Inject topic in confirmation popup after removing any previous injected topics
        $("#confirm .topic").remove();
        $("#confirm .pattitle").remove();
        delPat.listitem.find(".topic").clone().insertAfter("#question");
        delPat.listitem.find(".pattitle").clone().insertAfter("#question");

        // Show the confirmation popup
        $("#confirm").popup("open");
    },

    // delete pattern file
    deletePatternfile: function (patternFile) {
        delPat.deleteFilename = patternFile;
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, delPat.fsDeletePatfile, delPat.fail);
    },

    fsDeletePatfile: function (fileSystem) {
        fileSystem.root.getFile(app.patFolder + '/' + delPat.deleteFilename, { create: false, exclusive: false }, delPat.gotRemoveFileEntry, delPat.fail);

        // if not a bought pattern, we need to also delete the image file
        if (!delPat.boughtPattern) {
            var imageFile = delPat.deleteFilename.replace('.cht', 'pattern.png');
            fileSystem.root.getFile(app.patFolder + '/' + imageFile, { create: false, exclusive: false }, delPat.gotRemoveImageFileEntry, delPat.fail);
        }
    },

    gotRemoveFileEntry: function (fileEntry) {
        fileEntry.remove(delPat.fileDeleted, delPat.fail);
    },

    fileDeleted: function (entry) {
        app.deletePattern(delPat.deleteFilename);
        delPat.deleteFilename = '';
        //window.location.reload();
    },
    gotRemoveImageFileEntry: function (fileEntry) {
        fileEntry.remove(delPat.fileImageDeleted, delPat.fail);
    },

    fileImageDeleted: function (entry) {
    },
    fail: function (error) {
        var msg = app.getFileErrorCode(error);
        delPat.deleteFilename = '';
        alert('An error occurred while deleting the pattern: ' + msg);
    }
};
