// Bead Loom Pattern Creator Mobile
// Copyright 2019 Sand Castle Designs.Inc
// All Rights Reserved

var diagram = {
	mouse: {},
	zoom : function (amount){
		var diagramSvg = $("#diagramSvg");
		var width = diagramSvg.width() + amount;
		diagramSvg.width(width);
	}
}

var diagramTouchStart = function (event) {
    try {
		//else user has two fingers touching
        if (event.originalEvent.touches.length === 2) {

            app.mouse = {
                'touches': 2,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1,
                'startX2': event.originalEvent.touches[1].pageX,
                'endX2': -1,
                'startY2': event.originalEvent.touches[1].pageY,
                'endY2': -1
            };
		}
	} catch (e)
	{
	   alert (e.message);	
	}
}

var diagramTouchMove = function (event) {

    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;
    try {
	        if (app.mouse.endX1 !== -1) {
                app.mouse.startX1 = app.mouse.endX1;
                app.mouse.startY1 = app.mouse.endY1;
            }
            app.mouse.endX1 = event.originalEvent.touches[0].pageX;
            app.mouse.endY1 = event.originalEvent.touches[0].pageY;

            if (app.mouse.endX2 !== -1) {
                app.mouse.startX2 = app.mouse.endX2;
                app.mouse.startY2 = app.mouse.endY2;
            }
            app.mouse.endX2 = event.originalEvent.touches[1].pageX;
            app.mouse.endY2 = event.originalEvent.touches[1].pageY;

            // get the x, y differences for both fingers
            var touch1Diff;
            var touch2Diff;

            // if second finger is to the right of first finger
            if (app.mouse.startX2 > app.mouse.startX1) {
                touch1Diff = app.mouse.startX1 - app.mouse.endX1;
                touch2Diff = app.mouse.endX2 - app.mouse.startX2;
            }

            // else second finger is to the left of first finger
            else {
                touch1Diff = app.mouse.endX1 - app.mouse.startX1;
                touch2Diff = app.mouse.startX2 - app.mouse.endX2;
            }

            // which direction is the greatest, growing or shrinking
            var touchXDiff = touch1Diff + touch2Diff;

            // if second finger is below first finger
            if (app.mouse.startY2 > app.mouse.startY1) {
                touch1Diff = app.mouse.startY1 - app.mouse.endY1;
                touch2Diff = app.mouse.endY2 - app.mouse.startY2;
            }
            // else second finger is above first finger
            else {
                touch1Diff = app.mouse.endY1 - app.mouse.startY1;
                touch2Diff = app.mouse.startY2 - app.mouse.endY2;
            }

            // which direction is the greatest, growing or shrinking
            var touchYDiff = touch1Diff + touch2Diff;

            // if positive difference then zoom in pattern
            if (touchXDiff + touchYDiff > 0) {
                diagram.zoom (10);
            }

            // if negative different then out pattern
            else if (touchXDiff + touchYDiff < 0) {
                diagram.zoom (-10);
            }
	} catch (e)
	{
		alert (e.message);
	}
    
}

var diagramTouchEnd = function (event) {

    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;

    // if tap highlight the pattern to the tapped square
	/*
    if (app.mouse.tap === true) {
    }

    // else moved, zoomed in or zoomed out of pattern
    else {
        try {
            // redraw the pattern to produce image with good resolution
            if (app.mouse.touches !== undefined && app.mouse.touches > 1) {
               // _pat.redrawPattern(true);
            }
            else {
                //_pat.redrawPattern(false);
            }
            //_pat.saveCanvasScaleOrigWidthHeight();
        }
        catch (err) { }
    }*/
    app.mouse = {};
}