﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var editor = {
    selected: "",
    modified: false,

    setSymbolsSelectedOff: function (s) {
        var btn = $("#" + s);
        id = btn.attr('id');
        var img = btn.css('background-image');
        if (img.indexOf('sel') > 0) {
            btn.css({ 'background-image': 'url(img/symbols.png)' });
            ColorSelector.displaySymbolsOnPattern(false);
        }
    },


    setSymbolsSelected: function (s) {
        var btn = $("#" + s);
        id = btn.attr('id');
        var img = btn.css('background-image');
        if (img.indexOf('sel') > 0) {
            btn.css({ 'background-image': 'url(img/symbols.png)' });
            ColorSelector.displaySymbolsOnPattern(false);
        }
        else {
            btn.css({ 'background-image': 'url(img/symbolssel.png)' });
            ColorSelector.displaySymbolsOnPattern(true);
        }
    },

    setSelected: function (s) {

        // turn off previous selected button
        if (editor.selected !== "") {
            var oldBtn = $("#" + editor.selected);
            oldBtn.css({ 'border-color': 'transparent', 'background-image': 'url(img/' + editor.selected + '.png)' });

            // remove drag box
            if (editor.selected === "box") {
                selectionBox.abortDragbox();
                $("#copy").removeAttr('disabled');
                $("#copy").attr('disabled', 'disabled');
                $("#cut").removeAttr('disabled');
                $("#cut").attr('disabled', 'disabled');
                $("#paste").removeAttr('disabled');
                $("#paste").attr('disabled', 'disabled'); 
            }

            // if stamp move box has been left on the pattern
            // then just paste it
            else if (editor.selected === "stamps") {
                if (stamps.stampOnPat !== null) {
                    stamps.insertStampOnPattern();

                }
            }

            // if insert move box has been left on the pattern
            // then just paste it
            else if (editor.selected === "inserts") {
                if (inserts.insertOnPat !== null) {
                    inserts.insertInsertOnPattern();

                }
            }
        }

        var id = "";
        if (s !== "") {
            var btn = $("#" + s);
            id = btn.attr('id');

            // if current selected button is old button
            // we already turned it off, select current selected button to none 
            if (editor.selected === id && id !== "undo" && id !== "redo" && id !== "zoomin" && id !== "zoomout" && id !== "camera" && id !== "picture" && id !== "share" && id !== "rotate" && id !== "trace") {
                editor.selected = "";
            }
            // else selecting a different button
            else {

                if (id !== "undo" && id !== "redo" && id !== "color" && id !== "zoomin" && id !== "zoomout" && id !== "camera" && id !== "picture" && id !== "share" && id !== "cut" && id !== "rotate" && id !== "trace") {
                    btn.css({ 'background-image': 'url(img/' + id + 'sel.png)' });
                }
                editor.selected = id;
            }
        }

        // nothing is selected next
        else {
            editor.selected = "";
        }

        if (editor.selected === "stamps") {
            if (trace.tracing) {
                trace.close();
            }
            $.mobile.changePage("#stamps-page", null, true, true);
        }
        else if (editor.selected === "inserts") {
            if (trace.tracing) {
                trace.close();
            }
            $.mobile.changePage("#inserts-page", null, true, true);
        }
        else if (editor.selected === "borders") {
            if (trace.tracing) {
                trace.close();
            }
            $.mobile.changePage("#borders-page", null, true, true);
        }
        else if (editor.selected === "undo") {
            editor.undo();
            editor.selected = "";
        }
        else if (editor.selected === "redo") {
            editor.redo();
            editor.selected = "";
        }
        else if (editor.selected === "zoomin") {
            editor.zoomin();
            editor.selected = "";
        }
        else if (editor.selected === "zoomout") {
            editor.zoomout();
            editor.selected = "";
        }
        else if (editor.selected === "dropper") {
        }
        else if (editor.selected === "bucket") {
        }
        else if (editor.selected === "box") {
            if (trace.tracing) {
                trace.close();
            }
        }
        else if (editor.selected === "cut") {
            if (trace.tracing) {
                trace.close();
            }
            editor.cut();
            editor.selected = "";
        }
        else if (editor.selected === "copy") {
            if (trace.tracing) {
                trace.close();
            }
            editor.copy();
        }
        else if (editor.selected === "paste") {
            editor.paste();
        }

        else if (editor.selected === "rotate") {
            if (trace.tracing) {
                trace.close();
            }
            editor.rotate();           
        }
        else if (editor.selected === "save") {
            $.mobile.changePage("#savepattern-page", null, true, true);
        }
        else if (editor.selected === "camera") {
            if (trace.tracing) {
                trace.close();
            }
            editor.cameras();
        }
        else if (editor.selected === "picture") {
            if (trace.tracing) {
                trace.close();
            }
            editor.picture();
        }
        else if (editor.selected === "trace") {
            editor.trace();
        }
        else if (editor.selected === "color") {
            // make pencil current button           
            editor.selected = "pencil";
            var btn2 = $("#" + editor.selected);
            btn2.css({ 'background-image': 'url(img/' + editor.selected + 'sel.png)' });
        }
        else if (editor.selected === "share") {
            editor.share();
        }
    },
    draw: function (x, y) {
        editor.modified = true;
        switch (editor.selected) {
            case "pencil":
                editor.drawFilled(x, y);
                break;
            case "eraser":
                editor.drawErase(x, y);
                break;
            case "foursqr":
                editor.drawFourSqr(x, y);
                break;
            case "twosqr":
                editor.drawTwoSqr(x, y);
                break;
            case "trim":
                editor.drawTrim(x, y);
                break;
            case "dropper":
                //editor.getPixelColor(x, y);
                editor.getSelectedBeadColor(x, y);
                break;
            case "bucket":
                editor.bucketFill(x, y);
                break;
            case "box":
                editor.drawBox(x, y);
                break;
            case "stamps":
                break;
            case "inserts":
                break;
            case "borders":
                break;
            case "undo":
                break;
            case "redo":
                break;
            case "save":
                editor.save();
                break;
            case "share":
                break;
            default:
                editor.modified = false;
                break;
        }
    },
    drawFilled: function (x, y) {
        if (app.mouse.touches == 1) {
            _pat.fillSquare(x, y);
        }
    },
    drawErase: function (x, y) {
        if (app.mouse.touches == 1) {
            _pat.clearSquare(x, y);
        }
    },
    drawFourSqr: function (x, y) {
        if (app.mouse.touches == 1) {
            _pat.fourSquare(x, y);
        }
    },
    drawTwoSqr: function (x, y) {
        if (app.mouse.touches == 1) {
            _pat.twoSquare(x, y);
        }
    },
    drawTrim: function (x, y) {
        if (app.mouse.touches == 1) {
            _pat.trimSquare(x, y);
        }
    },
    getSelectedBeadColor: function (x, y) {
        if (app.mouse.touches == 1) {
            var color = _pat.getBeadColor(x, y);
            var colorBtn = $("#color");
            colorBtn.css("background-color", color);
            var colorBtnId = ColorSelector.getExistingColorBtnId(color);
            if (colorBtnId !== "") {
                var colorBtnTableId = colorBtnId.replace("Btn_", "BtnTable_");
                ColorSelector.setCurrentSelectedButton("#" + colorBtnTableId);
            }
            _pat.setfilledSqrColor(color);
        }
    },
    getPixelColor: function (x, y) {
        if (app.mouse.touches == 1) {
            var color = _pat.getPixelColor(x, y);
            var colorBtn = $("#color");
            colorBtn.css("background-color", color);
            var colorBtnId = ColorSelector.getExistingColorBtnId(color);
            if (colorBtnId !== "") {
                var colorBtnTableId = colorBtnId.replace("Btn_", "BtnTable_");
                ColorSelector.setCurrentSelectedButton("#" + colorBtnTableId);
            }
            _pat.setfilledSqrColor(color);
        }
    },
    bucketFill: function (x, y) {
        if (app.mouse.touches == 1 && _pat !== null) {
            var btn = _pat.mousexyToBtnij(x, y);
            if (btn !== null && _pat !== null) {
                if (_pat.bucketFill(x, y, btn)) {
                    tempFile.save();
                    $("#undo").removeAttr('disabled');
                    ColorSelector.updateColorCounts();
                }
            }
        }
    },
    drawBox: function (x, y) {
        if (app.mouse.touches == 1) {
            if (selectionBox.mode === "dragboxend" && selectionBox.insideBox(x, y)) {
                selectionBox.createMoveBox(x, y);
            }
            else if (selectionBox.mode === "movebox") {
            }
            else if (selectionBox.mode === "dragbox") {
                selectionBox.dragBox(x, y);
            }
            else {
                selectionBox.displayBox(x, y);
            }
        }
    },
    undo: function () {
        var content = tempFile.getUndoContent();
        var canvasSize = tempFile.getCanvasSize();
        if (content !== "") {
            if (_pat.readPattern(content)) {
                _pat.createCanvas(canvasSize.width, canvasSize.height);
                // display the pattern
                if (_pat.drawPattern()) {
                    // save current canvas info
                    _pat.saveCanvasOrigWidthHeight();
                    _pat.saveCanvasScaleOrigWidthHeight();
                    $("#redo").removeAttr('disabled');
                    ColorSelector.updateColorCounts();
                }
            }
        }
    },

    redo: function () {
        var content = tempFile.getRedoContent();
        var canvasSize = tempFile.getCanvasSize();
        if (content !== "") {
            if (_pat.readPattern(content)) {
                _pat.createCanvas(canvasSize.width, canvasSize.height);
                // display the pattern
                if (_pat.drawPattern()) {
                    // save current canvas info
                    _pat.saveCanvasOrigWidthHeight();
                    _pat.saveCanvasScaleOrigWidthHeight();
                    $("#undo").removeAttr('disabled');
                    ColorSelector.updateColorCounts();
                }
            }
        }
    },
    zoomin: function () {
        _pat.zoomInOutPattern(1);
        tempFile.save();
        $("#undo").removeAttr('disabled');
    },
    zoomout: function () {
        _pat.zoomInOutPattern(-1);
        tempFile.save();
        $("#undo").removeAttr('disabled');
    },
    cut: function () {
        $("#copy").removeAttr('disabled');
        $("#copy").attr('disabled', 'disabled');
        $("#cut").removeAttr('disabled');
        $("#cut").attr('disabled', 'disabled');
        $("#paste").removeAttr('disabled');
        cutBox.cut();
    },
    copy: function () {
        $("#copy").removeAttr('disabled');
        $("#copy").attr('disabled', 'disabled');
        $("#cut").removeAttr('disabled');
        $("#cut").attr('disabled', 'disabled');
        $("#paste").removeAttr('disabled');
        cutBox.copy();
    },
    paste: function () {
        $("#box").removeAttr('disabled');
        $("#copy").removeAttr('disabled');
        $("#cut").removeAttr('disabled');
        $("#box").attr('disabled', 'disabled');
        $("#copy").attr('disabled', 'disabled');
        $("#cut").attr('disabled', 'disabled');
        $("#stamps").removeAttr('disabled');
        $("#stamps").attr('disabled', 'disabled');
        $("#inserts").removeAttr('disabled');
        $("#inserts").attr('disabled', 'disabled');
        $("#borders").removeAttr('disabled');
        $("#borders").attr('disabled', 'disabled');
        cutBox.paste();
    },
    rotate: function () {

        // first time selected rotate removes the selection box
        // rotates and places the rotated  items in the move box
        if (selectionBox.mode === "dragboxend") {
            cutBox.copy();
            cutBox.rotate();
            cutBox.paste();
        }

        // second time rotate is selected the movebox displays
        // first set of rotated items
        else if (selectionBox.mode === "movebox") {
            cutBox.rotate();
            cutBox.paste();
        }
        else if (stamps.selectedStamp > -1) {
            stamps.rotateStampOnPattern();
        }
        else if (inserts.selectedInsert !== "") {
            inserts.rotateInsertOnPattern();
        }
        
    },
    picture: function () {
        camera.getPicture();
    }, 
    trace: function () {
        camera.getPicture();
        //trace.displayImageUriOnPatternTest();
    },
    cameras: function () {
        camera.capturePhotoEdit();
    },

    share: function () {
        share.sharePattern();
    }
};

