﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var importImage = {
    imageState: "",
    currentCanvasId: "",
    rawCanvasId: "imageCanvastb",
    mosaicCanvasId: "mosicCanvastb",
    quantizeCanvasId: "quantizeCanvastb",
    dragImage: false,
    colors: [],
    // pattern on pattern page top, left
    patOffset: { "top": 0, "left": 0 },

    // thumbnail on pattern page top, left
    canvasOffset: { "top": 0, "left": 0 },
    resizHandle: "",

    // borderWidth: 3,
    imageSize: { "width": 0, "height": 0 },
    btns: [],
    rows: 0,
    cols: 0,

    displayImageUriOnPattern: function (result) {
        // convert JSON string to JSON Object
        var thisResult = JSON.parse(result);

        // convert json_metadata JSON string to JSON Object 
        // debug code for browser
        //var metadata = JSON.parse(thisResult.json_metadata);

        var img = new Image();
        img.onload = function () {
            importImage.setupImageCanvas(this.naturalWidth, this.naturalHeight);
            var imageCanvas = $("#" + importImage.currentCanvasId);
            var canvas = imageCanvas[0];
            var ctx = canvas.getContext("2d");
            ctx.fillStyle = "white";
            ctx.drawImage(img, 0, 0, this.naturalWidth, this.naturalHeight);
            importImage.imageState = "rawImage";
            var thumbnail = $("#thumbnail");
            thumbnail.css('top', importImage.canvasOffset.top.toString() + "px");
            thumbnail.css('left', importImage.canvasOffset.left.toString() + "px");
        };
        img.src = thisResult.filename;
    },

    displayImageOnPattern: function (rgbdata, width, height, mosaicCtx) {
        if (rgbdata != null) {

            var targetCanvas = document.createElement('canvas');
            targetCanvas.id = importImage.quantizeCanvasId;
            targetCanvas.style.zIndex = 2;
            var width = targetCanvas.width = mosaicCtx.canvas.width;
            targetCanvas.height = mosaicCtx.canvas.height;
            var totalCols = 0;
            var context = targetCanvas.getContext('2d');
            context.fillStyle = "#FFFFFF";
            context.fillRect(1, 1, width, height);
            context.stroke();
            var r, g, b;
            var idx = 0;
            var row = 0;
            var col = 0;
            var sqrW = _pat.getSqrW();
            var sqrH = _pat.getSqrH();
            for (var i = 0; i < height; i++) {
                if (i % sqrH === 0) {
                    importImage.btns[row] = [];
                }
                for (var j = 0; j < width; j++) {
                    if (rgbdata[idx] !== undefined) {
                        r = rgbdata[idx][0];
                        g = rgbdata[idx][1];
                        b = rgbdata[idx][2];
                        context.fillStyle = "rgba(" + r + "," + g + "," + b + ", 1)";
                        context.fillRect(j, i, 1, 1);
                        idx++;
                    }

                    // should never go here
                    else {
                        context.fillStyle = "rgba(255,255,255, 1)";
                        context.fillRect(j, i, 1, 1);
                    }


                    if (i % sqrH === 0 && j % sqrW === 0) {
                        importImage.btns[row][col] = context.fillStyle;
                        col++;
                    }
                }
                if (i % sqrH === 0) {
                    row++;
                    totalCols = col - 1;
                    col = 0;
                }
            }

            importImage.rows = row - 1;
            importImage.cols = totalCols;
            context.stroke();
            var thumbnail = $("#thumbnail");
            thumbnail.append(targetCanvas);
            $("#" + importImage.currentCanvasId).hide();
            importImage.currentCanvasId = targetCanvas.id;
            importImage.imageSize.width = width;
            importImage.imageSize.height = height;
        }
    },

    drawBorder: function (context, width, height) {
        // draw blue bounding box
        context.fillStyle = "rgba(0, 0, 200, 0.5)";
        context.strokeStyle = "#1b7ec1";
        context.lineWidth = 3;
        context.rect(1, 1, width - 2, height - 2);
        context.stroke();
    },

    setGridOveryOffset: function () {
        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();

        var gridOverlay = $("#gridOverlay");
        gridOverlay.css('top', (top + patDivOffset.top) + "px");
        gridOverlay.css('left', (left + patDivOffset.left) + "px");
    },

    setupImageCanvasFromCanvas: function (iCanvas, meta) {
        importImage.initImageOffset();

        var thumbnail = $("#thumbnail");
        thumbnail.css('top', importImage.canvasOffset.top.toString() + "px");
        thumbnail.css('left', importImage.canvasOffset.left.toString() + "px");
        var gridOverlay = $("#gridOverlay");
        importImage.currentCanvasId = importImage.rawCanvasId;

        var imageCanvas = $(iCanvas);
        imageCanvas.attr("id", importImage.currentCanvasId);
        imageCanvas.css("z-index", 2);
        thumbnail.append(imageCanvas);
        var gridCanvas = $('<canvas id="gridCanvastb"  width="' + _pat.getWidth() + '" height="' + _pat.getHeight() + 'style="z-index:3"></canvas>');
        gridOverlay.append(gridCanvas);
        importImage.setGridOveryOffset();

        var width = imageCanvas.width();
        var height = imageCanvas.height();
        importImage.dragImage = true;
        // add handles to camera picture

        var handleud = $("<div id='camerahandleud' style='position:absolute; top:" + (height - 8) + "px; left:" + (width - 55) + "px;z-index:3' data-title='' data-theme='c'>" +
            "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleudImg' src='img/handleud.png' />" +
                "</div>");
        thumbnail.append(handleud);


        var handlelr = $("<div id='camerahandlelr' style='position:absolute; top:" + (height - 55) + "px;  left:" + (width - 8) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handlelrImg' src='img/handlelr.png' />" +
                        "</div>");
        thumbnail.append(handlelr);
        var handle = $("<div id='camerahandle' style='position:absolute;  top:" + (height - 20) + "px; left:" + (width - 20) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleImg' src='img/handle.png' />" +
                        "</div>");
        thumbnail.append(handle);
        importImage.displayGridOnImage(gridCanvas);
        buttonBar.displayNumOfColors(false);
        buttonBar.displayButtonBar(false);
        buttonBar.displayBackButton(false);
    },
    setupImageCanvas: function (width, height) {
        importImage.initImageOffset();

        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();

        var thumbnail = $("#thumbnail");
        thumbnail.css('top', importImage.canvasOffset.top.toString() + "px");
        thumbnail.css('left', importImage.canvasOffset.left.toString() + "px");
        var gridOverlay = $("#gridOverlay");

        importImage.currentCanvasId = importImage.rawCanvasId;
        var imageCanvas = $('<canvas id="' + importImage.currentCanvasId + '" style="z-index:2"></canvas>');
        thumbnail.append(imageCanvas);

        var gridCanvas = $('<canvas id="gridCanvastb"  width="' + _pat.getWidth() + '" height="' + _pat.getHeight() + 'style="z-index:3"></canvas>');
        gridOverlay.append(gridCanvas);
        importImage.setGridOveryOffset();

        var canvas = imageCanvas[0];
        canvas.width = width;
        canvas.height = height;
        imageCanvas.width(width);
        imageCanvas.height(height);

        importImage.dragImage = true;
        // add handles to camera picture

        var handleud = $("<div id='camerahandleud' style='position:absolute; top:" + (height - 8) + "px; left:" + (width - 55) + "px;z-index:3' data-title='' data-theme='c'>" +
            "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleudImg' src='img/handleud.png' />" +
                "</div>");
        thumbnail.append(handleud);


        var handlelr = $("<div id='camerahandlelr' style='position:absolute; top:" + (height - 55) + "px;  left:" + (width - 8) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handlelrImg' src='img/handlelr.png' />" +
                        "</div>");
        thumbnail.append(handlelr);
        var handle = $("<div id='camerahandle' style='position:absolute;  top:" + (height - 20) + "px; left:" + (width - 20) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleImg' src='img/handle.png' />" +
                        "</div>");
        thumbnail.append(handle);
        importImage.displayGridOnImage(gridCanvas);
        buttonBar.displayNumOfColors(false);
        buttonBar.displayButtonBar(false);
        buttonBar.displayBackButton(false);
    },
    initImageOffset: function () {
        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();
        importImage.canvasOffset.top = top + patDivOffset.top;
        importImage.canvasOffset.left = left + patDivOffset.left;
    },
    setImageOffset: function () {
        var thumbnail = $("#thumbnail");
        var thumbnailOffset = thumbnail.offset();
        importImage.canvasOffset.top = thumbnailOffset.top;
        importImage.canvasOffset.left = thumbnailOffset.left;
    },
    displayGridOnImage: function (gridCanvas) {
        var patCanvas = _pat.getCanvas();

        gridCanvas.width(patCanvas.width);
        gridCanvas.height(patCanvas.height);

        var rows = _pat.getRows();
        var cols = _pat.getCols();
        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        var grid = new Pattern(gridCanvas);
        grid.setCanvas(gridCanvas[0]);
        grid.setSqrW(sqrW);
        grid.setSqrH(sqrH);
        grid.setTopOffset(0);
        grid.setRows(rows);
        grid.setCols(cols);
        grid.setLeftOffset(0);
        grid.drawGrid(1);

    },
    cancelImport: function () {
        var handle = $("#camerahandleud");
        handle.hide();
        handle.remove();
        handle = $("#camerahandlelr");
        handle.hide();
        handle.remove();
        handle = $("#camerahandle");
        handle.hide();
        handle.remove();
    },

    resizeImage: function (deltaX, deltaY) {
        if (deltaX !== 0 || deltaY !== 0) {
            var imageCanvas = $("#" + importImage.currentCanvasId);
            var upHandle = $("#camerahandleud");
            var lrHandle = $("#camerahandlelr");
            var handle = $("#camerahandle");
            var upHandleOffset = upHandle.offset();
            var lrHandleOffset = lrHandle.offset();
            var handleOffset = handle.offset();

            var newWidth = imageCanvas.width() + deltaX;
            var newHeight = imageCanvas.height() + deltaY;

            lrHandle.css("left", newWidth - 8);
            lrHandle.css("top", newHeight - 55);

            upHandle.css("left", newWidth - 55);
            upHandle.css("top", newHeight - 8);

            handle.css("left", newWidth - 20)
            handle.css("top", newHeight - 20);

            if (importImage.resizHandle === "resizeBoth") {
                imageCanvas.width(newWidth);
                imageCanvas.height(newHeight);
            }
            else if (importImage.resizHandle === "resizeUpDown") {
                imageCanvas.height(newHeight);
            }
            else if (importImage.resizHandle === "resizeLeftRight") {
                imageCanvas.width(newWidth);
            }
        }
    },

    moveImage: function (deltaX, deltaY) {
        try {
            var sqrW = _pat.getSqrW();
            var sqrH = _pat.getSqrH();
            var x = Math.floor(deltaX / sqrW);
            x = x * sqrW;
            var y = Math.floor(deltaY / sqrH);
            y = y * sqrH;
            if (x !== 0 || y !== 0) {
                var thumbnailDiv = $("#thumbnail");
                var newTop = y + importImage.canvasOffset.top;
                var newLeft = x + importImage.canvasOffset.left;
                thumbnailDiv.css("top", newTop);
                thumbnailDiv.css("left", newLeft);
            }
        }
        catch (err) {
        }
    },
    mosaicImage: function () {
        var canvas = $("#" + importImage.currentCanvasId);
        var ctx = canvas[0].getContext("2d");
        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        var width = canvas.width();
        var height = canvas.height();
        importImage.tileCanvas(width, height, ctx, sqrW, sqrH);
        buttonBar.displayNumOfColors(true);
        buttonBar.setNumberOfColors(importImage.colors.length);
    },
    tileCanvas: function (targetWidth, targetHeight, context, sqrw, sqrh) {
        importImage.colors = [];

        var originalImageData = context.getImageData(0, 0, context.canvas.width, context.canvas.height);

        var targetCanvas = document.createElement('canvas');
        targetCanvas.id = importImage.mosaicCanvasId;
        targetCanvas.style.zIndex = 2;
        var width = targetCanvas.width = targetWidth;
        targetCanvas.height = targetHeight;

        var targetContext = targetCanvas.getContext('2d');
        var sx = context.canvas.width / targetWidth;
        var sy = context.canvas.height / targetHeight;

        var sqrWidth = (sqrw * sx) | 0;
        var sqrHeight = (sqrh * sy) | 0;
        var divX = Math.floor(targetWidth / sqrw) + 1;
        var divY = Math.floor(targetHeight / sqrh) + 1;

        for (var i = 0; i < divY; i++) {

            for (var j = 0; j < divX; j++) {
                var x = j * sqrWidth;
                var y = i * sqrHeight;
                var newX = j * sqrw;
                var newY = i * sqrh;
                var imageData = importImage.getImageData(originalImageData, context.canvas.width, x, y, sqrWidth, sqrHeight);
                var averageColor = importImage.getAverageColor(imageData);
                var color = 'rgba(' + averageColor.r + ',' + averageColor.g + ',' + averageColor.b + ',' + 1 + ')';

                if (importImage.colors.indexOf(color) < 0) {
                    importImage.colors.push(color);
                }
                targetContext.fillStyle = color;
                importImage.createMosaic(newX, newY, targetContext, sqrw, sqrh);
            }
        }
        var thumbnail = $("#thumbnail");
        thumbnail.append(targetCanvas);
        $("#" + importImage.currentCanvasId).hide();
        importImage.currentCanvasId = targetCanvas.id;
        importImage.rows = divY;
        importImage.cols = divX;
    },
    // targetCanvas is output
    // context is input
    tileCanvas2: function (targetWidth, targetHeight, context, sqrw, sqrh) {
        importImage.colors = [];
        var targetCanvas = document.createElement('canvas');
        targetCanvas.id = importImage.mosaicCanvasId;
        targetCanvas.style.zIndex = 2;
        var width = targetCanvas.width = context.canvas.width;
        targetCanvas.height = context.canvas.height;

        var targetContext = targetCanvas.getContext('2d');

        var originalImageData = context.getImageData(0, 0, context.canvas.width, context.canvas.height);
        var divX = Math.floor(targetWidth / sqrw) + 1;
        var divY = Math.floor(targetHeight / sqrh) + 1;
        for (var i = 0; i < divY; i++) {
            for (var j = 0; j < divX; j++) {
                var x = j * sqrw;
                y = i * sqrh;
                var imageData = importImage.getImageData(originalImageData, context.canvas.width, x, y, sqrw, sqrh);
                var averageColor = importImage.getAverageColor(imageData);
                var color = 'rgba(' + averageColor.r + ',' + averageColor.g + ',' + averageColor.b + ',' + 1 + ')';

                if (importImage.colors.indexOf(color) < 0) {
                    importImage.colors.push(color);
                }
                targetContext.fillStyle = color;
                importImage.createMosaic(x, y, targetContext, sqrw, sqrh);
            }
        }
        var thumbnail = $("#thumbnail");
        thumbnail.append(targetCanvas);
        $("#" + importImage.currentCanvasId).hide();
        importImage.currentCanvasId = targetCanvas.id;
    },
    getImageData: function (originalImageData, canvasWidth, startX, startY, sqrwidth, sqrheight) {
        var data = [];
        var tileWidth = sqrwidth;
        var tileHeight = sqrheight;
        for (var x = startX; x < (startX + tileWidth); x++) {
            var xPos = x * 4;
            for (var y = startY; y < (startY + tileHeight); y++) {
                var yPos = y * canvasWidth * 4;
                data.push(
                    originalImageData.data[xPos + yPos + 0],
                    originalImageData.data[xPos + yPos + 1],
                    originalImageData.data[xPos + yPos + 2],
                    originalImageData.data[xPos + yPos + 3]
                );
            }
        }
        return data;
    },
    getAverageColor: function (data) {
        var i = -4,
            pixelInterval = 5,
            count = 0,
            rgb = {
                r: 0,
                g: 0,
                b: 0
            },
            length = data.length;

        while ((i += pixelInterval * 4) < length) {
            count++;
            rgb.r += data[i];
            rgb.g += data[i + 1];
            rgb.b += data[i + 2];
        }

        // floor the average values to give correct rgb values
        rgb.r = Math.floor(rgb.r / count);
        rgb.g = Math.floor(rgb.g / count);
        rgb.b = Math.floor(rgb.b / count);

        return rgb;
    },
    createMosaic: function (x, y, context, sqrw, sqrh) {
        var tileWidth = sqrw;
        var tileHeight = sqrh;
        var height = tileHeight;
        var width = tileWidth;
        context.beginPath();
        context.fillRect(x, y, width, height);
        context.closePath();
        context.stroke();
    },
    quantizeCanvas: function (numOfColors, context) {
        var imgData = context.getImageData(0, 0, context.canvas.width, context.canvas.height);
        var pixels = camera.getImagePixels(imgData);
        var newPixels = camera.reduceColors(numOfColors, pixels);
        importImage.displayImageOnPattern(newPixels, context.canvas.width, context.canvas.height, context);
    },


    // remove import image drag box
    removeImageOnPattern: function () {
        // remove the image on canvas        
        $("#" + importImage.currentCanvasId).hide();
        $("#" + importImage.currentCanvasId).remove();
        $("#" + importImage.rawCanvasId).hide();
        $("#" + importImage.rawCanvasId).remove();
        $("#" + importImage.mosaicCanvasId).hide();
        $("#" + importImage.mosaicCanvasId).remove();
        $("#" + importImage.quantizeCanvasId).hide();
        $("#" + importImage.quantizeCanvasId).remove();

        importImage.currentCanvasId = "";
        var thumbnailDiv = $("#thumbnail");
        thumbnailDiv.offset({ top: 0, left: 0 });

        var gridCanvastb = $("#gridCanvastb");
        gridCanvastb.hide();
        gridCanvastb.remove();
        var gridOverlay = $("#gridOverlay");
        gridOverlay.offset({ top: 0, left: 0 });

        importImage.dragImage = false;

        var camerahandle = $("#camerahandleud");
        camerahandle.hide();
        camerahandle.remove();
        camerahandle = $("#camerahandlelr");
        camerahandle.hide();
        camerahandle.remove();
        camerahandle = $("#camerahandle");
        camerahandle.hide();
        camerahandle.remove();
    },

    nextBtnClick: function () {
        buttonBar.displayPleaseWait(true);
        setTimeout(function () { importImage.doNextButton(); }, 1000);
    },
    doNextButton: function () {
        //first
        if (importImage.imageState === "rawImage") {
            importImage.mosaicImage();
            buttonBar.displayBackButton(true);
            importImage.displayResizeHandles(false);
            importImage.imageState = "mosaicImage";
            importImage.initImageOffset();
            importImage.setGridOveryOffset();
        }

        // second
        else if (importImage.imageState === "mosaicImage") {
            var numOfColors = buttonBar.getNumberOfColors();
            if (numOfColors > 1) {
                var imageCanvas = $("#" + importImage.currentCanvasId);
                var canvas = imageCanvas[0];
                var ctx = canvas.getContext("2d");
                importImage.quantizeCanvas(numOfColors, ctx);
                buttonBar.displayNumOfColors(false);
                importImage.imageState = "quantizeImage";
                importImage.initImageOffset();
                importImage.setGridOveryOffset();
            }
        }
        // last
        else if (importImage.imageState === "quantizeImage") {
            importImage.insertImageOnPattern();
            importImage.removeImageOnPattern();
            buttonBar.displayButtonBar(true);
            buttonBar.displayBackButton(false);
            importImage.imageState = "";
            editor.modified = true;
            editor.setSelected("");
            tempFile.save();
            $("#undo").removeAttr('disabled');
            importImage.initImageOffset();
            importImage.setGridOveryOffset();
        }
        buttonBar.displayPleaseWait(false);
    },

    //    nextBtnClick: function () {
    //        // first
    //        if (importImage.imageState === "rawImage") {
    //            importImage.mosaicImage();
    //            buttonBar.displayBackButton(true);
    //            importImage.displayResizeHandles(false);
    //            importImage.imageState = "mosaicImage";
    //            importImage.initImageOffset();
    //            importImage.setGridOveryOffset();
    //        }

    //        // second
    //        else if (importImage.imageState === "mosaicImage") {
    //            var numOfColors = buttonBar.getNumberOfColors();
    //            if (numOfColors > 1) {
    //                var imageCanvas = $("#" + importImage.currentCanvasId);
    //                var canvas = imageCanvas[0];
    //                var ctx = canvas.getContext("2d");
    //                importImage.quantizeCanvas(numOfColors, ctx);
    //                buttonBar.displayNumOfColors(false);
    //                importImage.imageState = "quantizeImage";
    //                importImage.initImageOffset();
    //                importImage.setGridOveryOffset();
    //            }
    //        }
    //        // last
    //        else if (importImage.imageState === "quantizeImage") {
    //            importImage.insertImageOnPattern();
    //            importImage.removeImageOnPattern();
    //            buttonBar.displayButtonBar(true);
    //            buttonBar.displayBackButton(false);
    //            importImage.imageState = "";
    //            editor.modified = true;
    //            editor.setSelected("");
    //            tempFile.save();
    //            $("#undo").removeAttr('disabled');
    //            importImage.initImageOffset();
    //            importImage.setGridOveryOffset();
    //        }
    //    },
    backBtnClick: function () {
        if (importImage.imageState === "mosaicImage") {
            $("#" + importImage.rawCanvasId).show();
            $("#" + importImage.mosaicCanvasId).hide();
            $("#" + importImage.mosaicCanvasId).remove();
            importImage.currentCanvasId = importImage.rawCanvasId;
            buttonBar.displayNumOfColors(false);
            buttonBar.displayBackButton(false);
            importImage.displayResizeHandles(true);
            importImage.imageState = "rawImage";
            importImage.initImageOffset();
            importImage.setGridOveryOffset();
        }
        else if (importImage.imageState === "quantizeImage") {
            $("#" + importImage.mosaicCanvasId).show();
            $("#" + importImage.quantizeCanvasId).hide();
            $("#" + importImage.quantizeCanvasId).remove();
            buttonBar.displayNumOfColors(true);
            importImage.imageState = "mosaicImage";
            importImage.currentCanvasId = importImage.mosaicCanvasId;
            importImage.initImageOffset();
            importImage.setGridOveryOffset();
        }
    },
    cancelBtnClick: function () {
        importImage.removeImageOnPattern();
        buttonBar.displayButtonBar(true);
        editor.setSelected("");
    },
    displayResizeHandles: function (display) {
        var updown = $("#camerahandleud");
        var leftright = $("#camerahandlelr");
        var both = $("#camerahandle");
        if (display) {
            updown.show();
            leftright.show();
            both.show();
        }
        else {
            updown.hide();
            leftright.hide();
            both.hide();
        }
    },
    insertImageOnPattern: function () {
        var thumbnailDiv = $("#thumbnail");
        var offset = thumbnailDiv.offset();

        var patDivOffset = $("#patternPage").offset();
        var startRow = Math.floor((offset.top - patDivOffset.top - _pat.getTopOffset()) / _pat.getSqrW());
        var startCol = Math.floor((offset.left - patDivOffset.left - _pat.getLeftOffset()) / _pat.getSqrW());
        _pat.insertBtns(startRow, startCol, importImage.btns, importImage.rows, importImage.cols);
    },

    scaleSize: function (maxW, maxH, currW, currH) {
        var ratio = currH / currW;
        if (currW >= maxW && ratio <= 1) {
            currW = maxW;
            currH = currW * ratio;
        }
        else if (currH >= maxH) {
            currH = maxH;
            currW = currH / ratio;
        }
        return { "width": currW, "height": currH };
    }
};