// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved


// you have 3 folders
// www/data you can use ajax to read from but not write too
// application documents folder that gets created during installation, so you cannot preload any files in it
// file system crochetpatterns folder, you cannot preload this folder either

// have all the patterns and .png files reside in the www/data folder
// when they purchase a pattern write it to the crochetpatterns folder. that way they can copy it to there pc

// create pattern, back button to save, display created pattern, back button
var app = {
    patternLeft: 80,
    pictureSource: null,
    destinationType: null,

    undoState: 'disabled',
    redoState: 'disabled',

    createNew: false,
    createAllowed: false,

    patFolder: 'loompatterns',

    content: '',

    // list of all the not bought patterns
    patNotBoughtFiles: [],
    notBoughtCnt: 0,

    // list of all the found bought patterns
    patBoughtFiles: [],
    boughtCnt: 0,

    // list of all the free patterns
    patFreeFiles: [],
    freeCnt: 0,

    // save fileSytem to use to read next file
    fileSystem: null,

    // current page being displayed
    currentPage: '',

    // currently displayed pattern position (used by mouseEvents.js)
    patPageOffset: { 'left': 0, 'top': 0 },

    // current mouse position (used by mouseEvents.js
    mouse: {},

    patfileName2Id: function (patfilename) {
        return patfilename.replace(/[^a-zA-Z0-9]/g, '');
    },

    ///////////////Read Crochet Pattern Files/////////////////////////////////
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    addEventListener: function () {
        // when device is ready call initApp
        document.addEventListener('deviceready', this.initApp, false);

        window.addEventListener('orientationchange', function () {
            inserts.setSize();

            stamps.setCanvasSize(stamps.size);
            stamps.resetPageNumber();
            stamps.redisplayStamps();
            stamps.displayNextPrevBtns();
            borders.setCanvasSize();
            borders.resetPageNumber();
            borders.redisplayBorders();

        });
    },

    // intialize Filet Crochet Pattern Creator app
    initApp: function () {
        $(".ui-dialog a[data-icon='delete']").remove();

        // disable phone the back button
        document.addEventListener("backbutton", app.onBackKeyPress, false);

        var createPat = $("#createpat");
        var buyCreatePat = $("#buycreatepat");
        buyCreatePat.hide();
        createPat.hide();
        app.pictureSource = navigator.camera.PictureSourceType;
        app.destinationType = navigator.camera.DestinationType;

        app.enableCreateButton(false);

        //comment out below for debugging
        //read the crochet settings file and store in memory
        LoomPatternDef.getLoomPatternDef();
        buy.getEnableCreateFile();

        // uncomment out to test googlePay directly
        //googlePay.restorePurchase();

        // safe guard 
        googlePay.restorePurchaseNoMsg();

        // uncomment out to bypass google pay
        //app.enableCreateButton(true);

        // display list of free patterns
        app.createFreePatFilesList(myPat.freePatList);
        inserts.createList();
        borders.initPage();
        delPat.initDialog();

        ColorSelector.createColorSelector();
        buttonBar.displayPleaseWait(false);
        buttonBar.displayImportBar(false);
        var iconbar = $('#iconbar');
        iconbar.hide();

        // allow zoom on diagram
        var diagramDiv = $("#diagramDiv");
        diagramDiv.bind("touchstart", diagramTouchStart);
        diagramDiv.bind("touchend", diagramTouchEnd);
        diagramDiv.bind("touchmove", diagramTouchMove);
    },

    // calculate the pattern div top location
    appGetPatternTop: function () {
        try {
            var iconbar = $("#iconbar");
            var iconbarHeight = iconbar.length > 0 ? iconbar[0].clientHeight : 0;

            var readonlyiconbar = $("#readonlyiconbar");
            var readonlyiconbarHeight = readonlyiconbar.length > 0 ? readonlyiconbar[0].clientHeight : 0;
            var navbar = $("#navbar");
            var navbarHeight = navbar[0].clientHeight;

            var top = iconbarHeight + readonlyiconbarHeight + navbarHeight + 10;
            return top;
        }
        catch (err) {
            return 175;
        }
    },

    // create list of free patterns
    createFreePatFilesList: function (entries) {

        var i;
        var j = 0;
        app.patFreeFiles = [];
        var files = entries.files;

        // for each pattern defined in the list
        // create an object for the pattern and add it to the local list
        for (i = 0; i < files.length; i++) {
            if (files[i].filename.indexOf(".cht") != -1) {

                // patterns image file xxxxpattern.png
                var name = files[i].filename.replace('.cht', 'pattern.png');

                // uri to pattern image file
                var uri = "data/" + name;

                // pattern file name xxxx.cht
                var patFilename = files[i].filename;

                app.patFreeFiles[j] = { 'uri': uri, 'patfilename': patFilename };
                j++;
            }
        }

        // read all the free pattern files in the list
        app.displayFreePatList(app.patFreeFiles);
    },

    // build the list of not bought patterns
    // then read each not bought pattern to get the title of the pattern and place into the list
    displayFreePatList: function (patFreeFiles) {

        var patList = $('#patlist');
        for (var i = 0; i < patFreeFiles.length; i++) {
            var pat = app.patfileName2Id(patFreeFiles[i].patfilename); // patFreeFiles[i].patfilename.replace(/[^a-zA-Z0-9]/g, '');
            var justName = patFreeFiles[i].patfilename.replace('.cht', '');

            // create html elements for the pattern             
            var str = '<li  id="id_f_' + pat + '" data-name="' + patFreeFiles[i].patfilename + '" style="padding:0;margin:0;">' +
                    '<a style="padding:0;margin:0;">' +
                    '<table><tr><td><div style="height:60px;overflow-y:scroll;">' +
                    '<img id="img_f_' + pat + '" style="margin-left:5px;width:60px;" onclick="app.displayPatternImage(\'' + justName + 'pattern\', \'f_' + pat + '\');return false;" ' +
                    'src="' + patFreeFiles[i].uri + '" />' +
                    '</div></td><td>' +

                    '<div style="padding-left:20px;" onclick="location.href=\'#pattern-page?pat=' + encodeURIComponent(patFreeFiles[i].patfilename) + '\'">' +
                    '<h3><i>Free!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</i></h3>' +
                    '<h3 class="pattitle" id="f_' + pat + '"></h3>' +
                    '<p class="topic">' + patFreeFiles[i].patfilename + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</p>' +
                    '</div>' +
                    '</td></tr></table>' +
                    '</a>' +
                    '<a style="padding:0;margin:0;" id="delete_' + justName.replace(/[^a-zA-Z0-9]/g, '') + '" href="#" data-role="button" data-icon="lock" data-iconpos="notext">Delete</a>' +
                    '</li>';

            var li = $(str);
            patList.append(li);
        }
        patList.listview('refresh');

        // get list of bought patterns and create list of bought patterns
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, app.fsReadBoughtPatFolder, app.boughtListFail);
    },

    // bought patterns are in crochetpatterns folder so that user can move them to PC
    fsReadBoughtPatFolder: function (fileSystem) {
        fileSystem.root.getDirectory(app.patFolder, { create: true, exclusive: false }, app.deReadBoughtPatFolder, app.boughtListFail);
    },

    // read crochetpatterns folder
    deReadBoughtPatFolder: function (dirEntry) {

        // Get a directory reader
        var patDirReader = dirEntry.createReader();

        // Get a list of all the entries in the directory
        patDirReader.readEntries(app.createBoughtPatFilesList, app.boughtListFail);
    },

    // create list of all bought patterns found
    createBoughtPatFilesList: function (entries) {
        var i;
        var j = 0;
        app.patBoughtFiles = [];
        for (i = 0; i < entries.length; i++) {
            if (entries[i].name.toLowerCase().indexOf(".cht") != -1) {

                // patterns image file xxxxpattern.png
                var imageName = entries[i].name.replace('.cht', 'pattern.png');

                // uri to pattern image file (the image file is stored in wwww/data folder)
                var uri = "data/" + imageName;

                // uri to pattern file  file:///storage/emulated/0/CrochetPatterns/Pat63a.cht
                var patFileUri = entries[i].toURI();

                // pattern file name xxxx.cht
                var patFilename = entries[i].name;

                app.patBoughtFiles[j] = { 'uri': uri, 'imagefilename': imageName, 'patfileuri': patFileUri, 'patfilename': patFilename };
                j++;
            }
        }
        for (i = 0; i < entries.length; i++) {
            if (entries[i].name.toLowerCase().indexOf(".png") != -1) {
                for (k = 0; k < j; k++) {
                    if (app.patBoughtFiles[k].imagefilename.toLowerCase() == entries[i].name.toLowerCase()) {
                        app.patBoughtFiles[k].uri = entries[i].toURL() + "?t=";
                        break;
                    }
                }
            }
        }
        app.displayBoughtPatList(app.patBoughtFiles);
    },

    // insert the newly created pattern into the list
    insertCreatedPattern: function () {

        // C2015927182521.cht
        var patFilename = save.fileName;

        // uri to pattern file
        // CrochetPatterns/C2015927182521.cht
        var patFileUri = save.patFileUri;

        // pattern title
        var title = save.title.replace(/_/g, " ");

        var patList = $('#patlist');
        if (patFilename.indexOf(".cht") != -1) {

            // patterns image file C2015927182521pattern.png
            var imageName = patFilename.replace('.cht', 'pattern.png');

            // patnamecht
            var pat = app.patfileName2Id(patFilename);

            var li = $("#id_b_" + pat);
            if (li.length > 0) {
                var img = $("#img_b_" + pat);
                var src = img.attr("src");
                src = src.substring(0, src.indexOf("?")) + "?" + new Date().getTime();
                var src = img.attr("src", src);
            }
            else {

                // uri to pattern image file which is stored in same folder as created pattern
                // CrochetPatterns/C2015927182521pattern.png?t=
                var uri = patFileUri.replace('.cht', 'pattern.png') + "?t=";

                // pattern file name xxxx.cht
                var len = app.patBoughtFiles.length;
                app.patBoughtFiles[len] = { 'uri': uri, 'imagefilename': imageName, 'patfileuri': patFileUri, 'patfilename': patFilename };

                var justName = patFilename.replace('.cht', '');

                // create html elements for the pattern
                var str = '<li id="id_b_' + pat + '" data-name="' + patFilename + '" style="padding:0;margin:0;">' +
                  '<a style="padding:0;margin:0;"><table><tr><td>' +
                  '<div style="height:60px;width:60px;overflow-y:scroll;">' +
                  '<img id="img_b_' + pat + '" style="margin-left:5px;width:60px;" onclick="app.displayPatternImage(\'' + justName + 'pattern\', \'b_' + pat + '\');" ';

                if (app.patBoughtFiles[len].uri[app.patBoughtFiles[len].uri.length - 1] == "=") {
                    str += 'src="' + app.patBoughtFiles[len].uri + new Date().getTime() + '" />';
                }
                else {
                    str += 'src="' + app.patBoughtFiles[len].uri + '" />';
                }

                str +=
            '</div></td><td><div style="padding-left:20px" onclick="location.href=\'#pattern-page?pat=' + encodeURIComponent(app.patBoughtFiles[len].patfilename) + '\'">' +
                  '<h3 class="pattitle" id="b_' + pat + '" data-iseditable="yes"></h3>' +
                  '<p class="topic">' + app.patBoughtFiles[len].patfilename + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</p>' +
                  '</div></td></tr></table>' +
                  '</a><a id="delete_' + app.patfileName2Id(justName) + '" href="#" onclick="delPat.deletePattern(this,\'' + app.patBoughtFiles[len].patfilename + '\');" data-role="button" data-icon="delete" data-iconpos="notext">Delete</a> </li>';

                var li = $(str);

                var list = $('li');
                var boughtFound = "";
                var createdFound = "";
                var freeFound = "";
                for (var i = 0; i < list.length; i++) {
                    var id = $(list[i]).attr("id");
                    if (id !== undefined) {

                        if (id.indexOf("id_b_") >= 0) {
                            var h3Id = id.substring(3);
                            var h3 = $("#" + h3Id);
                            var isEditable = h3.data("iseditable");

                            // find first created pattern
                            if (isEditable === "yes") {
                                createdFound = id;
                                break;
                            }

                            // find last bought pattern
                            // only need this is no created patterns found
                            else {
                                boughtFound = id;
                            }
                        }

                        // find last free pattern
                        // only need this if no created patterns and no bought patterns found
                        else if (id.indexOf("id_f_") >= 0) {
                            freeFound = id;
                        }
                    }
                }

                if (createdFound !== "") {
                    $("#" + createdFound).before(li);
                }
                else if (boughtFound !== "") {
                    $("#" + boughtFound).after(li);
                }
                else if (freeFound !== "") {
                    $("#" + freeFound).after(li);
                }
            }

            // update the title
            var h3 = $('#b_' + pat);

            // h3 found, add the title
            if (h3 !== undefined) {
                h3.text(title);
            }
            patList.listview('refresh');
        }
    },

    // build the list of bought patterns
    // then read each bought pattern to get the title of the pattern and place into the list
    displayBoughtPatList: function (patBoughtFiles) {
        var patList = $('#patlist');
        for (var i = 0; i < patBoughtFiles.length; i++) {
            var fullname = patBoughtFiles[i].patfilename;
            var pat = app.patfileName2Id(fullname); //fullname.replace(/[^a-zA-Z0-9]/g, '');
            var justName = fullname.replace('.cht', '');

            // create html elements for the pattern
            var str = '<li id="id_b_' + pat + '" data-name="' + patBoughtFiles[i].patfilename + '" style="padding:0;margin:0;">' +
                  '<a style="padding:0;margin:0;"><table><tr><td><div style="height:60px;overflow-y:scroll;"><img id="img_b_' + pat + '" style="margin-left:5px;width:60px;" onclick="app.displayPatternImage(\'' + justName + 'pattern\', \'b_' + pat + '\');" ';
            if (patBoughtFiles[i].uri[patBoughtFiles[i].uri.length - 1] == "=")
                str += 'src="' + patBoughtFiles[i].uri + new Date().getTime() + '" />';
            else
                str += 'src="' + patBoughtFiles[i].uri + '" />';
            str +=
            '</div></td><td><div style="padding-left:20px" onclick="location.href=\'#pattern-page?pat=' + encodeURIComponent(patBoughtFiles[i].patfilename) + '\'">' +
                  '<h3 class="pattitle" id="b_' + pat + '"></h3>' +
                  '<p class="topic">' + patBoughtFiles[i].patfilename + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</p>' +
                  '</div></td></tr></table>' +
                  '</a><a id="delete_' + app.patfileName2Id(justName) + '" href="#" onclick="delPat.deletePattern(this,\'' + patBoughtFiles[i].patfilename + '\');" data-role="button" data-icon="delete" data-iconpos="notext">Delete</a> </li>';

            var li = $(str);
            patList.append(li);
        }

        // NOTE: you need to call below even if there are no user pattern becaue it initializes app.filesystem
        // read each bought pattern file to get the title and add the title into the list
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, app.fsReadBoughtPatterns, app.boughtListFail);
        
        patList.listview('refresh');
    },

    // get bought pattern file
    fsReadBoughtPatterns: function (fileSystem) {

        // read one pattern file at a time
        // save fileSytem to use to read next file
        app.fileSystem = fileSystem;

        // keep track of the number of files read 
        app.boughtCnt = 0;
        fileSystem.root.getFile(app.patFolder + '/' + app.patBoughtFiles[0].patfilename, null, app.feReadBoughtPat, app.boughtPatFail);
    },

    // read bought pattern file
    feReadBoughtPat: function (fileEntry) {
        fileEntry.file(app.readBoughtPatFile, app.boughtPatFail);
    },

    // read bought pattern file
    readBoughtPatFile: function (file) {

        var reader = new FileReader();
        var filename = file.name;

        reader.onloadend = function (evt) {
            // if success
            if (evt.target.result) {
                // extract the title and display it
                app.displayPatternInfo(filename, evt.target.result, "b_");
            }
            else {
                alert('Error: could not read pattern file:' + filename);
            }
            app.boughtCnt++;

            // if more files to process
            if (app.boughtCnt < app.patBoughtFiles.length) {

                // don't create it if it does not exist                    
                app.fileSystem.root.getFile(app.patFolder + '/' + app.patBoughtFiles[app.boughtCnt].patfilename, null, app.feReadBoughtPat, app.boughtPatFail);
            }

            // else read them all
            else {

                var patList = $('#patlist');
                patList.listview('refresh');

                // get all the not bought pattern files
                app.createNotBoughtPatFilesList(myPat.completePatList);
            }
        };
        reader.readAsText(file);
    },

    // create list of all not bought patterns found
    createNotBoughtPatFilesList: function (entries) {
        var i;
        var j = 0;
        app.patNotBoughtFiles = [];
        var files = entries.files;
        for (i = 0; i < files.length; i++) {
            if (files[i].filename.indexOf(".cht") != -1) {

                // patterns image file xxxxpattern.png
                var name = files[i].filename.replace('.cht', 'pattern.png');

                // uri to pattern image file
                var uri = "data/" + name;

                // pattern file name xxxx.cht
                var patFilename = files[i].filename;

                app.patNotBoughtFiles[j] = { 'uri': uri, 'patfilename': patFilename };
                j++;
            }
        }

        // read all the not bought pattern files in the list
        app.displayNotBoughtPatList(app.patNotBoughtFiles);
    },

    // build the list of not bought patterns
    // then read each not bought pattern to get the title of the pattern and place into the list
    displayNotBoughtPatList: function (patNotBoughtFiles) {

        var purchased = false;
        var patList = $('#patlist');

        for (var i = 0; i < patNotBoughtFiles.length; i++) {

            //var pat = patNotBoughtFiles[i].patfilename.replace('.', '');

            var pat = app.patfileName2Id(patNotBoughtFiles[i].patfilename); // patNotBoughtFiles[i].patfilename.replace(/[^a-zA-Z0-9]/g, '');
            var justName = patNotBoughtFiles[i].patfilename.replace('.cht', '');
            var str = "";
            var bought = $('#id_b_' + pat);

            // if user has not bought this pattern
            // if bought then already in list with id of id_b_xxxxcht
            if (bought === undefined || bought === null || bought.length === 0) {

                // create html elements for the pattern
                // include a button to purchase the pattern
                str = '<li style="margin:0px;padding:0px" id="id_n_' + pat + '" data-name="' + patNotBoughtFiles[i].patfilename + '">' +
                  '<a><table><tr><td><div style="height:60px;overflow-y:scroll;"><img id="img_n_' + pat + '"style="margin-left: 5px;width:60px;" onclick="app.displayPatternImage(\'' + justName + 'pattern\', \'n_' + pat + '\');" ' +
                  'src="' + patNotBoughtFiles[i].uri + '" />' +
                  '</div></td><td><div style="padding-left:20px">' +
                  '<h3 id="n_' + pat + '" style="margin:0px;padding:0px"></h3>' +
                  '<p class="topic" style="margin:0px;padding:0px">' + patNotBoughtFiles[i].patfilename + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</p>' +
                  '<p class="topic" style="margin:0px;padding:0px">' +
                           '<button id="buy_' + i + '" onclick="paypal.createPatternPayment(this);"><b>Buy Now! $.99</b></button></p>' +
                   '</div>' +
                    '</td></tr></table>' +
                           '</a><a id="buy2_' + i + '" href="#" onclick="paypal.createPatternPayment(this);" data-role="button" data-icon="lock" data-iconpos="notext"">Delete</a> </li>';

                var li = $(str);
                patList.append(li);
            }
        }

        // get all the free pattern files
        myPat.getAllFreePatFiles();
    },


    //////////////////////////////////////////////////////////

    // read content of pattern file (.cht) and extract the title
    displayPatternInfo: function (patFilename, content, bNF) {
        try {

            var lines = content.split(/\r\n|\r|\n/g);
            if (lines.length > 0) {

                var line = lines[0];
                var r = line.substring(0, line.indexOf(' '));
                line = line.substring(line.indexOf(' ') + 1);
                var c = line.substring(0, line.indexOf(' '));
                line = line.substring(line.indexOf(' ') + 1);
                var title = '';
                if (line.indexOf(' ') > 0)
                    title = line.substring(0, line.indexOf(' '));
                else
                    title = line;

                // extract the title
                title = title.replace(/_/g, " ");
                title = title.substring(title.toLocaleLowerCase().indexOf("title"));
                title = title.replace('Title:', '');

                // h3 id will be b_xxxxcht or n_xxxxcht or f_xxxxcht
                // where b = bought, n= not bought, f = free
                var pat = app.patfileName2Id(patFilename); // patFilename.replace(/[^a-zA-Z0-9]/g, '');

                var editable = false;
                var idx = parseInt(r) + 1;
                if (lines[idx] !== undefined) {
                    line = lines[idx].toLowerCase();
                    if (line.indexOf('copyright') < 0) {
                        editable = true;
                    }
                    idx++;
                }

                var h3 = $('#' + bNF + pat);

                // h3 found, add the title
                if (h3 !== undefined) {
                    h3.text(title);
                    // if user created this pattern then EDITABLE YES is at the bottom of the file
                    if (editable)
                        h3.data('iseditable', 'yes');
                    else
                        h3.data('iseditable', 'no');
                }
                // else not found. Should never get here
                else {
                    alert('#' + bNF + pat + " not found.");
                }
            }
        }
        catch (e) {
            alert(e.message);
        }
    },

    displayPatternImage: function (img, id) {
        var title = $("#" + id).text();
        var isEditable = $('#' + id).data("iseditable");
        var full = (id.substring(0, 2) === "f_" || id.substring(0, 2) === "b_") ? "yes" : "no";

        var imgUrl = $("#img_" + id).attr("src");
        if (imgUrl.indexOf("?t=") > 0) {
            imgUrl = imgUrl.substring(0, imgUrl.indexOf("?t="));
        }
        var uri = "#image-page?img=" + img + "&full=" + full + "&title=" + encodeURIComponent(title) + "&isEditable=" + isEditable + "&url=" + encodeURIComponent(imgUrl);
        location.href = uri;
    },

    // failed to read not bought pattern
    notBoughtPatFail: function (error) {

        // if not finished processing all bought patterns in list
        // then process the next one
        app.notBoughtCnt++;
        if (app.notBoughtCnt < app.patNotBoughtFiles.length) {
            app.fileSystem.root.getFile(app.patFolder + '/' + app.patNotBoughtFiles[app.notBoughtCnt].patfilename, null, app.feReadCrochetPat, app.notBoughtPatFail);
        }

        // else refresh the list
        else {
            var patList = $('#patlist');
            patList.listview('refresh');
        }

        // display error message
        app.fail(error);
    },

    // failed to read bought pattern
    boughtPatFail: function (error) {

        // if not finished processing all bought patterns in list
        // then process the next one
        app.boughtCnt++;
        if (app.notBoughtCnt < app.patNotBoughtFiles.length) {
            app.fileSystem.root.getFile(app.patFolder + '/' + app.patNotBoughtFiles[app.notBoughtCnt].patfilename, null, app.feReadCrochetPat, app.boughtPatFail);
        }
        // else refresh the list
        else {
            var patList = $('#patlist');
            patList.listview('refresh');

            // start processing not bought pattern files
            app.createNotBoughtPatFilesList(myPat.completePatList);
        }
        app.fail(error);
    },

    // failed to get list of bought patterns
    boughtListFail: function (error) {
        // user may not have bought any yet
        // move on to get not bought patterns
        app.createNotBoughtPatFilesList(myPat.completePatList);
    },

    // display failure read/write message to user
    fail: function (error) {
        var msg = app.getFileErrorCode(error);
        delPat.deleteFilename = '';
        alert('Error: ' + msg);
    },


    // delete an item from the list
    deletePattern: function (patternName) {

        var id = "id_" + app.patfileName2Id(patternName);
        var li = $("#" + id);
        li.remove();
        var patList = $('#patlist');
        patList.listview('refresh');
    },

    // Read a pattern to display the pattern on the pattern Page
    // user selected a pattern to display
    showPattern: function (patternName) {
        if (patternName !== undefined && patternName.length > 0) {
            var pat = app.patfileName2Id(patternName); // patternName.replace(/[^a-zA-Z0-9]/g, '');
            var h3 = $('#f_' + pat);
            var iconbar = $('#iconbar');
            var readonlyiconbar = $('#readonlyiconbar');

            // if this is a free pattern
            if (h3 !== undefined && h3.length > 0) {

                iconbar.hide();
                readonlyiconbar.show();
                // read contents of pattern file
                app.readFreePattern(patternName);

                // test code start for edit while using browser
                //                patternPage.css('top', '135px');
                //                iconbar.show();
                //                save.fileName = patternName;
                // end test code
            }
            // else user bought this pattern or created it
            else {

                h3 = $('#b_' + pat);

                // if bought pattern
                if (h3 !== undefined && h3.length > 0) {

                    var editable = h3.data('iseditable');

                    // user created this pattern and purchased create 
                    if (editable === "yes" && app.createAllowed) {
                        iconbar.show();
                        readonlyiconbar.hide();
                        save.fileName = patternName;
                    }

                    // user bought this pattern
                    else {
                        iconbar.hide();
                        readonlyiconbar.show();
                    }
                }

                // read the contents of the pattern file
                app.readPattern(patternName);
            }
        }
    },

    showImage: function (imageName, title, full, isEditable, url) {
        if (imageName !== undefined && imageName.length > 0) {
            var newImg = new Image();

            var patternImage = $('#patternImage');
            if (isEditable) {
                newImg.src = url;
                patternImage.attr("src", url);
            }
            else {
                newImg.src = "data/" + imageName + ".png";
                patternImage.attr("src", "data/" + imageName + ".png");
            }

            var height = newImg.height;
            if (height == 0) {
                height = 300;
            }
            if (full) {
                patternImage.height(height);
            }
            else {
                patternImage.height(3 * (height / 5));
            }
        }
        if (title !== undefined && title.length > 0) {
            $('#patTitle').text(title);
        }
    },

    // user selected a free pattern to display
    readFreePattern: function (filename) {
        // free patterns are located under www/data folder
        $.ajax({
            url: 'data/' + filename,
            type: "get",
            dataType: "text",
            success: function (data, textStatus, jqXHR) {
                // success reading the pattern
                app.displayPattern(filename, data);
            },
            error: function (jqXHR, textStatus, exception) {

                var str = 'Error displaying pattern ' + filename + ".\nError: ";

                if (jqXHR.status === 0) {
                    str += 'File not found.';
                } else if (jqXHR.status == 404) {
                    str += 'Requested page not found. [404]';
                } else if (jqXHR.status == 500) {
                    str += 'Internal Server Error [500].';
                } else if (exception === 'parsererror') {
                    str += 'Requested JSON parse failed.';
                } else if (exception === 'timeout') {
                    str += 'Time out error.';
                } else if (exception === 'abort') {
                    str += 'Ajax request aborted.';
                } else {
                    str += 'Uncaught Error.\n' + jqXHR.responseText;
                }
                alert(str);
            }
        });
    },

    // user selected a bought pattern to display
    readPattern: function (filename) {
        try {
            // don't create it if it does not exist
            app.fileSystem.root.getFile(app.patFolder + '/' + filename, null, app.readCrochetPat, app.fail);
        }
        catch (e) {
            alert(e.message);
        }
    },
    readCrochetPat: function (fileEntry) {
        fileEntry.file(app.readSelectedPatFile, app.fail);
    },
    readSelectedPatFile: function (file) {
        var reader = new FileReader();
        var filename = file.name;

        reader.onloadend = function (evt) {
            if (evt.target.result) {
                // success reading the pattern
                app.displayPattern(filename, evt.target.result);
            }
            else
                alert('Error: could not read pattern file:' + filename);
        };
        reader.readAsText(file);
    },

    setupCanvas: function (editable) {
        var win = $(window);

        // device width and height
        var w = win.width() - 20;

        // here is where you change the initial square size by changing the canvas height
        var h = win.height() * 2.5;

        // remove old canvas
        var patCanvas = $("#patCanvas");
        patCanvas.hide();
        patCanvas.remove();
        var canvasDiv = $("#canvasDiv");
        canvasDiv.hide();
        canvasDiv.remove();

        // create new canvas with correct width and height of window
        // allow room at bottom for device buttons
        var patCanvas = $('<div id="canvasDiv"><canvas id="patCanvas" width="' + w.toString() + '" height="' + (h - 90).toString() + '" style="position:absolute;border: 1px solid #000000;top:0;left:0;"></canvas></div>');

        // calculate the pattern dive top location
        var top = app.appGetPatternTop();

        var colorBtnSideNav = $("#colorBtnSideNav");
        colorBtnSideNav.offset({ top: top, left: 0 });
        var h = colorBtnSideNav[0].clientHeight;
        var colorSideNav = $("#colorSideNav");
        colorSideNav.offset({ top: top + h + 2, left: 0 });

        colorSelectorDiv = $("#colorSelectorDiv");
        colorSelectorDiv.offset({ top: top + h + 2 + 15 });

        patCanvas.width(w);
        patCanvas.height(h - 90);
        var patternPageDiv = $("#patternPage");
        patternPageDiv.append(patCanvas);

        // add space for color div
        patternPageDiv.offset({ top: top + 40, left: app.patternLeft });

        var setColor = _pat !== undefined;
        var curColor = "#000000";
        if (setColor) {
            curColor = _pat.getfilledSqrColor();
        }
        _pat = new Pattern(patCanvas);

        _pat.setEditable(editable);
        if (setColor) {
            _pat.setfilledSqrColor(curColor);
        }

        // save current canvas width and height
        _pat.saveCanvasWidthHeight();

        var patternTouchDiv = $("#pattern-page");


        // unbind old events
        patternTouchDiv.unbind("touchstart");
        patternTouchDiv.unbind("touchmove");
        patternTouchDiv.unbind("touchend");

        if (editable) {
            // add touch events           
            patternTouchDiv.bind("touchstart", createTouchStart);
            patternTouchDiv.bind("touchmove", createTouchMove);
            patternTouchDiv.bind("touchend", createTouchEnd);
        }
        else {
            // add touch events           
            patternTouchDiv.bind("touchstart", touchStart);
            patternTouchDiv.bind("touchmove", touchMove);
            patternTouchDiv.bind("touchend", touchEnd);
        }
    },

    createPattern: function () {
        try {
            // display button bar
            var iconbar = $('#iconbar');
            iconbar.show();
            var readonlyiconbar = $('#readonlyiconbar');
            readonlyiconbar.hide();

            app.createNew = true;
            app.setupCanvas(true);

            // save current canvas info
            _pat.saveCanvasOrigWidthHeight();
            _pat.saveCanvasScaleOrigWidthHeight();

            var success = _pat.createNewPattern();
            if (!success)
                return false;

            // display the pattern
            success = _pat.drawPattern();
            if (!success)
                return false;

            // save current canvas info
            _pat.saveCanvasOrigWidthHeight();
            _pat.saveCanvasScaleOrigWidthHeight();
            ColorSelector.updateColorCounts();
        }
        catch (err) {
            alert('Error displaying pattern 2: ' + err.message);
            return false;
        }
        return true;
    },

    // display the contents of the pattern user selected
    displayPattern: function (patFilename, content) {
        try {

            var pat = app.patfileName2Id(patFilename); // patFilename.replace(/[^a-zA-Z0-9]/g, '');
            var h3 = $('#b_' + pat);
            var editable = false;
            // if bought pattern
            if (h3 !== undefined && h3.length > 0) {
                editable = h3.data('iseditable') == "yes";
            }
            app.setupCanvas(editable);

            // read pattern contents
            var success = _pat.readPattern(content);
            if (!success)
                return false;

            // display the pattern
            success = _pat.drawPattern();
            if (!success)
                return false;

            // save current canvas info
            _pat.saveCanvasOrigWidthHeight();
            _pat.saveCanvasScaleOrigWidthHeight();
            if (editable) {
                tempFile.save();
                ColorSelector.addUserDefColors();
            }
            ColorSelector.addColorButtonsOnPattern();
            ColorSelector.updateColorCounts();
        }
        catch (err) {
            alert('Error displaying pattern 3: ' + err.message);
            return false;
        }
        return true;
    },

    getFileErrorCode: function (error) {
        var msg = '';
        switch (error.code) {
            case FileError.QUOTA_EXCEEDED_ERR:
                msg = 'QUOTA_EXCEEDED_ERR';
                break;
            case FileError.NOT_FOUND_ERR:
                msg = 'NOT_FOUND_ERR';
                break;
            case FileError.SECURITY_ERR:
                msg = 'SECURITY_ERR';
                break;
            case FileError.INVALID_MODIFICATION_ERR:
                msg = 'INVALID_MODIFICATION_ERR';
                break;
            case FileError.INVALID_STATE_ERR:
                msg = 'INVALID_STATE_ERR';
                break;
            case FileError.NOT_READABLE_ERR:
                msg = 'NOT_READABLE_ERR';
                break;
            case FileError.ENCODING_ERR:
                msg = 'ENCODING_ERR';
                break;
            case FileError.NO_MODIFICATION_ALLOWED_ERR:
                msg = 'NO_MODIFICATION_ALLOWED_ERR';
                break;
            case FileError.TYPE_MISMATCH_ERR:
                msg = 'TYPE_MISMATCH_ERR';
                break;
            case FileError.TYPE_MISMATCH_ERR:
                msg = 'PATH_EXISTS_ERR';
                break;
            case FileError.ABORT_ERR:
                msg = 'ABORT_ERR';
                break;
            case FileError.SYNTAX_ERR:
                msg = 'SYNTAX_ERR';
                break;
            default:
                msg = 'Unknown Error';
                break;
        }
        return msg;
    },

    goBack: function (btn) {

        if (editor.modified) {
            app.displaySaveDialog(btn);
        }
        else {
            try {
                $.mobile.changePage("#main-page", null, true, true);
            }
            catch (e) {
                alert(e.message);
            }
        }
    },

    displaySaveDialog: function (btn) {
        if (editor.modified) {
            app.currentPage = 'save-page';
            $.mobile.changePage("#save-page", null, true, true);
            editor.modified = false;
            save.goToPage = "main-page";
        }
    },

    savePattern: function (btn) {
        save.savePattern(btn);
    },

    deviceWidth: function () {
        var deviceWidth = window.screen.width;
        // iOS returns available pixels, Android returns pixels / pixel ratio
        // http://www.quirksmode.org/blog/archives/2012/07/more_about_devi.html
        //if (navigator.userAgent.indexOf('Android') >= 0 && window.devicePixelRatio) {
        //    deviceWidth = deviceWidth / window.devicePixelRatio;
        //}
        return deviceWidth;
    },
    deviceHeight: function () {
        var deviceHeight = window.screen.height;
        // iOS returns available pixels, Android returns pixels / pixel ratio
        // http://www.quirksmode.org/blog/archives/2012/07/more_about_devi.html
        //if (navigator.userAgent.indexOf('Android') >= 0 && window.devicePixelRatio) {
        //    deviceHeight = deviceHeight / window.devicePixelRatio;
        //}
        return deviceHeight;
    },

    enableCreateButton: function (enable) {
        var createPat = $("#createpat");
        var buyCreatePat = $("#buycreatepat");
        app.createAllowed = enable;
        if (enable) {
            createPat.show();
            buyCreatePat.hide();
        }
        else {
            createPat.hide();
            buyCreatePat.show();
        }
    },

    initIconbar: function () {
        $('#pencil').removeAttr('disabled');
        $('#eraser').removeAttr('disabled');
        $('#foursqr').removeAttr('disabled');
        $('#twosqr').removeAttr('disabled');
        $('#trim').removeAttr('disabled');
        $('#stamps').removeAttr('disabled');
        $('#inserts').removeAttr('disabled');
        $('#borders').removeAttr('disabled');
        $('#box').removeAttr('disabled');
        $('#undo').removeAttr('disabled');
        $('#redo').removeAttr('disabled');
        $('#cut').removeAttr('disabled');
        $('#copy').removeAttr('disabled');
        $('#paste').removeAttr('disabled');
        $('#rotate').removeAttr('disabled');
        $('#trace').removeAttr('disabled');

        $('#cut').attr('disabled', 'disabled');
        $('#copy').attr('disabled', 'disabled');
        $('#paste').attr('disabled', 'disabled');
        $('#undo').attr('disabled', 'disabled');
        $('#redo').attr('disabled', 'disabled');
        $('#rotate').attr('disabled', 'disabled');
    },
    enableIconbar: function (enable) {
        $('#pencil').removeAttr('disabled');
        $('#eraser').removeAttr('disabled');
        $('#foursqr').removeAttr('disabled');
        $('#twosqr').removeAttr('disabled');
        $('#trim').removeAttr('disabled');
        $('#stamps').removeAttr('disabled');
        $('#inserts').removeAttr('disabled');
        $('#borders').removeAttr('disabled');
        $('#box').removeAttr('disabled');
        $('#trace').removeAttr('disabled');

        $('#undo').attr('disabled', 'disabled');
        $('#redo').attr('disabled', 'disabled');

        if (enable) {
            if (app.undoState !== 'disabled') {
                $('#undo').removeAttr('disabled');
            }
            if (app.redoState !== 'disabled') {
                $('#redo').removeAttr('disabled');
            }
        }
        else {
            app.undoState = $('#undo').attr('disabled');
            app.redoState = $('#redo').attr('disabled');
            $('#undo').removeAttr('disabled');
            $('#redo').removeAttr('disabled');
            $('#pencil').attr('disabled', 'disabled');
            $('#eraser').attr('disabled', 'disabled');
            $('#foursqr').attr('disabled', 'disabled');
            $('#twosqr').attr('disabled', 'disabled');
            $('#trim').attr('disabled', 'disabled');
            $('#eraser').attr('disabled', 'disabled');
            $("#stamps").attr('disabled', 'disabled');
            $('#inserts').attr('disabled', 'disabled');
            $('#borders').attr('disabled', 'disabled');
            $('#box').attr('disabled', 'disabled');
            $('#undo').attr('disabled', 'disabled');
            $('#redo').attr('disabled', 'disabled');
            $('#trace').attr('disabled', 'disabled');

            $('#cut').removeAttr('disabled');
            $('#copy').removeAttr('disabled');
            $('#paste').removeAttr('disabled');
            $('#rotate').removeAttr('disabled');

            $('#cut').attr('disabled', 'disabled');
            $('#copy').attr('disabled', 'disabled');
            $('#paste').attr('disabled', 'disabled');
            $('#rotate').attr('disabled', 'disabled');
        }
    },
    displayVideo: function (display) {
        var videoDiv = $("#howtoVideoDiv");
        var video = $("#howtoVideo");
        if (display) {
            video[0].load();
            videoDiv.show();
            var playBtn = $("#playButton");
            playBtn.text("Play");
        }
        else {
            videoDiv.hide();
        }
    },

    playVideo: function (btn) {
        var video = $("#howtoVideo");
        var playBtn = $(btn);
        var playBtnText = playBtn.text();

        if (playBtnText === "Play") {
            video[0].play();
            playBtn.text("Pause");
        }
        else {
            video[0].pause();
            playBtn.text("Play");
        }
    },
    // disable the back button by not doing anything
    onBackKeyPress : function () {            
    }
};