﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var LoomPatternDef = {

    LoomPatternDefFile: 'loompatdef.txt',
    content: '',

    // save contents to file
    saveLoomPatternDef: function (content) {
        try {

            LoomPatternDef.content = content;

            //store = "file:///data/data/com.SandCastleDesigns.filetcrochet/files/"
            var store = cordova.file.dataDirectory;
            window.resolveLocalFileSystemURI(store, LoomPatternDef.fsWriteLoomPatternDefFile, LoomPatternDef.fail);
        }
        catch (err) {
            alert("An error has occurred while trying to save your settings: " + err.message);
        }
    },

    // write LoomPatternDef file to file system
    fsWriteLoomPatternDefFile: function (directoryEntry) {

        // create it if it does not exist
        directoryEntry.getFile(LoomPatternDef.LoomPatternDefFile, { create: true, exclusive: false }, LoomPatternDef.feWriteLoomPatternDef, LoomPatternDef.saveFail);
    },

    feWriteLoomPatternDef: function (fileEntry) {
        fileEntry.createWriter(LoomPatternDef.fwLoomPatternDef, LoomPatternDef.saveFail);
    },
    fwLoomPatternDef: function (writer) {
        writer.write(LoomPatternDef.content);
    },
    saveFail: function (error) {
        var msg = "An error has occurred while trying to save your settings: ";
        msg += fail(error);
    },

    // read contents from file
    getLoomPatternDef: function () {

        //store = "file:///data/data/com.SandCastleDesigns.filetcrochet/files/"
        var store = cordova.file.dataDirectory;
        window.resolveLocalFileSystemURI(store, LoomPatternDef.fsReadLoomPatternDefFile, LoomPatternDef.readFail);
    },
    fsReadLoomPatternDefFile: function (directoryEntry) {

        // don't create it if it does not exist
        directoryEntry.getFile(LoomPatternDef.LoomPatternDefFile, null, LoomPatternDef.feReadLoomPatternDef, LoomPatternDef.readFail);
    },

    feReadLoomPatternDef: function (fileEntry) {
        fileEntry.file(LoomPatternDef.frLoomPatternDef, LoomPatternDef.readFail);
    },
    frLoomPatternDef: function (file) {
        LoomPatternDef.readLoomPatternDefFile(file);
    },
    readLoomPatternDefFile: function (file) {
        var reader = new FileReader();
        reader.onloadend = function (evt) {
            // store settings in memory
            settings.storeSettings(evt.target.result);
        };
        reader.readAsText(file);
    },
    readFail: function (error) {
        var msg = "An error has occurred while trying to read your settings: ";
        msg += LoomPatternDef.fail(error);
    },
    

    fail: function (error) {
        var msg = app.getFileErrorCode(error);
        return (msg);
    }
};