﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

// touch events
var headerHeight = 100;

// user can touch with 1 or 2 fingers
var touchStart = function (event) {
    try {
        var patternDiv = $("#patternPage");
        var offset = patternDiv.offset();
        var top = offset.top;

        // space for header and tawith test accountbs
        if (event.originalEvent.touches[0].pageY < top) {
            return;
        }
        var offset = patternDiv.offset();
        app.patPageOffset.left = offset.left;
        app.patPageOffset.top = offset.top;

        // if user touched with one finger
        if (event.originalEvent.touches.length === 1) {

            app.mouse = {
                'touches': 1,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1,

                'startX2': 0,
                'endX2': -1,
                'startY2': 0,
                'endY2': -1
            };
            app.mouse.tap = true;

        }
        //else user has two fingers touching
        else if (event.originalEvent.touches.length === 2) {

            app.mouse = {
                'touches': 2,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1,
                'startX2': event.originalEvent.touches[1].pageX,
                'endX2': -1,
                'startY2': event.originalEvent.touches[1].pageY,
                'endY2': -1
            };

            // save canvas width and height before changing it
            _pat.saveCanvasWidthHeight();
        }
    } catch (err) {
    }
}

var touchMove = function (event) {

    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;

    // if user touched with one finger and moving it
    if (event.originalEvent.touches.length === 1) {

        app.mouse.endX1 = event.originalEvent.touches[0].pageX;
        app.mouse.endY1 = event.originalEvent.touches[0].pageY;

        // get x and y deltas
        var deltaX = app.mouse.endX1 - app.mouse.startX1;
        var deltaY = app.mouse.endY1 - app.mouse.startY1;

        // move the pattern by delta x and y only if x or y changed by at least 3 pixels
        var patternDiv = $("#patternPage");
        if (Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) {
            try {
                var patCanvas = $("#patCanvas");
                if (patCanvas !== undefined && patCanvas.length !== undefined && patCanvas.length > 0) {
                    var h = patCanvas[0].height;
                    var newTop = deltaY + app.patPageOffset.top;
                    if (newTop + h > headerHeight + 40) {
                        patternDiv.offset({ top: newTop, left: deltaX + app.patPageOffset.left });
                    }
                }
            }
            catch (err) {
            }
            app.mouse.tap = false;
        }
    }

    //else  the user has two fingers touching
    else if (event.originalEvent.touches.length === 2) {
        try {
            if (app.mouse.endX1 !== -1) {
                app.mouse.startX1 = app.mouse.endX1;
                app.mouse.startY1 = app.mouse.endY1;
            }
            app.mouse.endX1 = event.originalEvent.touches[0].pageX;
            app.mouse.endY1 = event.originalEvent.touches[0].pageY;

            if (app.mouse.endX2 !== -1) {
                app.mouse.startX2 = app.mouse.endX2;
                app.mouse.startY2 = app.mouse.endY2;
            }
            app.mouse.endX2 = event.originalEvent.touches[1].pageX;
            app.mouse.endY2 = event.originalEvent.touches[1].pageY;

            // get the x, y differences for both fingers
            var touch1Diff;
            var touch2Diff;

            // if second finger is to the right of first finger
            if (app.mouse.startX2 > app.mouse.startX1) {
                touch1Diff = app.mouse.startX1 - app.mouse.endX1;
                touch2Diff = app.mouse.endX2 - app.mouse.startX2;
            }

            // else second finger is to the left of first finger
            else {
                touch1Diff = app.mouse.endX1 - app.mouse.startX1;
                touch2Diff = app.mouse.startX2 - app.mouse.endX2;
            }

            // which direction is the greatest, growing or shrinking
            var touchXDiff = touch1Diff + touch2Diff;

            // if second finger is below first finger
            if (app.mouse.startY2 > app.mouse.startY1) {
                touch1Diff = app.mouse.startY1 - app.mouse.endY1;
                touch2Diff = app.mouse.endY2 - app.mouse.startY2;
            }
            // else second finger is above first finger
            else {
                touch1Diff = app.mouse.endY1 - app.mouse.startY1;
                touch2Diff = app.mouse.startY2 - app.mouse.endY2;
            }

            // which direction is the greatest, growing or shrinking
            var touchYDiff = touch1Diff + touch2Diff;

            // if positive difference then zoom in pattern
            if (touchXDiff + touchYDiff > 0) {
                _pat.zoomPattern(10);
            }

            // if negative different then out pattern
            else if (touchXDiff + touchYDiff < 0) {
                _pat.zoomPattern(-10);
            }
        } catch (err)
        { }
    }
}


var touchEnd = function (event) {

    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;

    // if tap highlight the pattern to the tapped square
    if (app.mouse.tap === true) {
    }

    // else moved, zoomed in or zoomed out of pattern
    else {
        try {
            // redraw the pattern to produce image with good resolution
            _pat.redrawPattern();
            _pat.saveCanvasScaleOrigWidthHeight();
        }
        catch (err) { }
    }
    app.mouse = {};
}

//////////////////////////////////////////////////////////////////////////////////////
// user can touch with 1 or 2 fingers
var createTouchStart = function (event) {

    var handleHeight = 32;
    var handleWidth = 25;
    try {
        var patternPageDiv = $("#patternPage");
        var offset = patternPageDiv.offset();

        var top = app.appGetPatternTop();
        // space for header and tabs
        if (
           event.originalEvent.touches[0].pageY < top || ColorSelector.isSymbolDialogDisplayed ||
           (event.target.parentNode !== undefined && (
               event.target.parentNode.id.substring(0, 11) === "staticColor" ||
               event.target.parentNode.id.substring(0, 5) === "color")))
            return;

        var patternDiv = $("#patternPage");
        var offset = patternDiv.offset();
        app.patPageOffset.left = offset.left;
        app.patPageOffset.top = offset.top;
        app.mouse.handle = "";

        // if user touched with one finger
        if (event.originalEvent.touches.length === 1) {
            app.mouse = {
                'touches': 1,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1,
                'startX2': 0,
                'endX2': -1,
                'startY2': 0,
                'endY2': -1,

                'moveX1': 0,
                'moveY1': 0,
                'moving': false
            };
            app.mouse.tap = true;

            var handleOffset = $("#handle").offset();
            var handlelrOffset = $("#handlelr").offset();
            var handleudOffset = $("#handleud").offset();
            if (trace.tracing) {

                var udHandle = $("#camerahandleud");
                var lrHandle = $("#camerahandlelr");
                var handle = $("#camerahandle");
                var moveHandle = $("#camerahandlemove");
                if (udHandle !== undefined && lrHandle !== undefined && handle !== undefined && !handle.is(':hidden') && moveHandle !== undefined && !moveHandle.is(':hidden')) {
                    var udOffset = udHandle.offset();
                    var lrOffset = lrHandle.offset();
                    var hOffset = handle.offset();
                    var moveOffset = moveHandle.offset();

                    // if on resize handle
                    if (app.mouse.startX1 >= hOffset.left && app.mouse.startX1 <= hOffset.left + handleHeight + 10 &&
                        app.mouse.startY1 >= hOffset.top && app.mouse.startY1 <= hOffset.top + handleHeight + 10) {
                        trace.resizHandle = "resizeBoth";
                        trace.dragImage = true;
                    }
                    else if (app.mouse.startX1 >= udOffset.left && app.mouse.startX1 <= udOffset.left + handleHeight &&
                        app.mouse.startY1 >= udOffset.top && app.mouse.startY1 <= udOffset.top + handleWidth + 10) {
                        trace.resizHandle = "resizeUpDown";
                        trace.dragImage = true;
                    }
                    else if (app.mouse.startX1 >= lrOffset.left && app.mouse.startX1 <= lrOffset.left + handleWidth + 10 &&
                        app.mouse.startY1 >= lrOffset.top && app.mouse.startY1 <= lrOffset.top + handleHeight) {
                        trace.resizHandle = "resizeLeftRight";
                        trace.dragImage = true;
                    }
                    else if (app.mouse.startX1 >= moveOffset.left && app.mouse.startX1 <= moveOffset.left + handleHeight + 10 &&
                        app.mouse.startY1 >= moveOffset.top && app.mouse.startY1 <= moveOffset.top + handleHeight + 10) {
                        trace.resizHandle = "moveImage";
                        trace.dragImage = true;
                        trace.setImageOffset();
                    }
                }
            }
            // if stamp is on the pattern
            if (stamps.selectedStamp >= 0) {
                _pat.createLocBox();
                var locCanvas = $("#locCanvas");
                locCanvas.show();
            }

            // if insert is on the pattern, this is the insert filename .ist
            else if (inserts.selectedInsert !== "") {
                _pat.createLocBox();
                var locCanvas = $("#locCanvas");
                locCanvas.show();
            }

            // else if move box is on the pattern, user is moving some squares
            else if (selectionBox.mode === "movebox") {
                _pat.createLocBox();
            }
            else if (selectionBox.mode === "dragboxend" && editor.selected === "box") {
                // starting the move box
                _pat.createLocBox();
            }

            // else if on resize handle
            else if (app.mouse.startX1 >= handleOffset.left && app.mouse.startX1 <= handleOffset.left + handleHeight &&
                 app.mouse.startY1 >= handleOffset.top && app.mouse.startY1 <= handleOffset.top + handleHeight) {
                app.mouse.handle = "resizeBoth";
                $("#handleImg").css({ "border-width": "4px" });

            }
            
            // else if on left/right resize handle
            else if (app.mouse.startX1 >= handlelrOffset.left && app.mouse.startX1 <= handlelrOffset.left + handleWidth &&
                 app.mouse.startY1 >= handlelrOffset.top && app.mouse.startY1 <= handlelrOffset.top + handleHeight) {
                app.mouse.handle = "resizeLeftRight";
                $("#handlelrImg").css({ "border-width": "4px" });
            }

            // else if on up/down resize handle
            else if (app.mouse.startX1 >= handleudOffset.left && app.mouse.startX1 <= handleudOffset.left + handleHeight &&
                 app.mouse.startY1 >= handleudOffset.top && app.mouse.startY1 <= handleudOffset.top + handleWidth) {
                app.mouse.handle = "resizeUpDown";
                $("#handleudImg").css({ "border-width": "4px" });
            }
            // else importing an image
            else if (importImage.dragImage) {
                var udHandle = $("#camerahandleud");
                var lrHandle = $("#camerahandlelr");
                var handle = $("#camerahandle");
                if (udHandle !== undefined && lrHandle !== undefined && handle !== undefined && !handle.is(':hidden')) {
                    var udOffset = udHandle.offset();
                    var lrOffset = lrHandle.offset();
                    var hOffset = handle.offset();

                    // if on resize handle
                    if (app.mouse.startX1 >= hOffset.left - 10 && app.mouse.startX1 <= hOffset.left + handleHeight + 10 &&
                        app.mouse.startY1 >= hOffset.top - 10 && app.mouse.startY1 <= hOffset.top + handleHeight + 10) {
                        importImage.resizHandle = "resizeBoth";
                    }
                    else if (app.mouse.startX1 >= udOffset.left - 10 && app.mouse.startX1 <= udOffset.left + handleHeight &&
                        app.mouse.startY1 >= udOffset.top - 10 && app.mouse.startY1 <= udOffset.top + handleWidth + 10) {
                        importImage.resizHandle = "resizeUpDown";
                    }
                    else if (app.mouse.startX1 >= lrOffset.left - 10 && app.mouse.startX1 <= lrOffset.left + handleWidth + 10 &&
                        app.mouse.startY1 >= lrOffset.top - 10 && app.mouse.startY1 <= lrOffset.top + handleHeight + 10) {
                        importImage.resizHandle = "resizeLeftRight";
                    }
                    else {
                        importImage.setImageOffset();
                    }
                }
                else {
                    importImage.setImageOffset();
                }
            }
            // else tracing an image
            else if (trace.dragImage) {
            }
            else {
                // if icon selected on pattern create page
                if (editor.selected != "") {
                    if (!ColorSelector.isInside(app.mouse.startX1, app.mouse.startY1)) {
                        try {
                            if (editor.selected === "pencil") {
                                ColorSelector.addNewColorButton();
                            }

                            // color selector box is on the screen
                            if (ColorSelector.isDisplayed) {
                                if (!ColorSelector.isInside(app.mouse.startX1, app.mouse.startY1)) {
                                    editor.draw(app.mouse.startX1, app.mouse.startY1);
                                }
                            }
                            else
                                editor.draw(app.mouse.startX1, app.mouse.startY1);
                        }
                        catch (err) {
                        }
                    }
                }
            }
        }
        //else user has two fingers touching
        else if (event.originalEvent.touches.length === 2) {

            app.mouse = {
                'touches': 2,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1,
                'startX2': event.originalEvent.touches[1].pageX,
                'endX2': -1,
                'startY2': event.originalEvent.touches[1].pageY,
                'endY2': -1,

                'moveX1': 0,
                'moveY1': 0
            };

            // save canvas width and height before changing it
            _pat.saveCanvasWidthHeight();
        }
    }
    catch (err)
    { }

    // do not remove this - beadloom has a problem with header moving off screen
    event.stopPropagation();
}


var createTouchMove = function (event) {
    try {
        // use touched in header/tab space
        if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
            return;

        // if user touched with one finger and moving it
        if (event.originalEvent.touches.length === 1) {

            var moveX = app.mouse.endX1 == -1 ? event.originalEvent.touches[0].pageX - app.mouse.startX1 : event.originalEvent.touches[0].pageX - app.mouse.endX1;
            var moveY = app.mouse.endY1 == -1 ? event.originalEvent.touches[0].pageY - app.mouse.startY1 : event.originalEvent.touches[0].pageY - app.mouse.endY1;
            app.mouse.endX1 = event.originalEvent.touches[0].pageX;
            app.mouse.endY1 = event.originalEvent.touches[0].pageY;
            app.mouse.moving = true;

            // get x and y deltas
            var deltaX = app.mouse.endX1 - app.mouse.startX1;
            var deltaY = app.mouse.endY1 - app.mouse.startY1;
            if (importImage.dragImage) {

                if (importImage.resizHandle.length > 0) {

                    var deltaX1 = moveX + app.mouse.moveX1;
                    var deltaY1 = moveY + app.mouse.moveY1;
                    importImage.resizeImage(deltaX1, deltaY1);
                }
                else {
                    importImage.moveImage(deltaX, deltaY);
                }
            }
            else if (trace.dragImage) {

                if (trace.resizHandle.length > 0) {
                    if (trace.resizHandle === "moveImage") {
                        trace.moveImage(deltaX, deltaY);

                    }
                    else {
                        var deltaX1 = moveX + app.mouse.moveX1;
                        var deltaY1 = moveY + app.mouse.moveY1;
                        trace.resizeImage(deltaX1, deltaY1);
                    }
                }
            }

            // user is moving a stamp on the pattern
            else if (stamps.selectedStamp >= 0) {
                if (Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) {
                    try {
                        var thumbnailDiv = $("#thumbnail");
                        //var offset = thumbnailDiv.offset();
                        var newTop = deltaY + stamps.canvasOffset.top;
                        var newLeft = deltaX + stamps.canvasOffset.left;
                        thumbnailDiv.css("top", newTop);
                        thumbnailDiv.css("left", newLeft);
                        

                        var patDivOffset = $("#patternPage").offset();
                        var sqrW = _pat.getSqrW();
                        var sqrH = _pat.getSqrH();

                        var startRow = Math.floor((newTop - patDivOffset.top - _pat.getTopOffset()) / sqrH);
                        var startCol = Math.floor((newLeft - patDivOffset.left - _pat.getLeftOffset()) / sqrW);

                        var top = patDivOffset.top + _pat.getTopOffset() + (startRow * sqrH);
                        var left = patDivOffset.left + _pat.getLeftOffset() + (startCol * sqrW);

                        var locCanvas = $("#locCanvas");
                        locCanvas.offset({ left: left, top: top });
                    }
                    catch (err) {
                    }
                }
            }

            // user is moving an insert on top of the pattern
            else if (inserts.selectedInsert !== "") {
                if (Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) {
                    try {
                        var thumbnailDiv = $("#thumbnail");
                        var newTop = deltaY + inserts.canvasOffset.top;
                        var newLeft = deltaX + inserts.canvasOffset.left;
                        thumbnailDiv.css("top", newTop);
                        thumbnailDiv.css("left", newLeft);

                        var patDivOffset = $("#patternPage").offset();
                        var sqrW = _pat.getSqrW();
                        var sqrH = _pat.getSqrH();

                        var startRow = Math.floor((newTop - patDivOffset.top - _pat.getTopOffset()) / sqrH);
                        var startCol = Math.floor((newLeft - patDivOffset.left - _pat.getLeftOffset()) / sqrW);

                        var top = patDivOffset.top + _pat.getTopOffset() + (startRow * sqrH);
                        var left = patDivOffset.left + _pat.getLeftOffset() + (startCol * sqrW);
                        var locCanvas = $("#locCanvas");
                        locCanvas.offset({ left: left, top: top });
                    }
                    catch (err) {
                    }
                }
            }
            // else if move box is on the pattern, user is moving some squares
            else if (selectionBox.mode === "movebox") {
                if (Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) {
                    try {
                        var thumbnailDiv = $("#thumbnail");
                        var offset = thumbnailDiv.offset();
                        var newTop = deltaY + selectionBox.moveBox.top + selectionBox.canvasOffset.top;
                        var newLeft = deltaX + selectionBox.moveBox.left + selectionBox.canvasOffset.left;

                        thumbnailDiv.css("top", newTop);
                        thumbnailDiv.css("left", newLeft);

                        var sqrW = _pat.getSqrW();
                        var sqrH = _pat.getSqrH();
                        var patDivOffset = $("#patternPage").offset();
                        var startRow = Math.floor((newTop - patDivOffset.top - _pat.getTopOffset()) / sqrH);
                        var startCol = Math.floor((newLeft - patDivOffset.left - _pat.getLeftOffset()) / sqrW);

                        var top = patDivOffset.top + _pat.getTopOffset() + (startRow * sqrH);
                        var left = patDivOffset.left + _pat.getLeftOffset() + (startCol * sqrW);

                        var locCanvas = $("#locCanvas");
                        locCanvas.offset({ left: left, top: top });
                        locCanvas.show();
                    }
                    catch (err) {
                    }
                }
            }
            // user is moving the both resize handle
            else if (app.mouse.handle !== undefined && app.mouse.handle === "resizeBoth") {

                var sqrW = _pat.getSqrW();
                var sqrH = _pat.getSqrH();
                if (Math.abs(moveX + app.mouse.moveX1) > sqrW || Math.abs(moveY + app.mouse.moveY1) > sqrH) {
                    var deltaCols = 0;
                    var deltaRows = 0;

                    // if  mouse moved in x direction more than square size
                    if (Math.abs(moveX + app.mouse.moveX1) > sqrW) {
                        deltaCols = moveX + app.mouse.moveX1 > 0 ? 1 : -1;
                        app.mouse.moveX1 = 0;
                    }
                    else {
                        app.mouse.moveX1 += moveX;
                    }

                    // if  mouse moved in y direction more than square size
                    if (Math.abs(moveY + app.mouse.moveY1) > sqrH) {
                        deltaRows = moveY + app.mouse.moveY1 > 0 ? 1 : -1;
                        app.mouse.moveY1 = 0;
                    }
                    else {
                        app.mouse.moveY1 += moveY;
                    }
                    _pat.resizePatternByDeltas(deltaRows, deltaCols);
                }

                // save delta move
                else {
                    app.mouse.moveX1 += moveX;
                    app.mouse.moveY1 += moveY;
                }
            }

            // user is moving the left right resize handle
            else if (app.mouse.handle !== undefined && app.mouse.handle === "resizeLeftRight") {

                // if  mouse moved in x direction more than square size
                if (Math.abs(moveX + app.mouse.moveX1) > _pat.getSqrW()) {
                    var deltaCols = moveX + app.mouse.moveX1 > 0 ? 1 : -1;
                    app.mouse.moveX1 = 0;
                    _pat.resizePatternByDeltas(0, deltaCols);
                }
                else {
                    app.mouse.moveX1 += moveX;
                }
            }
            else if (app.mouse.handle !== undefined && app.mouse.handle === "resizeUpDown") {

                // if  mouse moved in y direction more than square size
                if (Math.abs(moveY + app.mouse.moveY1) > _pat.getSqrW()) {
                    var deltaRows = moveY + app.mouse.moveY1 > 0 ? 1 : -1;
                    app.mouse.moveY1 = 0;
                    _pat.resizePatternByDeltas(deltaRows, 0);
                }
                else {
                    app.mouse.moveY1 += moveY;
                }
            }
            else {

                if (editor.selected === "") {
                    // move the pattern by delta x and y only if x or y changed by at least 3 pixels
                    var patternDiv = $("#patternPage");
                    if ((Math.abs(deltaX) > 5 || Math.abs(deltaY) > 5) && app.mouse.startX1 > 90 && app.mouse.endX1 > 90){
                        try {
                            var patCanvas = $("#patCanvas");
                            if (patCanvas !== undefined && patCanvas.length !== undefined && patCanvas.length > 0) {
                                var h = patCanvas[0].height;
                                var newTop = deltaY + app.patPageOffset.top;
                                if (newTop + h > headerHeight + 40) {
                                    patternDiv.offset({ top: newTop, left: deltaX + app.patPageOffset.left });
                                    _pat.posResizeHandles();

                                }
                            }
                        }
                        catch (err) {
                        }
                        app.mouse.tap = false;
                    }
                }
                else {

                    if (Math.abs(deltaX) > _pat.getSqrW() || Math.abs(deltaY) > _pat.getSqrW()) {
                        try {
                            if (editor.selected === "box" || editor.selected === "pencil" ||
                                editor.selected === "eraser" || editor.selected === "foursqr" ||
                                editor.selected === "twosqr" || editor.selected === "trim") {

                                // color selector box is on the screen
                                if (ColorSelector.isDisplayed) {
                                    if (!ColorSelector.isInside(app.mouse.endX1, app.mouse.endY1)) {
                                        editor.draw(app.mouse.endX1, app.mouse.endY1);
                                    }
                                }
                                else {
                                    editor.draw(app.mouse.endX1, app.mouse.endY1);
                                }
                            }
                        }
                        catch (err) {
                        }
                    }
                }
            }
        }

        //else  the user has two fingers touching
        else if (event.originalEvent.touches.length === 2) {

            // if stamp is on the pattern
            if (stamps.selectedStamp >= 0) {

            }
            // else if insert is on the pattern
            else if (inserts.selectedInsert !== "") {

            }
            else {
                if (app.mouse.endX1 !== -1) {
                    app.mouse.startX1 = app.mouse.endX1;
                    app.mouse.startY1 = app.mouse.endY1;
                }
                app.mouse.endX1 = event.originalEvent.touches[0].pageX;
                app.mouse.endY1 = event.originalEvent.touches[0].pageY;

                if (app.mouse.endX2 !== -1) {
                    app.mouse.startX2 = app.mouse.endX2;
                    app.mouse.startY2 = app.mouse.endY2;
                }
                app.mouse.endX2 = event.originalEvent.touches[1].pageX;
                app.mouse.endY2 = event.originalEvent.touches[1].pageY;

                // get the x, y differences for both fingers
                var touch1Diff;
                var touch2Diff;

                // if second finger is to the right of first finger
                if (app.mouse.startX2 > app.mouse.startX1) {
                    touch1Diff = app.mouse.startX1 - app.mouse.endX1;
                    touch2Diff = app.mouse.endX2 - app.mouse.startX2;
                }

                // else second finger is to the left of first finger
                else {
                    touch1Diff = app.mouse.endX1 - app.mouse.startX1;
                    touch2Diff = app.mouse.startX2 - app.mouse.endX2;
                }

                // which direction is the greatest, growing or shrinking
                var touchXDiff = touch1Diff + touch2Diff;

                // if second finger is below first finger
                if (app.mouse.startY2 > app.mouse.startY1) {
                    touch1Diff = app.mouse.startY1 - app.mouse.endY1;
                    touch2Diff = app.mouse.endY2 - app.mouse.startY2;
                }
                // else second finger is above first finger
                else {
                    touch1Diff = app.mouse.endY1 - app.mouse.startY1;
                    touch2Diff = app.mouse.startY2 - app.mouse.endY2;
                }

                // which direction is the greatest, growing or shrinking
                var touchYDiff = touch1Diff + touch2Diff;

                // if positive difference then zoom in pattern
                if (touchXDiff + touchYDiff > 0) {
                    _pat.zoomPattern(10);
                    _pat.posResizeHandles();
                }

                // if negative different then out pattern
                else if (touchXDiff + touchYDiff < 0) {
                    _pat.zoomPattern(-10);
                    _pat.posResizeHandles();
                }
            }
        }
    }
    catch (err)
    { }

    // do not remove this - beadloom has a problem with header moving off screen
    event.stopPropagation();
}

var createTouchEnd = function (event) {

    try {
        // use touched in header/tab space
        if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
            return;

        if (importImage.dragImage) {
            if (importImage.resizHandle.length > 0) {
                if (importImage.resizHandle === "resizeBoth") {

                }
                else if (importImage.resizHandle === "resizeUpDown") {
                }
                else if (importImage.resizHandle === "resizeLeftRight") {
                }
                importImage.resizHandle = "";

            }
        }
        else if (trace.dragImage) {
            if (trace.resizHandle.length > 0) {
                if (trace.resizHandle === "resizeBoth") {

                }
                else if (trace.resizHandle === "resizeUpDown") {
                }
                else if (trace.resizHandle === "moveImage") {
                }
                else if (trace.resizHandle === "resizeLeftRight") {
                }
                trace.resizHandle = "";
                trace.dragImage = false;
            }
        }
        // if stamp is on the pattern
        else if (stamps.selectedStamp >= 0) {
            stamps.insertStampOnPattern();
            tempFile.save();
            $("#undo").removeAttr('disabled');
            ColorSelector.updateColorCounts();
            var locCanvas = $("#locCanvas");
            locCanvas.hide();
            $("#rotate").removeAttr('disabled');
            $("#rotate").attr('disabled', 'disabled'); 
        }

        // if insert is on the pattern
        else if (inserts.selectedInsert !== "") {
            inserts.insertInsertOnPattern();
            tempFile.save();
            $("#undo").removeAttr('disabled');
            ColorSelector.updateColorCounts();
            var locCanvas = $("#locCanvas");
            locCanvas.hide();
            $("#rotate").removeAttr('disabled');
            $("#rotate").attr('disabled', 'disabled'); 
        }

        // user selected resize handle
        else if (app.mouse.handle !== undefined && app.mouse.handle !== "") {
            editor.modified = true;
            tempFile.save();
            $("#undo").removeAttr('disabled');
        }

        else if (editor.selected === "box" || editor.selected === "paste" || editor.selected === "rotate") {
            if (selectionBox.mode === "dragbox") {
                selectionBox.dragBoxEnd();
                $("#cut").removeAttr('disabled');
                $("#copy").removeAttr('disabled');
                $("#rotate").removeAttr('disabled');
                $("#trace").removeAttr('disabled');

            }
            else if (selectionBox.mode === "movebox") {
                selectionBox.moveBoxEnd();
                tempFile.save();
                var locCanvas = $("#locCanvas");
                locCanvas.hide();
                $("#undo").removeAttr('disabled');
                $("#box").removeAttr('disabled');
                $("#stamps").removeAttr('disabled');
                $("#inserts").removeAttr('disabled');
                $("#borders").removeAttr('disabled');
                $("#rotate").removeAttr('disabled');
                $('#rotate').attr('disabled', 'disabled');
                $("#trace").removeAttr('disabled');
            }
        }
        else {
            // if user is not zooming in/out
            // best thing to do after drawing trims is redisplaying the whole pattern
            // to clean it up
            if (app.mouse.touches !== 2) {
                if (editor.selected === "pencil" || editor.selected === "eraser" || editor.selected === "foursqr" ||
                    editor.selected === "twosqr" || editor.selected === "trim") {
                    tempFile.save();
                    _pat.drawGridPattern();

                }
                $("#undo").removeAttr('disabled');
            }

            // else moved, zoomed in or zoomed out of pattern
            if (!app.mouse.tap) {
                // redraw the pattern to produce image with good resolution
                _pat.redrawPattern();
               
                // if 2 fingure zoom
                if (app.mouse.touches !== undefined && app.mouse.touches === 2) {
                    tempFile.save();
                    $("#undo").removeAttr('disabled');
                }
                _pat.saveCanvasScaleOrigWidthHeight();
            }
        }
        app.mouse = {};
        stamps.selectedStamp = -1;
        inserts.selectedInsert = "";
        $("#handleImg").css({ "border-width": "0" });
        $("#handlelrImg").css({ "border-width": "0" });
        $("#handleudImg").css({ "border-width": "0" });

        ColorSelector.updateColorCounts();
    }
    catch (err)
    { }

    // do not remove this - beadloom has a problem with header moving off screen
    event.stopPropagation();
}

var stampsTouchStart = function (event) {

    event.preventDefault();

    // if user touched with one finger
    if (event.originalEvent.touches.length >= 1) {
        app.mouse = {
            'touches': 1,
            'startX1': event.originalEvent.touches[0].pageX,
            'endX1': -1,
            'startY1': event.originalEvent.touches[0].pageY,
            'endY1': -1,
            'startX2': 0,
            'endX2': -1,
            'startY2': 0,
            'endY2': -1
        };
        app.mouse.tap = true;
    }
}

var stampsTouchEnd = function (event) {
    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;
    stamps.selected(app.mouse.startX1,app.mouse.startY1);
    app.mouse = {};
}

var bordersTouchStart = function (event) {

    event.preventDefault();

    // if user touched with one finger
    if (event.originalEvent.touches.length >= 1) {
        app.mouse = {
            'touches': 1,
            'startX1': event.originalEvent.touches[0].pageX,
            'endX1': -1,
            'startY1': event.originalEvent.touches[0].pageY,
            'endY1': -1,
            'startX2': 0,
            'endX2': -1,
            'startY2': 0,
            'endY2': -1
        };
        app.mouse.tap = true;
    }
}

var bordersTouchEnd = function (event) {
    // use touched in header/tab space
    if (app.mouse.startY1 === undefined || app.mouse.startX1 === undefined)
        return;
    borders.selected(app.mouse.startX1, app.mouse.startY1);
    app.mouse = {};
}