﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

// list of all patterns
// NOTE: the .png files for each pattern remain in the www/data folder because a url to the png file is only needed.

var myPat = {

    // complete list of all patterns available to purchase
    completePatList: { "totalFiles": 12, "files": [
        ]
    },

    // complete list of free patterns
     freePatList: { "totalFiles": 4, "files": [
         { "filename": "chainlink.cht" },
         { "filename": "pathway.cht" },
         { "filename": "daffodils.cht" },
         { "filename": "joinedflowers.cht" },
       ]
    },

    // current index into completePatList/freePatList
    // can only read one pattern at a time
    // use this to keep track of which pattern we just read
    patIndex: -1,

    // copy all patterns to application folder file:////data/data/com.SandCastleDesings.filetcrochet/files/
    getAllMyPatFiles: function () {

        // start with first one, when it is done a call is made to get the next one myPat.getMyPatFile(1);
        myPat.getMyPatFile(0);
    },
    
    // get a pattern file from www/data folder that can be purchased
    getMyPatFile: function (i) {
 
        // for each file listed in the completPatList array
        if (i < myPat.completePatList.files.length) {

            myPat.patIndex = i;

            // read the .cht file
            $.ajax({
                url: 'data/' + myPat.completePatList.files[myPat.patIndex].filename,
                type: "get",
                dataType: "text",

                success: function (data, textStatus, jqXHR) {
                    
                    // read the title from the pattern
                    app.displayPatternInfo(myPat.completePatList.files[myPat.patIndex].filename, data, "n_");
                    myPat.getNextPatFile();
                },

                // just continue if could not read this file
                error: function (jqXHR, textStatus, errorThrown) {
                    myPat.getNextPatFile();
                }
            });
        }
    },

    // get the next pattern from the list
    // if no more patterns to read then refresh the list
    getNextPatFile: function () {
        myPat.patIndex++;

        // read next pattern
        if (myPat.patIndex < myPat.completePatList.files.length) {
            myPat.getMyPatFile(myPat.patIndex);
        }

        // no more patterns to read
        else {
            var patList = $('#patlist');
            if (patList !== undefined && patList.length > 0){
                patList.listview('refresh');
            }
        }
    },

    // copy all patterns to application folder file:////data/data/com.SandCastleDesings.filetcrochet/files/
    getAllFreePatFiles: function () {
        // start with first one, when it is done a call is made to get the next one myPat.getMyPatFile(1);
        myPat.getFreePatFile(0);
    },

    // read free pattern from wwww/data folder
    getFreePatFile: function (i) {

        if (i < myPat.freePatList.files.length) {
            myPat.patIndex = i;

            $.ajax({
                url: 'data/' + myPat.freePatList.files[myPat.patIndex].filename,
                type: "get",
                dataType: "text",
                success: function (data, textStatus, jqXHR) {

                    // read the title from the pattern
                    app.displayPatternInfo(myPat.freePatList.files[myPat.patIndex].filename, data, "f_");
                    myPat.getNextFreePatFile();
                },

                // just continue if could not read this file
                error: function (jqXHR, textStatus, errorThrown) {
                    myPat.getNextFreePatFile();
                }
            });
        }
    },

    // get the next pattern from the list
    // if no more patterns to read then refresh the list
    getNextFreePatFile: function () {
        myPat.patIndex++;
        if (myPat.patIndex < myPat.freePatList.files.length) {
            myPat.getFreePatFile(myPat.patIndex);
        }

        // done getting all free pattern titles
        // now get all not bought pattern titles
        else {
            myPat.getAllNotBoughtPatTitles();
        }
    },

    // get all not bought pattern titles
    getAllNotBoughtPatTitles: function (){
        var patList = $('#patlist');
        if (patList !== undefined && patList.length > 0){
            patList.listview('refresh');
        }
        myPat.getAllMyPatFiles();       
    }
};
