﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

// pattern file contents
var Pattern = function (patCanvas) {
    var _patCanvas = patCanvas;
    var _maxRows = 500;
    var _maxCols = 500;
    var _grid = "GRID";
    var _style = "STYLE";
    var _metric = "METRIC";
    var _english = "ENGLISH";
    var _counter = "COUNTER";
    var _gridColor = "GRIDCOLOR";
    var _shape = "SHAPE";
    var _ruler = "RULER";
    var _units = "UNITS";
    var _author = "AUTHOR";
    var _company = "COMPANY";
    var _website = "WEBSITE";
    var _copyright = "COPYRIGHT";
    var _userColors = "USERCOLORS";

    var _gray = "GRAY";
    var _white = "WHITE";
    var _black = "BLACK";
    var _solid = "SOLID";
    var _color = "COLOR";

    var _leftAxis = "LEFTAXIS";
    var _rightAxis = "RIGHTAXIS";
    var _topAxis = "TOPAXIS";
    var _bottomAxis = "BOTTOMAXIS";

    var _borderAxis = { "top": 0, "bottom": 0, "left": 0, "right": 0 };


    // different pattern types
    var _pattern = "pattern";
    var _stamp = "stamp";
    var _insert = "insert";
    var _border = "border";
    var _patternType = "pattern";
    // end different pattern types

    var _content = "";
    var _frameWidth = 10;
    var _origFrameWidth = 10;
    var _emptySqr = "#ZZZZZZ";
    var _oldEmptySqr = 0;
    var _filledSqr = "#000000";
    var _oldFilledSqr = 1;
    var _fourSqrTopLeft = "#2";
    var _fourSqrTopRight = "#3";
    var _fourSqrBotLeft = "#4";
    var _fourSqrBotRight = "#5";
    var _twoSqrLeft = "#6";
    var _twoSqrRight = "#7";
    var _trim = "#8";
    var _oldTrim = 8;
    var _pnull = "#9";
    var _popcorn = "#10";
    var _origWidth = 0;
    var _origHeight = 0;
    var _width = 0;
    var _height = 0;
    var _scaleFactor = 1;
    var _scaleOrigWidth = 0;
    var _scaleOrigHeight = 0;

    var _titleHeight = 20;
    var _origTitleHeight = 20;

    var _yes = "YES";
    var _no = "NO";

    var _regular = "REGULAR";
    var _diamond = "DIAMOND";
    var _oval = "OVAL";
    var _octagon4 = "OCTAGON4";
    var _octagon6 = "OCTAGON6";
    var _octagon8 = "OCTAGON8";

    var _size5 = "Size5";
    var _size10 = "Size10";
    var _size20 = "Size20";
    var _size30 = "Size30";
    var _sizeBW = "SizeBW";
    var _sizeSW = "SizeSW";
    var _sizeWW = "SizeWW";

    var _s5 = "5";
    var _s10 = "10";
    var _s20 = "20";
    var _s30 = "30";
    var _sBW = "BW";
    var _sSW = "SW";
    var _sWW = "WW";

    var _xInchesPerSqr5 = 0.277;
    var _xInchesPerSqr10 = 0.23;
    var _xInchesPerSqr20 = 0.22;
    var _xInchesPerSqr30 = 0.21;
    var _xInchesPerSqrBW = 0.7;
    var _xInchesPerSqrSW = 0.8;
    var _xInchesPerSqrWW = 0.9;

    var _yInchesPerSqr5 = 0.317;
    var _yInchesPerSqr10 = 0.25;
    var _yInchesPerSqr20 = 0.24;
    var _yInchesPerSqr30 = 0.23;
    var _yInchesPerSqrBW = 0.72;
    var _yInchesPerSqrSW = 0.82;
    var _yInchesPerSqrWW = 0.92;

    var _xCMeterPerSqr5 = 0.70358;
    var _xCMeterPerSqr10 = 0.58420;
    var _xCMeterPerSqr20 = 0.55880;
    var _xCMeterPerSqr30 = 0.53340;
    var _xCMeterPerSqrBW = 1.77800;
    var _xCMeterPerSqrSW = 2.03200;
    var _xCMeterPerSqrWW = 2.28600;

    var _yCMeterPerSqr5 = 0.80518;
    var _yCMeterPerSqr10 = 0.63500;
    var _yCMeterPerSqr20 = 0.60960;
    var _yCMeterPerSqr30 = 0.58420;
    var _yCMeterPerSqrBW = 1.82880;
    var _yCMeterPerSqrSW = 2.08280;
    var _yCMeterPerSqrWW = 2.33680;

    //single crochet as fill stitch
    var _xInchesPerSqr5S = 0.277;
    var _xInchesPerSqr10S = 0.23;
    var _xInchesPerSqr20S = 0.22;
    var _xInchesPerSqr30S = 0.21;
    var _xInchesPerSqrBWS = 0.7;
    var _xInchesPerSqrSWS = 0.8;
    var _xInchesPerSqrWWS = 0.9;

    var _yInchesPerSqr5S = 0.317;
    var _yInchesPerSqr10S = 0.25;
    var _yInchesPerSqr20S = 0.24;
    var _yInchesPerSqr30S = 0.23;
    var _yInchesPerSqrBWS = 0.72;
    var _yInchesPerSqrSWS = 0.82;
    var _yInchesPerSqrWWS = 0.92;

    var _xCMeterPerSqr5S = 0.70358;
    var _xCMeterPerSqr10S = 0.58420;
    var _xCMeterPerSqr20S = 0.55880;
    var _xCMeterPerSqr30S = 0.53340;
    var _xCMeterPerSqrBWS = 1.77800;
    var _xCMeterPerSqrSWS = 2.03200;
    var _xCMeterPerSqrWWS = 2.28600;

    var _yCMeterPerSqr5S = 0.80518;
    var _yCMeterPerSqr10S = 0.63500;
    var _yCMeterPerSqr20S = 0.60960;
    var _yCMeterPerSqr30S = 0.58420;
    var _yCMeterPerSqrBWS = 1.82880;
    var _yCMeterPerSqrSWS = 2.08280;
    var _yCMeterPerSqrWWS = 2.33680;

    var _size5Amount = 0.128;
    var _size10Amount = 0.114;
    var _size20Amount = 0.107;
    var _size30Amount = 0.1;
    var _sizeBWAmount = 0.1;
    var _sizeSWAmount = 0.29;
    var _sizeWWAmount = 0.33;


    var _authorChoice = "";
    var _companyChoice = "";
    var _websiteChoice = "";
    var _copyrightChoice = "";
    var _unitChoice = "ENGLISH";
    var _gridColorChoice = "";
    var _counterChoice = "";
    var _gridColorRefChoice = 0;
    var _shapeChoice = "REGULAR";
    var _threadSizeChoice = "Size20";
    var _colorChoice = 1;
    var _fgColor = 'black';
    var _errorMessage = "";
    var _btns = [];
    var _userDefColors = {};

    var _title = "";
    var _footer = "";
    var _rows = 0;
    var _cols = 0;
    var _totalSquares = 0;
    var _canvas;
    var _squareW;
    var _squareH;

    var _defRows = 100
    var _defCols = 20

    var _topOffset = 20;
    var _origTopOffset = 20;

    var _footerHeight = 40;
    var _origFooterHeight = 40;
    var _hlColor = '#FFC3CE';
    var _filledHlColor = '#6B824A';
    var _bgColor = "#f9eced";
    var _labelWidth = 20;

    var _font = { 'name': 'Calibri', 'size': '10', 'units': 'pt', 'weight': 'normal' };
    var _origFont = { 'name': 'Calibri', 'size': '10', 'units': 'pt', 'weight': 'normal' };

    var _top = 0;
    var _bot = 0;
    var _colStart;
    var _colEnd;
    var _context;

    var _btni = -1;
    var _btnj = -1;
    var _btniSave = -1;
    var _btnjSave = -1;

    var _create = false;
    var _editable = false;

    var _displaySymbols = false;

    this.setDisplaySymbols = function (displaySymbols) {
        _displaySymbols = displaySymbols;
    }
    this.getDisplaySymbols = function () {
        return _displaySymbols;
    }

    this.setEditable = function (editable) {
        _editable = editable;
    }

    this.getContent = function () {
        return _content;
    }
    this.setContent = function (content) {
        _content = content;
    }

    this.getCanvas = function () {
        return _canvas;
    },
    this.setCanvas = function (canvas) {
        _canvas = canvas;
    },

    this.getPatCanvas = function () {
        return _patCanvas;
    }
    this.setPatCanvas = function (patCanvas) {
        _patCanvas = patCanvas;
    }
    this.getContext = function () {
        return _context;
    },

    this.saveCanvasWidthHeight = function () {
        var patCanvas = $("#patCanvas");
        _width = patCanvas.width();
        _height = patCanvas.height();
    }

    this.saveCanvasOrigWidthHeight = function () {
        var patCanvas = $("#patCanvas");
        _origWidth = patCanvas[0].width;
        _origHeight = patCanvas[0].height;
    }

    this.saveCanvasScaleOrigWidthHeight = function () {
        var patCanvas = $("#patCanvas");
        _scaleOrigWidth = patCanvas[0].width;
        _scaleOrigHeight = patCanvas[0].height;
    }

    this.getWidth = function () {
        return _width;
    }
    this.getHeight = function () {
        return _height;
    }

    this.getSqrW = function () {
        return _squareW;
    }

    this.setSqrW = function (sqrW) {
        _squareW = sqrW;
    }
    this.getSqrH = function () {
        return _squareH;
    }

    this.setSqrH = function (sqrH) {
        _squareH = sqrH;
    }
    this.getBtns = function () {
        return _btns;
    }

    this.getRows = function () {
        return _rows;
    }
    this.setRows = function (rows) {
        _rows = rows;
    }

    this.getUserDefColors = function () {
        return _userDefColors;
    }

    this.getCols = function () {
        return _cols;
    }
    this.setCols = function (cols) {
        _cols = cols;
    }

    this.getTitle = function () {
        return _title;
    }
    this.setTitle = function (title) {
        _title = title;
    }

    this.getTopOffset = function () {
        return _topOffset;
    }
    this.setTopOffset = function (topOffset) {
        _topOffset = topOffset;
    }

    this.getLeftOffset = function () {
        return _frameWidth;
    }
    this.setLeftOffset = function (leftOffset) {
        _frameWidth = leftOffset;
    }
    this.getBorderAxis = function () {
        return _borderAxis;
    }
    this.setfilledSqrColor = function (color) {
        _filledSqr = color;
    }
    this.getfilledSqrColor = function () {
        return _filledSqr;
    }
    this.getColorCount = function (color) {
        var cnt = 0;
        var color = color.toLowerCase();
        for (var i = 0; i < _rows; i++) {
            for (var j = 0; j < _cols; j++) {
                if (_btns[i][j].toLowerCase() == color) {
                    cnt++;
                }
            }
        }
        return cnt;
    }

    this.getAllColorCounts = function () {
        var colorCounts = {};
        for (var i = 0; i < _rows; i++) {
            for (var j = 0; j < _cols; j++) {
                btnColor = _btns[i][j].toLowerCase();
                if (btnColor !== _trim) {
                    if (colorCounts[btnColor] !== undefined) {
                        colorCounts[btnColor] += 1;
                    }
                    else {
                        colorCounts[btnColor] = 1;
                    }
                }
            }
        }
        return colorCounts;
    }
    this.createNewPattern = function () {
        try {
            _title = "";
            _rows = _defRows;
            _cols = _defCols;
            for (var i = 0; i < _rows; i++) {
                _btns[i] = [];
                for (var j = 0; j < _cols; j++) {
                    _btns[i][j] = "#ZZZZZZ";
                }
            }
            _footer = "";
            _gridColorChoice = settings.gridColor;
            _counterChoice = settings.displayRC;
            _shapeChoice = _regular;
            _threadSizeChoice = _s20;
            _unitChoice = _english;
            _authorChoice = "";
            _companyChoice = "";
            _websiteChoice = "";
            _copyrightChoice = "";
            _create = true;
        }
        catch (err) {
            alert(err.message);
            return false;
        }
        return true;
    },

    this.createPatternContent = function () {
        var title = _title.replace(/\s/g, '');
        if (title.length == 0)
            title = '_';
        var str = _rows.toString() + ' ' + _cols.toString() + ' ' + title + ' 1 1 \n';
        for (i = 0; i < _rows; i++) {
            for (j = 0; j < _cols; j++) {
                str += _btns[i][j].toString();
            }
            str += '\n';
        }
        str += '_\n';
        str += 'TITLEFONT 16 7 0 0 700 \n';
        str += 'FOOTERFONT 16 7 0 0 700 \n';
        str += 'GRID ' + settings.gridColor + '\n';
        str += 'GRIDCOLOR 6252702\n';
        str += 'COUNTER ' + settings.displayRC + '\n';
        str += 'COUNTONTOP YES\n';
        str += 'ROWCDIR YES\n';
        str += 'COLCDIR YES\n';
        str += 'RCINCSIZE 10\n';
        str += 'RCCOLOR 0\n';
        str += 'RULER Size20\n';
        str += 'UNITS ENGLISH\n';
        str += 'PINHFACT 0\n';
        str += 'STYLE ' + settings.fillStyle + '\n';
        str += 'FILLSTITCH ' + settings.fillStitch + '\n';
        str += 'SHAPE REGULAR\n';
        str += 'COLOR 0\n';
        str += 'MULTCOLORS NO\n';
        return str;
    }
    this.readBtns = function (btns, rows, cols) {
        _gridColorChoice = settings.gridColor;
        _counterChoice = settings.displayRC;
        _btns = btns;
        _rows = rows;
        _cols = cols;
    },

    // read the contents of a pattern file
    this.readPattern = function (pattern) {

        try {
            _content = pattern;
            var lines = pattern.split(/\r\n|\r|\n/g);
            if (lines.length > 0) {
                var line = lines[0];
                var r = line.substring(0, line.indexOf(' '));
                line = line.substring(line.indexOf(' ') + 1);
                var c = line.substring(0, line.indexOf(' '));
                line = line.substring(line.indexOf(' ') + 1);
                if (line.indexOf(' ') > 0)
                    _title = line.substring(0, line.indexOf(' '));
                else
                    _title = line;
                _title = _title.replace(/_/g, " ");
                _title = _title.substring(_title.toLowerCase().indexOf("title"));

                _rows = parseInt(r);
                _cols = parseInt(c);
            }

            for (var i = 0; i < _rows; i++)
                _btns[i] = [];

            var idx = 0;
            while (idx < _rows && lines[idx + 1] !== undefined) {
                line = lines[idx + 1];

                // new file type
                if (line.indexOf("#") >= 0) {
                    var cols = line.split("#");
                    for (var k = 0; k < _cols; k++) {
                        var color = cols[k + 1] === undefined ? "#FFFFFF" : "#" + cols[k + 1];
                        _btns[idx][k] = color;
                    }
                }

                // old file type
                else {
                    for (var j = 0; j < _cols; j++) {
                        var len = line.length;
                        if (j + 1 <= len) {
                            c = line.substring(j, j + 1);
                            try {
                                _btns[idx][j] = parseInt(c);
                            }
                            catch (error) {
                                _btns[idx][j] = _oldEmptySqr;
                            }
                            if (_btns[idx][j] != _oldTrim)
                                _totalSquares++;
                            // convert to new squares
                            if (_btns[idx][j] === _oldFilledSqr) {
                                _btns[idx][j] = _filledSqr;
                            }
                            else if (_btns[idx][j] === _oldTrim) {
                                _btns[idx][j] = _trim;
                            }
                            else {
                                _btns[idx][j] = _emptySqr;
                            }
                        }
                        else {
                            _btns[idx][j] = _emptySqr;
                        }
                    }
                }
                idx++;
            }
            idx++;
            if (lines[idx] !== undefined) {
            }

            idx++;
            _gridColorChoice = settings.gridColor;
            _counterChoice = settings.displayRC;
            _borderAxis = { "top": 0, "bottom": 0, "left": 0, "right": 0 };
            while (lines[idx] !== undefined) {
                line = lines[idx];
                var index = line.indexOf(' ');
                if (index > 0) {
                    var vName = line.substring(0, index);
                    var value = line.substring(index + 1);

                    if (vName === _shape)
                        _shapeChoice = value;
                    else if (vName === _ruler)
                        _threadSizeChoice = value;
                    else if (vName === _units)
                        _unitChoice = value;
                    else if (vName === _author)
                        _authorChoice = value;
                    else if (vName === _company)
                        _companyChoice = value;
                    else if (vName === _website)
                        _websiteChoice = value;
                    else if (vName === _copyright)
                        _copyrightChoice = value;
                    else if (vName === _leftAxis)
                        _borderAxis.left = parseInt(value, 10);
                    else if (vName === _rightAxis)
                        _borderAxis.right = parseInt(value, 10);
                    else if (vName === _topAxis)
                        _borderAxis.top = parseInt(value, 10);
                    else if (vName === _bottomAxis)
                        _borderAxis.bottom = parseInt(value, 10);
                    else if (vName === _userColors) {
                        idx++;
                        var j = 0;
                        while (lines[idx] !== undefined) {
                            line = lines[idx]
                            var index = line.indexOf(' ');
                            if (index > 0) {
                                vName = line.substring(0, index);
                                value = line.substring(index + 1);
                                _userDefColors[j] = { "color": vName, "symbol": value };
                                j++;
                            }

                            idx++;
                        }
                    }
                }
                idx++;
                line = lines[idx];
            }
        }
        catch (err) {
            alert('Error reading pattern contents: ' + err.message);
            return false;
        }
        return true;
    }

    // create a new canvas with given width and height
    this.createCanvas = function (width, height) {
        try {
            var w = 0;
            var h = 0;

            // remove the old canvas
            var patCanvas = $("#patCanvas");
            if (patCanvas !== undefined && patCanvas.length !== undefined && patCanvas.length > 0) {
                w = patCanvas[0].width;
                h = patCanvas[0].height;
                patCanvas.hide();
                patCanvas.remove();
            }

            // 3 megapixles for mobile device with 256 meg memory
            if (width * height > 44000000) {
                var size = width * height;
                if (w !== 0)
                    width = w;
                if (h != 0)
                    height = h;
                // don't have any patterns this big so should never get here
                alert('too big:' + size + ": width=" + width + "height=" + height + "w=" + w + "h=" + h);
            }

            // create the new canvas
            var canvas = $('<canvas id="patCanvas" width="' + width + '" height="' + height + '" style="position:absolute;border: 1px solid #000000;top:0;left0;"></canvas>');
            var canvasDiv = $("#canvasDiv");
            canvasDiv.append(canvas);

            var canvas = $("#patCanvas");
            _canvas = canvas[0];
            _context = _canvas.getContext('2d');
            this.posResizeHandles();

        }
        catch (err) {
            alert('Error - createCanvas failed: ' + err.message);
            return false;
        }
        return true;
    }

    this.posResizeHandles = function () {
        var handle = $("#handle");
        var handlelr = $("#handlelr");
        var handleud = $("#handleud");
        if (_create || _editable) {
            var top = this.getTopOffset();
            var left = this.getLeftOffset();
            var patternDiv = $("#patternPage");
            var offset = patternDiv.offset();
            var patCanvas = $("#patCanvas");
            if (patCanvas !== undefined && patCanvas.length !== undefined && patCanvas.length > 0) {
                var w = patCanvas[0].width;
                var h = patCanvas[0].height;
                handle.css({ "top": offset.top + h - 32, "left": offset.left + w - 32 });
                handlelr.css({ "top": offset.top + h - 32 - 32 - 4, "left": offset.left + w - 20 });
                handleud.css({ "top": offset.top + h - 20, "left": offset.left + w - 32 - 32 - 4 });
            }
            handle.show();
            handlelr.show();
            handleud.show();
        }
        else {
            handle.hide();
            handlelr.hide();
            handleud.hide();
        }
    }
    this.getPixelColor = function (x, y) {
        x = Math.floor(x - app.patPageOffset.left);
        y = Math.floor(y - app.patPageOffset.top);
        var patCanvas = $("#patCanvas");
        var canvas = patCanvas[0];
        var context = canvas.getContext('2d');
        var p = context.getImageData(x, y, 1, 1).data;
        var hex = ColorConvert.rgbValToHex(p[0], p[1], p[2]);
        return hex;
    },

    this.getBeadColor = function (x, y) {
        var btn = this.mousexyToBtnij(x, y);
        if (btn !== null) {
            var color = _btns[btn.i][btn.j];
            return color;
        }
        return "#FFFFFF";
    },

    //http://www.williammalone.com/articles/html5-canvas-javascript-paint-bucket-tool/
    this.bucketFill = function (startX, startY, btn) {
        var color = _btns[btn.i][btn.j].toUpperCase();

        var colorBtn = $("#color");
        var newColor = colorBtn.css("background-color");
        newColor = ColorConvert.rgbToHex(newColor);
        if (newColor.toLowerCase() !== color.toLowerCase()) {

            // i = rows, j = cols
            var floodList = [[btn.i, btn.j]];


            while (floodList.length) {

                var newPos = floodList.pop();
                var r = newPos[0];
                var c = newPos[1];

                // Go up as long as the color matches and are inside the canvas
                while (r >= 0 && _btns[r][c].toUpperCase() === color) {
                    r -= 1;
                }
                r += 1;

                var reachLeft = false;
                var reachRight = false;

                // Go down as long as the color matches and in inside the canvas
                while (r < _rows && _btns[r][c].toUpperCase() === color) {

                    _btns[r][c] = newColor;
                    if (c > 0) {
                        if (_btns[r][c - 1].toUpperCase() === color) {
                            if (!reachLeft) {
                                floodList.push([r, c - 1]);
                                reachLeft = true;
                            }
                        }
                        else if (reachLeft) {
                            reachLeft = false;
                        }
                    }

                    if (c < _cols - 1) {
                        if (_btns[r][c + 1].toUpperCase() === color) {
                            if (!reachRight) {
                                floodList.push([r, c + 1]);
                                reachRight = true;
                            }
                        }
                        else if (reachRight) {
                            reachRight = false;
                        }
                    }
                    r++;
                }
            }
            this.drawSquares();
            return true;
        }
        return false;
    }

    this.clearPattern = function () {
        // clear the canvas
        _canvas = $("#patCanvas")[0];
        _context = _canvas.getContext('2d');
        _context.clearRect(0, 0, _canvas.width, _canvas.height);
    }

    this.clearGrid = function () {
        _canvas = $("#patCanvas")[0];
        _context = _canvas.getContext('2d');
        _context.moveTo(_frameWidth + (i * _squareW), _topOffset);
        _context.clearRect(_frameWidth, _topOffset, _frameWidth + (_cols * _squareW), _topOffset + (_rows * _squareH));
    }

    this.scalePattern = function (scaleFactor) {
        try {

            this.clearPattern();
            _scaleFactor = _scaleFactor + scaleFactor;

            var width = _scaleOrigWidth * _scaleFactor;
            var height = _scaleOrigHeight * _scaleFactor;

            this.createCanvas(width, height);
            _context.scale(_scaleFactor, _scaleFactor);
            this.clearPattern();

            this.drawTitle();
            this.drawFooter();
            this.drawGrid(1);
            if (settings.displayRC === settings.yesRC)
                this.drawRowColCounters();
            this.drawSquares();
        }
        catch (err) {
            alert('Error scaling pattern: ' + err.message);
            return false;
        }
        return true;
    }

    // zoom buttons use this function
    this.zoomInOutPattern = function (zoomAmount) {

        try {
            var patCanvas = $("#patCanvas");
            var width = patCanvas.width();
            var height = patCanvas.height();
            _squareW += zoomAmount;
            _squareH = _squareW + 2;
            var height = (_squareH * _rows) + _topOffset + _titleHeight + _footerHeight;
            var width = _frameWidth + (_squareW * _cols) + _labelWidth + 15;

            this.clearPattern();
            this.createCanvas(width, height);
            this.drawPattern();
            this.saveCanvasWidthHeight();

        }
        catch (err) {
            alert('Error trying to zoom pattern: ' + err.message);
            return false;
        }
        return true;
    }
    this.zoomPattern = function (diff) {

        try {
            var patCanvas = $("#patCanvas");
            var width = patCanvas.width();
            var height = patCanvas.height();

            if (diff > 0) {
                var newWidth = (width * .01) + width;
                var newHeight = (height * .01) + height;

                patCanvas.width(newWidth);
                patCanvas.height(newHeight);
            }
            else {
                var newWidth = (width * -.01) + width;
                var newHeight = (height * -.01) + height;

                if (newWidth > 250 && newHeight > 250) {
                    patCanvas.height(newHeight);
                    patCanvas.width(newWidth);
                }
            }
            this.saveCanvasWidthHeight();

        }
        catch (err) {
            alert('Error trying to zoom pattern: ' + err.message);
            return false;
        }
        return true;
    }

    this.resizePatternByDeltas = function (deltaRows, deltaCols) {

        if (deltaRows !== 0) {
            // if removing items
            if (deltaRows < 0) {
                // remove rows from bottom of pattern
                _btns.splice(deltaRows, -deltaRows);
            }
            // else adding items
            else {
                for (var i = _rows; i < _rows + deltaRows; i++) {
                    _btns[i] = [];
                    for (var j = 0; j < _cols; j++) {
                        _btns[i][j] = _emptySqr;
                    }
                }
            }
            _rows += deltaRows;
        }

        if (deltaCols !== 0) {
            // if removing cols
            if (deltaCols < 0) {
                // for each row remove cols at end of row
                for (var r = 0; r < _rows; r++) {
                    _btns[r].splice(deltaCols, -deltaCols);
                }
            }

            // else adding columns
            else {
                for (var r = 0; r < _rows; r++) {
                    for (var c = _cols; c < _cols + deltaCols; c++) {
                        _btns[r][c] = _emptySqr;
                    }
                }
            }
            _cols += deltaCols;
        }

        this.redrawPattern();
    }

    this.redrawPattern = function () {
        try {
            var patCanvas = $("#patCanvas");
            var width = patCanvas.width();
            var height = patCanvas.height();
            this.clearPattern();
            this.createCanvas(width, height);
            this.drawPattern();
        }
        catch (err) {
            alert('Error trying to redraw the pattern: ' + err.message);
            return false
        }
        return true;
    }

    this.redisplayPattern = function () {
        try {
            var patCanvas = $("#patCanvas");
            var width = patCanvas[0].width;
            var height = patCanvas[0].height;

            this.clearPattern();
            this.createCanvas(width, height);

            _gridColorChoice = settings.gridColor;
            _counterChoice = settings.displayRC;

            var canvas = $("#patCanvas");
            _canvas = canvas[0];
            _context = _canvas.getContext('2d');
            _context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;
            _context.clearRect(0, 0, _canvas.width, _canvas.height);

            this.drawTitle();
            this.drawFooter();
            this.drawGrid(1);
            if (settings.displayRC === settings.yesRC)
                this.drawRowColCounters();
            this.drawSquares();
            this.posResizeHandles();
        }
        catch (err) {
            alert('Error trying redisplay pattern: ' + err.message);
        }
    }

    this.redisplayInstructions = function () {
        _gridColorChoice = settings.gridColor;
        _counterChoice = settings.displayRC;
        this.displayInstructions();
    }

    // draw only grid and pattern squares
    this.drawGridPattern = function () {
        this.clearGrid();
        this.drawGrid(1);
        if (settings.displayRC === settings.yesRC)
            this.drawRowColCounters();
        this.drawSquares();
    }

    this.drawPattern = function () {

        try {
            _gridColorChoice = settings.gridColor;
            _counterChoice = settings.displayRC;

            // clear the canvas       
            var patCanvas = $("#patCanvas");
            this.clearPattern();

            // need to know the size of label 
            _context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;

            // use 4 characters because you need tick exterder length and space
            _labelWidth = _context.measureText('9999').width;

            var deltaMoveX = 0;
            var deltaMoveY = 0;
            var win = $(window);
            var w = win.width();
            var h = win.height();

            // remove the canvas
            patCanvas.hide();
            patCanvas.remove();

            // max size squares can be 
            _squareH = Math.floor((_canvas.height - _topOffset - _footerHeight) / _rows);
            var sqrMaxWidth = Math.floor((_canvas.width - _labelWidth) / _cols);
            if (sqrMaxWidth < _squareW)
                _squareW = sqrMaxWidth;
            _squareW = _squareH - 2;
            // create new canvas based on new height and width
            var height = (_squareH * _rows) + _topOffset + _titleHeight + _footerHeight; // +30;
            var width = _frameWidth + (_squareW * _cols) + _labelWidth + 15;
            var success = this.createCanvas(width, height);
            if (!success)
                return false;

            // set the font in the new canvas
            _context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;
            _labelWidth = _context.measureText('9999').width;

            this.drawTitle();
            this.drawFooter();
            this.drawGrid(1);

            // if user wants rows/column counters displayed
            if (settings.displayRC === settings.yesRC)
                this.drawRowColCounters();
            this.drawSquares();

            // save new width and height of canvas
            _pat.saveCanvasWidthHeight();
        }
        catch (ev) {
            alert('Error displaying pattern 1: ' + ev.message);
            return false;
        }
        return true;
    }

    this.drawTitle = function () {
        var context = _canvas.getContext('2d');
        context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;
        context.fillStyle = 'black';
        context.strokeStyle = "black";
        context.fillText(_title, _frameWidth, _topOffset - 5);
    }

    this.drawFooter = function () {
        var context = _canvas.getContext('2d');
        context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;
        context.fillStyle = 'black';
        context.strokeStyle = "black";

        var y = _topOffset + (_rows * _squareH) + _footerHeight; // + 30
        context.fillText(_footer, _frameWidth, y);
    }


    this.drawGrid = function (lineWidth) {
        if (lineWidth === undefined) {
            lineWidth = 1;
        }
        var context = _canvas.getContext('2d');
        context.fillStyle = settings.gridColor;
        context.strokeStyle = settings.gridColor;

        // draw the cols
        for (var i = 0; i <= _cols; i++) {
            context.beginPath();
            context.lineWidth = lineWidth;
            context.moveTo(_frameWidth + (i * _squareW), _topOffset);
            context.lineTo(_frameWidth + (i * _squareW), _topOffset + (_squareH * _rows));
            context.stroke();
        }
        // draw the rows
        for (var i = 0; i <= _rows; i++) {
            context.beginPath();
            context.lineWidth = lineWidth;
            context.moveTo(_frameWidth, _topOffset + (i * _squareH));
            context.lineTo(_frameWidth + (_squareW * _cols), _topOffset + (i * _squareH));
            context.stroke();
        }
    }

    this.drawRowColCounters = function () {
        var context = _canvas.getContext('2d');
        context.font = _font.weight + ' ' + _font.size + _font.units + ' ' + _font.name;
        context.fillStyle = 'black';
        context.strokeStyle = "black";
        
        // col numbers
        for (var i = 0; i <= _cols; i += 10) {
            var x = _frameWidth + (i * _squareW);
            var y = _topOffset + (_squareH * _rows) + _titleHeight;
            if (i == 0)
                context.fillText("1", x + _squareW / 2, y);
            else
                context.fillText(i.toString(), x - _squareW, y);
        }

        // row numbers
        for (var i = 0; i <= _rows; i += 10) {
            var x = _frameWidth + (_squareW * _cols) + 15;
            var y = _topOffset + (i * _squareH);
            if (i == 0)
                context.fillText("1", x, y + _squareH);
            else
                context.fillText(i.toString(), x, y - (_squareH / 3));
        }

        // column counter grid lines
        for (var i = 0; i < _cols; i += 10) {
            context.beginPath();
            context.lineWidth = 1;
            context.moveTo(_frameWidth + (i * _squareW), _topOffset);
            context.lineTo(_frameWidth + (i * _squareW), _topOffset + (_squareH * _rows) + 7);
            context.stroke();

        }

        // row counter grid lines
        for (var i = 0; i < _rows; i += 10) {
            context.beginPath();
            context.lineWidth = 3;
            context.moveTo(_frameWidth, _topOffset + (i * _squareH));
            context.lineTo(_frameWidth + (_squareW * _cols) + 7, _topOffset + (i * _squareH));
            context.stroke();
        }
    }

    this.drawSquares = function () {
        var context = _canvas.getContext('2d');

        context.lineWidth = .5;
        for (var i = 0; i < _rows; i++) {
            for (var j = 0; j < _cols; j++) {
                if (_btns[i][j] != 0) {
                    var x = (j * _squareW) + _frameWidth;
                    var y = (i * _squareH) + _topOffset;
                    if (_btns[i][j] === _trim) {
                        var right = _trim;
                        var bottomLeft = _trim;
                        var bottomRight = _trim;
                        if (j + 1 < _cols)
                            right = _btns[i][j + 1];

                        if (i + 1 < _rows)
                            bottom = _btns[i + 1][j];

                        if ((j + 1 < _cols) && (i + 1 < _rows))
                            bottomRight = _btns[i + 1][j + 1];

                        this.drawTrim(x, y, _btns[i][j], right, bottom, bottomRight, false);
                    }
                    else {
                        this.drawFilledSquare(x, y, _btns[i][j], false);
                    }
                }
            }
        }
    }
    this.drawFilledSquare = function (x, y, btn, highlight) {
        var context = _canvas.getContext('2d');
        var beadStyle = settings.beadStyle;
        context.lineWidth = .5;
        context.fillStyle = btn;

        if (highlight)
            context.fillStyle = _filledHlColor;
        if (_squareW - 2 <= 0) {
            if (btn.toUpperCase() === _emptySqr) {
                context.fillStyle = "#FFFFFF";
            }
            context.fillRect(x + 1, y + 1, 1, _squareH - 1);
        }
        else {

            // no bead here then draw a white background
            if (btn.toUpperCase() === _emptySqr) {
                context.fillStyle = "#FFFFFF";
                context.fillRect(x + 1, y + 1, _squareW - 2, _squareH - 2);
            }

            // display square as a real bead
            else if (beadStyle === settings.beadBead && btn.toUpperCase() !== _emptySqr && _patternType === _pattern) {

                var rectX = x - 2;
                var rectY = y - 1;
                var rectWidth = _squareW + 2;
                var rectHeight = _squareH + 2;
                var lineWidth = .2;

                var cornerRadius = rectHeight / 5;
                Bead.drawBead(context, x, y, _squareW, _squareH, btn, cornerRadius, lineWidth, true, true);
                if (_displaySymbols) {
                    var symbol = ColorSelector.getExistingColorSymbol(btn);
                    if (symbol !== "") {
                        symbol = String.fromCharCode(symbol);
                    }
                    Bead.drawSymbolOnBead(context, symbol, x + 2, y + _squareH - 2, _squareW, _squareH, btn)
                }
            }

            // display square as solid color
            else {
                context.fillRect(x + 1, y + 1, _squareW - 2, _squareH - 2);
                if (_displaySymbols) {
                    var symbol = ColorSelector.getExistingColorSymbol(btn);
                    if (symbol !== "") {
                        symbol = String.fromCharCode(symbol);
                    }
                    Bead.drawSymbolOnBead(context, symbol, x + 2, y + _squareH - 2, _squareW, _squareH, btn)
                }
            }
        }
    },

    this.drawFourSquare = function (x, y, btn, highlight, clear) {
        var context = _canvas.getContext('2d');
        context.lineWidth = .5;
        if (btn == _fourSqrTopLeft) {

            // clear out background
            context.fillStyle = _bgColor;

            if (clear) {
                context.fillRect(x, y, 2 * _squareW, 2 * _squareH);
            }

            // have to redraw the highlight color
            if (highlight) {
                context.fillStyle = _hlColor;
                context.fillRect(x, y, _squareW, _squareH);
            }

            // draw 4 square
            context.strokeStyle = _fgColor;
            context.lineWidth = .5;
            context.strokeRect(x, y, 2 * _squareW, 2 * _squareH);

            context.beginPath();
            context.strokeStyle = _fgColor;
            context.lineWidth = .5;
            context.arc(x + 1, y + (2 * _squareH) + 1, _squareW, 1.5 * Math.PI, 0, false);
            context.stroke();

            context.beginPath();
            context.strokeStyle = _fgColor;
            context.lineWidth = .5;
            context.arc(x + 2 * _squareW, y + (2 * _squareH) + 1, _squareH, 1.5 * Math.PI, Math.PI, true);
            context.stroke();
        }

        else if (btn == _fourSqrTopRight || btn == _fourSqrBotLeft || btn == _fourSqrBotRight) {
            if (highlight) {
                try {
                    context.fillStyle = _hlColor;
                    context.fillRect(x, y, _squareW, _squareH);

                    if (btn == _fourSqrTopRight) {
                        btn = _fourSqrTopLeft;
                        this.drawFourSquare(x - _squareW, y, btn, false, false);
                    }
                    else if (btn == _fourSqrBotLeft) {
                        btn = _fourSqrTopLeft;
                        this.drawFourSquare(x, y - _squareW, btn, false, false);
                    }
                    else if (btn == _fourSqrBotRight) {
                        btn = _fourSqrTopLeft;
                        this.drawFourSquare(x - _squareW, y - _squareH, btn, false, false);
                    }
                }
                catch (e) {
                    alert(e.message);
                }
            }
        }
    }

    this.drawTwoSquare = function (x, y, btn, highlight) {
        var context = _canvas.getContext('2d');
        if (btn == _twoSqrLeft) {
            // clear out background
            context.fillStyle = _bgColor;
            context.strokeStyle = _fgColor;
            context.lineWidth = .5;
            if (_squareW <= 2) {
                context.fillRect(x + 1, y + 1, (2 * _squareW), _squareH);
                context.strokeRect(x, y, (2 * _squareW) + 1, _squareH + 1);
            }
            else {
                context.fillRect(x + 1, y + 1, (2 * _squareW) - 2, _squareH - 2);
                context.strokeRect(x, y, (2 * _squareW), _squareH);
            }
        }

        if (btn == _twoSqrLeft || btn == _twoSqrRight) {
            if (highlight) {
                context.lineWidth = .5;
                context.fillStyle = _hlColor;
                context.fillRect(x + 1, y + 1, _squareW - 2, _squareH - 2);
            }
        }
    }

    this.drawTrim = function (x, y, btn, right, bot, botRight, highlight) {
        var context = _canvas.getContext('2d');
        if (btn == _trim) {
            context.fillStyle = _bgColor;
            context.lineWidth = .5;

            if (right == _trim && bot == _trim && botRight == _trim)
                context.fillRect(x + 1, y + 1, (2 * _squareW) - 2, (2 * _squareH) - 2);
            if (right == _trim)
                context.fillRect(x + 1, y + 1, (2 * _squareW) - 2, _squareH - 2);

            if (bot == _trim) {
                context.fillRect(x + 1, y + 1, _squareW - 2, (2 * _squareH) - 2);
            }

            if (highlight) {
                context.fillStyle = _hlColor;
                context.fillRect(x + 1, y + 1, _squareW - 2, _squareH - 2);
            }
        }
    }
    this.drawPopcorn = function (x, y, btn, highlight) {

        var context = _canvas.getContext('2d');
        if (btn == _popcorn) {
            if (highlight)
            // highlight background
                context.fillStyle = _hlColor;
            else
            // clear out background
                context.fillStyle = _bgColor;
            context.fillRect(x + 1, y + 1, _squareW - 2, _squareH - 2);

            // draw popcorn
            var centerX = x + (_squareW / 2);
            var centerY = y + (_squareH / 2);
            var radius = (_squareW - 2) / 4;
            if (radius < 0)
                radius = 2;

            // save state
            context.save();

            // translate context
            context.translate(centerX, centerY);

            // scale context horizontally
            context.scale(1.5, 2);

            context.beginPath();
            context.arc(0, 0, radius, 0, 2 * Math.PI, false);

            // restore to original state
            context.restore();
            context.lineWidth = .5;
            context.stokeStyle = _fgColor;
            context.stroke();
        }
    }

    this.displayInstructions = function () {

        var rectWidth = 20;
        var rectHeight = 30;
        var yDelta = 0;
        var instrText = '';

        // total number of beads to display
        var colorCnts = this.getAllColorCounts();
        var total = 0;
        $.each(colorCnts, function (color, count) {
            total++;
        });

        var canvas = $("#instrBeadCanvas");
        canvas[0].width = $(window).width();
        var windowHeight = $(window).height();

        // total beads height + pattern title height + "Bead colors:" height 
        var totalHeight = (total * (rectHeight + 5)) + 70;

        if (totalHeight < windowHeight) {
            totalHeight = windowHeight;
        }

        canvas[0].height = totalHeight;

        var ctx = canvas[0].getContext("2d");
        ctx.font = "18px Arial";
        ctx.fillStyle = "black";
        ctx.clearRect(0, 0, canvas[0].width, canvas[0].height);
        if (_title != null && _title != undefined && _title.length > 0) {
            ctx.fillText(_title, 0, yDelta += 25);
        }
        ctx.fillText("Bead colors:", 0, yDelta += 25);
        var writtenName = "";

        var rectX = 0;
        var rectY = yDelta + 20;

        var cornerRadius = 5;
        var lineWidth = 1;

        $.each(colorCnts, function (color, count) {

            // no bead here if it is #ZZZZZZ
            if (color.toUpperCase() !== _emptySqr) {

                // display color as solid rectangle
                ctx.fillStyle = color;
                ctx.fillRect(rectX, rectY, rectWidth, rectHeight);

                // display bead
                Bead.drawBead(ctx, rectX + 30, rectY, rectWidth, rectHeight, color, cornerRadius, lineWidth, true, true);
                var symbol = ColorSelector.getExistingColorSymbol(color);
                if (symbol !== "") {
                    symbol = String.fromCharCode(symbol);
                }

                // display bead's symbol
                Bead.drawSymbol(ctx, symbol, rectX + 55, rectY + rectHeight - 9, rectWidth, rectHeight, color);

                // display total beads used
                ctx.font = "18px Arial";
                ctx.fillStyle = "black";
                ctx.lineWidth = 1;
                ctx.fillText("- " + count.toString() + " beads", rectX + 55 + rectWidth + 5, rectY + rectHeight - 5);

                rectY += rectHeight + 5;
            }
        });


        instrText = "";
        var xPerSqr = 0.0;
        var yPerSqr = 0.0;
        var amountFactor = 0.0;

        var patWidth = 0.0;
        var patHeight = 0.0;
    }


    this.calcNonTrimRowsTopBot = function () {
        _top = -1;
        _bot = -1;

        // find first row without trims in the middle
        //
        var i = 0;
        var done = false;
        _colStart = 0;
        _colEnd = _cols - 1;

        // starting at top
        // check for first row with no trims in the middle.
        // because we could start at a point and then move down and find more points
        // we have to keep checking rows till we find points going the other way
        //
        //     /\     <-- start (first row with no trims in middle)
        //    /  \       /\    <--- keep looking because we may find another pt
        //   /    \-----/  \    <---- firstNonTrimRowFromTop
        //   |              |
        //   |              |
        //   \           ---
        //    -----\    /    <--- done = true
        //          \  /
        //           \/
        while ((i < _rows) && !done) {

            // get first non trim sqr in row
            // starting at end and working backward find first non trim sqr from end
            var nonTrimFound = this.getNonTrimColStartEnd(i);

            if (nonTrimFound) {

                // starting from first non trim col
                // find any trims in the middle
                // exclude trims found at end
                var j = _colStart + 1;
                var foundTrim = false;
                while (j <= _colEnd && !foundTrim && !done) {
                    if (_btns[i][j] == _trim) {
                        var ii = i - 1;
                        var filledAbove = false;
                        while (ii >= 0 && !filledAbove) {
                            if (_btns[ii][j] != _trim)
                                filledAbove = true;
                            ii--;
                        }
                        ii = i + 1;
                        var filledBelow = false;
                        while (ii < _rows - 1 && !filledBelow) {
                            if (_btns[ii][j] != _trim)
                                filledBelow = true;
                            ii++;
                        }

                        // if there are only trims above but filled squares below we know
                        // we found a point
                        if (!filledAbove && filledBelow) {
                            foundTrim = true;
                        }

                        // if only trims below we are done looking cause point upside down
                        if (!filledBelow) {
                            done = true;
                        }

                    }
                    j++;
                }

                // we found a point
                if (foundTrim) {
                    _top = -1;
                }
                else if (done) {
                    if (_top == -1)
                        _top = i - 1;
                }

                else {
                    if (_top == -1) {
                        _top = i;
                    }
                }
            }
            i++;
        }

        // starting from bottom and working up
        // find first row that does not have trims in the middle and save the row
        // number in  firstNonTrimRowFromBot for later use
        i = _rows - 1;
        _bot = -1;
        var done2 = false;
        while ((i >= _top) && !done2) {
            // get first non trim sqr in row
            // starting at end and working backward find first non trim sqr from end
            if (this.getNonTrimColStartEnd(i)) {

                // find any trims in the middle
                var j = _colStart + 1;
                var foundTrim = false;
                var splitDouble = false;

                while (j < _colEnd && !foundTrim && !splitDouble) {
                    if (_btns[i][j] == _trim) {
                        var ii = i - 1;
                        var filledAbove = false;
                        while (ii >= 0 && !filledAbove) {
                            if (_btns[ii][j] != _trim)
                                filledAbove = true;
                            ii--;
                        }
                        ii = i + 1;
                        var filledBelow = false;
                        while (ii < _rows - 1 && !filledBelow) {
                            if (_btns[ii][j] != _trim)
                                filledBelow = true;
                            ii++;
                        }

                        // if there are only trims below but filled squares above we know
                        // we found a point
                        if (filledAbove && !filledBelow) {
                            foundTrim = true;
                        }
                    }

                    else if ((_btns[i][j] == _fourSqrTopRight) || (_btns[i][j] == _fourSqrTopLeft)) {
                        splitDouble = true;
                    }
                    j++;
                }
                if (!foundTrim && !splitDouble) {
                    _bot = i;
                    done2 = true;
                }
            }
            i--;
        }

        // could not find a place to split
        if (_bot == -1) {
            _bot = _top;
        }
    }

    this.getNonTrimColStartEnd = function (row) {
        _colStart = 0;
        _colEnd = _cols - 1;

        // find first non trim in this row
        var foundStart = false;
        while ((_colStart < _cols) && !foundStart) {
            if (_btns[row][_colStart] == _trim)
                _colStart++;
            else
                foundStart = true;
        }
        // found the last non trim sqr in this row
        var foundEnd = false;
        while (_colEnd >= 0 && !foundEnd) {
            if (_btns[row][_colEnd] == _trim)
                _colEnd--;
            else
                foundEnd = true;
        }
        return (foundStart && foundEnd);
    }

    this.mousexyToBtnij = function (x, y) {
        var j = Math.floor((x - _frameWidth - app.patPageOffset.left) / _squareW);

        //var patPage = $("#patternPage");
        //var offset = patPage.offset();
        var i = Math.floor((y - _topOffset - app.patPageOffset.top) / _squareH);
        if (j >= 0 && j < _cols && i >= 0 && i < _rows) {
            var btni = i;
            var btnj = j;
            return { i: btni, j: btnj };
        }
        return null;
    }

    this.btnijToxy = function (i, j) {

        var x = (j * _squareW) + _frameWidth;
        var y = (i * _squareH) + _topOffset;
        return { x: x, y: y };
    }


    this.fillSquare = function (x, y) {
        try {
            var btn = this.mousexyToBtnij(x, y);
            if (btn !== null) {
                this.clearTwoFourSquares(btn.i, btn.j);
                _btns[btn.i][btn.j] = _filledSqr;

                var position = this.btnijToxy(btn.i, btn.j);
                this.drawFilledSquare(position.x, position.y, _btns[btn.i][btn.j], false);
            }
        }
        catch (err) {
            alert('Error trying to fill pattern square: ' + err.message);
        }
    },

    this.ClearRowsColsRange = function (startRow, startCol, numRows, numCols) {
        for (var i = startRow; i < startRow + numRows; i++) {
            for (var j = startCol; j < startCol + numCols; j++) {

                _btns[i][j] = _emptySqr;
                var position = this.btnijToxy(i, j);
                this.drawClearSquare(position.x, position.y, _btns[i][j], false);
            }
        }
    },
    this.clearSquare = function (x, y) {
        try {
            var btn = this.mousexyToBtnij(x, y);
            if (btn !== null) {

                _btns[btn.i][btn.j] = _emptySqr;
                var position = this.btnijToxy(btn.i, btn.j);
                this.drawClearSquare(position.x, position.y, _btns[btn.i][btn.j], false);

            }
        }
        catch (err) {
            alert('Error trying to fill pattern square: ' + err.message);
        }
    },

    this.fourSquare = function (x, y) {
        try {

            var btn = this.mousexyToBtnij(x, y);
            if (btn !== null) {
                if (btn.i + 1 < _rows && btn.j + 1 < _cols) {
                    var sqr1isClear = this.clearTwoFourSquares(btn.i, btn.j);
                    var sqr2isClear = this.clearTwoFourSquares(btn.i, btn.j + 1);
                    var sqr3isClear = this.clearTwoFourSquares(btn.i + 1, btn.j);
                    var sqr4isClear = this.clearTwoFourSquares(btn.i + 1, btn.j + 1);

                    if (sqr1isClear && sqr2isClear && sqr3isClear && sqr4isClear) {

                        _btns[btn.i][btn.j] = _fourSqrTopLeft;
                        _btns[btn.i][btn.j + 1] = _fourSqrTopRight;
                        _btns[btn.i + 1][btn.j] = _fourSqrBotLeft;
                        _btns[btn.i + 1][btn.j + 1] = _fourSqrBotRight;

                        var position = this.btnijToxy(btn.i, btn.j);
                        this.drawFourSquare(position.x, position.y, _btns[btn.i][btn.j], false, true);
                    }
                }
            }
        }
        catch (err) {
            alert('Error trying to fill pattern square: ' + err.message);
        }
    },
    this.twoSquare = function (x, y) {
        try {
            var btn = this.mousexyToBtnij(x, y);
            if (btn !== null) {
                if (btn.j + 1 < _cols) {
                    var sqr1isClear = this.clearTwoFourSquares(btn.i, btn.j);
                    var sqr2isClear = this.clearTwoFourSquares(btn.i, btn.j + 1);
                    if (sqr1isClear && sqr2isClear) {
                        _btns[btn.i][btn.j] = _twoSqrLeft;
                        _btns[btn.i][btn.j + 1] = _twoSqrRight;
                        var position = this.btnijToxy(btn.i, btn.j);
                        this.drawTwoSquare(position.x, position.y, _btns[btn.i][btn.j], false);
                    }
                }
            }
        }
        catch (err) {
            alert('Error trying to fill pattern square: ' + err.message);
        }
    },

    this.trimSquare = function (x, y) {
        try {
            var btn = this.mousexyToBtnij(x, y);
            if (btn !== null) {
                this.clearTwoFourSquares(btn.i, btn.j);


                _btns[btn.i][btn.j] = _trim;
                var position = this.btnijToxy(btn.i, btn.j);
                this.drawNewTrim(position.x, position.y, btn.i, btn.j, false);
            }
        }
        catch (err) {
            alert('Error trying to fill pattern square: ' + err.message);
        }
    },

    // clear out the square
    this.drawClearSquare = function (x, y, btn, highlight) {
        var context = _canvas.getContext('2d');
        // fill square solid
        if (btn === _emptySqr) {
            context.lineWidth = .5;
            context.fillStyle = "#FFFFFF";
            if (highlight)
                context.fillStyle = _filledHlColor;
            if (_squareW - 2 <= 0) {
                context.fillRect(x + 1, y + 1, 1, 1);
            }
            else {
                context.strokeStyle = settings.gridColor;
                context.fillRect(x - 1, y - 1, _squareW + 1, _squareH + 1);
                context.strokeRect(x, y, _squareW, _squareH);
            }
        }
    },


    // clear two squre or four square under the mouse click
    this.clearTwoFourSquares = function (i, j) {
        var ii = i;
        var jj = j;
        var type = _fourSqrTopLeft;
        var btn = _btns[i][j];
        switch (btn) {
            case _fourSqrTopLeft:
                ii = i;
                jj = j;
                type = _fourSqrTopLeft;
                break;
            case _fourSqrTopRight:
                ii = i;
                jj = j - 1;
                type = _fourSqrTopLeft;
                break;
            case _fourSqrBotLeft:
                ii = i - 1;
                jj = j;
                type = _fourSqrTopLeft;
                break;
            case _fourSqrBotRight:
                ii = i - 1;
                jj = j - 1;
                type = _fourSqrTopLeft;
                break;
            case _twoSqrLeft:
                ii = i;
                jj = j;
                type = _twoSqrLeft;
                break;
            case _twoSqrRight:
                ii = i;
                jj = j - 1;
                type = _twoSqrLeft;
                break;
            default:
                type = 0;
                break;

        }
        if (type === _fourSqrTopLeft) {
            if (editor.selected !== "foursqr") {
                _btns[ii][jj] = _emptySqr;
                var position = this.btnijToxy(ii, jj);
                this.drawClearSquare(position.x, position.y, _btns[ii][jj], false);
                _btns[ii][jj + 1] = _emptySqr;
                var position = this.btnijToxy(ii, jj + 1);
                this.drawClearSquare(position.x, position.y, _btns[ii][jj + 1], false);
                _btns[ii + 1][jj] = _emptySqr;
                var position = this.btnijToxy(ii + 1, jj);
                this.drawClearSquare(position.x, position.y, _btns[ii + 1][jj], false);
                _btns[ii + 1][jj + 1] = _emptySqr;
                var position = this.btnijToxy(ii + 1, jj + 1);
                this.drawClearSquare(position.x, position.y, _btns[ii + 1][jj + 1], false);
                return true;
            }
            else {
                return false;
            }
        }
        else if (type === _twoSqrLeft) {
            if (editor.selected !== "twosqr") {
                _btns[ii][jj] = _emptySqr;
                var position = this.btnijToxy(ii, jj);
                this.drawClearSquare(position.x, position.y, _btns[ii][jj], false);
                _btns[ii][jj + 1] = _emptySqr;
                var position = this.btnijToxy(ii, jj + 1);
                this.drawClearSquare(position.x, position.y, _btns[ii][jj + 1], false);
                return true;
            }
            else {
                return false;
            }
        }
        return true;
    },

    this.drawNewTrim = function (x, y, i, j, highlight) {
        var x1 = x;
        var y1 = y;
        var x2 = x + _squareW;
        var y2 = y + _squareH;

        var context = _canvas.getContext('2d');
        context.lineWidth = .5;
        context.fillStyle = _bgColor;
        if (highlight)
            context.fillStyle = _filledHlColor;

        var ii = i - 1;
        while (ii > 0 && _btns[ii][j] === _trim) {
            y1 = y1 - _squareW;
            ii--;
        }
        y1 = y1 + 1;

        ii = i + 1;
        while (ii < _rows - 1 && _btns[ii][j] === _trim) {
            y2 = y2 + _squareH;
            ii++;
        }
        y2 = y2 - 2;
        x1 = x1 + 1;
        x2 = x2 - 2;
        var w = x2 - x1;
        var h = y2 - y1;
        context.fillRect(x1 + 1, y1, w, h);

        x1 = x;
        y1 = y;
        x2 = x + _squareW;
        y2 = y + _squareH;

        var jj = j - 1;
        while (jj > 0 && _btns[i][jj] === _trim) {
            x1 = x1 - _squareW;
            jj--;
        }
        x1 = x1 + 1;

        jj = j + 1;
        while (jj < _cols - 1 && _btns[i][jj] === _trim) {
            x2 = x2 + _squareW;
            jj++;
        }
        x2 = x2 - 2;

        y1 = y1 + 1;
        y2 = y2 - 2;
        w = x2 - x1;
        h = y2 - y1;
        context.fillRect(x1, y1, w, h);
    },
    // called when user selects save button to display pattern in save dialog
    this.drawFinishedProdPic = function (canvas) {
        this.drawViewOnlyPattern("black", "white", canvas, 0, 0, 4, 5, true, true);
    },
    this.drawStamp = function (canvas, x, y, sqW, sqH) {
        _patternType = _stamp;
        this.drawViewOnlyPattern("black", "white", canvas, x, y, sqW, sqH, false, false);
    },
    this.drawMovePat = function (canvas, x, y, sqW, sqH) {
        canvas.css({ "opacity": 1.0 });
        this.drawViewOnlyPattern("black", "white", canvas, x, y, sqW, sqH, false, false);

        // draw blueish box around the move box
        var context = canvas[0].getContext('2d');
        context.strokeStyle = "#1b7ec1";
        context.lineWidth = 1;
        context.rect(x + 1, y + 1, (_cols * _squareW) - 2, (_rows * _squareH) - 2);
        context.stroke();
    },

    // draw the insert in the insert dialog box, or draw the insert on the pattern inside a movable box
    this.drawInsert = function (canvas, x, y, sqW, sqH) {
        _patternType = _insert;
        if (sqW == 0 && sqH == 0) {
            var w = canvas.width() / _cols;
            var h = canvas.height() / _rows;

            canvas[0].width = canvas.width();
            canvas[0].height = canvas.height();
            var sqWH = w < h ? w : h;

            this.drawViewOnlyPattern("black", "white", canvas, 0, 0, sqWH, sqWH, false, false);
        }
        else {
            this.drawViewOnlyPattern("black", "white", canvas, x, y, sqW, sqH, false, false);
        }
    },

    // draw border in borders dialog box
    this.drawBorder = function (canvas, x, y, bordersWidth) {
        _patternType = _border;
        var w = bordersWidth / _cols;
        var h = bordersWidth / _rows;
        //var sqWH = w < h ? w : h;
        this.drawViewOnlyPattern("black", "white", canvas, x, y, w, h, false, false);
    }

    this.drawViewOnlyPattern = function (fgColor, bgColor, canvas, xOffset, yOffset, sqW, sqH, fit, save) {

        var saveSquareW = _squareW;
        var saveSquareH = _squareH;
        var saveFgColor = _fgColor;
        var saveBgColor = _bgColor;
        var saveFrameWidth = _frameWidth;
        var saveTopOffset = _topOffset;
        var saveCanvas = _canvas;
        var saveBtni = _btni;
        var saveBtnj = _btnj;
        var saveDisplaySymbols = _displaySymbols;

        var saveGridColor = settings.gridColor;

        var saveBeadStyle = settings.beadStyle;

        _squareW = sqW;
        _squareH = sqH;
        _fgColor = fgColor;
        _bgColor = bgColor;
        _frameWidth = xOffset;
        _topOffset = yOffset;
        _canvas = canvas[0];
        _btni = -1;
        _btnj = -1;
        settings.gridColor = _fgColor;
        var context = canvas[0].getContext('2d');
        if (save) {
            settings.beadStyle = settings.beadSolid;
            _displaySymbols = false;
        }

        // if make canvas fit pattern
        if (fit) {

            canvas.width(_cols * _squareW + 3);
            canvas.height(_rows * _squareH + 3);

            canvas[0].width = _cols * _squareW + 3;
            canvas[0].height = _rows * _squareH + 3;

            context.fillStyle = _bgColor;
            context.fillRect(0, 0, _cols * _squareW + 3, _rows * _squareH + 3);
            _frameWidth = 2;
        }
        else {
            context.fillStyle = _bgColor;
            context.fillRect(_frameWidth, _topOffset, _cols * _squareW + 1, _rows * _squareH + 1);
        }
        var lineWidth = fit && save ? .5 : 1;
        this.drawGrid(lineWidth);

        this.drawSquares();
        if (save) {
            _squareW = saveSquareW;
            _squareH = saveSquareH;
            _fgColor = saveFgColor;
            _bgColor = saveBgColor;
            _frameWidth = saveFrameWidth;
            _topOffset = saveTopOffset;
            _canvas = saveCanvas;
            _btni = saveBtni;
            _btnj = saveBtnj;
            settings.gridColor = saveGridColor;
            settings.beadStyle = saveBeadStyle;
            _displaySymbols = saveDisplaySymbols;
        }
    },


    this.createTestNewPattern = function (canvas) {
        try {
            _title = "";
            _rows = _defRows;
            _cols = _defCols;
            for (var i = 0; i < _rows; i++) {
                _btns[i] = [];
                for (var j = 0; j < _cols; j++) {
                    _btns[i][j] = 0;
                }
            }
            _footer = "";
            _gridColorChoice = 'white';
            _counterChoice = 'yes';
            _shapeChoice = _regular;
            _threadSizeChoice = _s20;
            _unitChoice = _english;
            _authorChoice = "";
            _companyChoice = "";
            _websiteChoice = "";
            _copyrightChoice = "";
            _create = true;
            _squareW = 2;
            _squareH = 2 + 2;
            _topOffset = 0;
            _frameWidth = 0;
            var context = canvas[0].getContext('2d');
            canvas.width(_defCols * _squareW + 1);
            canvas.height(_defRows * _squareH + 1);
            context.fillStyle = "black";
            context.strokeStyle = "white";


            // draw the cols
            for (var i = 0; i <= _cols; i++) {
                context.beginPath();
                context.lineWidth = .5;
                context.moveTo(_frameWidth + (i * _squareW), _topOffset);
                context.lineTo(_frameWidth + (i * _squareW), _topOffset + (_squareH * _rows));
                context.stroke();
            }
            // draw the rows
            for (var i = 0; i <= _rows; i++) {
                context.beginPath();
                context.lineWidth = .5;
                context.moveTo(_frameWidth, _topOffset + (i * _squareH));
                context.lineTo(_frameWidth + (_squareW * _cols), _topOffset + (i * _squareH));
                context.stroke();
            }
        }
        catch (err) {
            alert(err.message);
            return false;
        }
        return true;
    },

    this.drawWhiteSquares = function (canvas) {

        _fgColor = "white";
        _bgColor = "green";

        var context = canvas[0].getContext('2d');
        context.lineWidth = .5;
        context.fillStyle = _fgColor;
        context.strokeStyle = _fgColor;


        for (var i = 0; i < _rows; i++) {
            for (var j = 0; j < _cols; j++) {

                if (_btns[i][j] != 0) {
                    var x = (j * _squareW);
                    var y = (i * _squareH);
                    if (_btns[i][j] === _filledSqr) {
                        this.drawFilledSquare(x, y, _btns[i][j], false);
                    }
                    else if (_btns[i][j] == _fourSqrTopLeft || _btns[i][j] == _fourSqrTopRight ||
                            _btns[i][j] == _fourSqrBotLeft || _btns[i][j] == _fourSqrBotRight) {

                        this.drawFourSquare(x, y, _btns[i][j], false, true);

                    }
                    else if (_btns[i][j] == _twoSqrLeft || _btns[i][j] == _twoSqrRight) {

                        this.drawTwoSquare(x, y, _btns[i][j], false);

                    }
                    else if (_btns[i][j] == _trim) {
                        var right = _trim;
                        var bottomLeft = _trim;
                        var bottomRight = _trim;
                        if (j + 1 < _cols)
                            right = _btns[i][j + 1];

                        if (i + 1 < _rows)
                            bottom = _btns[i + 1][j];

                        if ((j + 1 < _cols) && (i + 1 < _rows))
                            bottomRight = _btns[i + 1][j + 1];

                        this.drawTrim(x, y, _btns[i][j], right, bottom, bottomRight, false);
                    }
                }
            }
        }
    },
    this.insertBtns = function (startRow, startCol, btns, rows, cols) {
        // user is importing the image onto pattern, time to insert the image into the pattern
        var startR = startRow;
        var startC = startCol;
        for (var i = 0; i < rows; i++) {
            for (var j = 0; j < cols; j++) {
                if (startR >= 0 && startR < _rows && startC >= 0 && startC < _cols) {
                    _btns[startR][startC] = btns[i][j];
                    var symbol = ColorSelector.getExistingColorSymbol(btns[i][j]);
                    if (symbol === "") {
                        ColorSelector.lastSymbolUsed++;
                        var btn = ColorSelector.addColorButton(btns[i][j], "&#" + ColorSelector.lastSymbolUsed, false, true);
                    }
                }
                startC++;
            }
            startC = startCol;
            startR++;
        }
        this.redisplayPattern();
        ColorSelector.updateColorCounts();
    },

    this.insertStamp = function (startRow, startCol, btns, rows, cols) {
        // user is done moving stamp on pattern, time to insert the stamp into the pattern
        var startR = startRow;
        var startC = startCol;
        for (var i = 0; i < rows; i++) {
            for (var j = 0; j < cols; j++) {
                if (startR >= 0 && startR < _rows && startC >= 0 && startC < _cols) {
                    _btns[startR][startC] = btns[i][j];
                }
                startC++;
            }
            startC = startCol;
            startR++;
        }
    },
    this.placeBorderOnPattern = function (borderLeftWidth, borderRightWidth, borderMiddleLRWidth, borderTopHeight, borderBottomHeight, borderMiddleTBHeight, rows, cols, btns) {
        var rlMiddle = true;
        this.centerPattern();

        // get the amount of blank space on the left and right of the pattern
        // get the amount of blank space on the top and bottom of the pattern
        var loc2 = this.locateLeftRightSpace();
        var loc1 = this.locateTopBotSpace();

        //if all blank space set  1/2 cols to be used for the each side of the border
        // and set 1/2 rows to be used for top bottom of the border
        var patLeftWidth = loc2.locations.cLeft; // blank left space
        var patRightWidth = loc2.locations.cRight; // blank right space
        var patTopHeight = loc1.locations.rTop; // blank top space
        var patBottomHeight = loc1.locations.rBottom; // blank bottom space

        if (patLeftWidth < 0)
            patLeftWidth = Math.floor(_cols / 2);
        if (patRightWidth < 0)
            patRightWidth = Math.floor(_cols / 2);
        if (patTopHeight < 0)
            patTopHeight = Math.floor(_rows / 2);
        if (patBottomHeight < 0)
            patBottomHeight = Math.floor(_rows / 2);

        var resizeLeftWidth = 0;
        var resizeRightWidth = 0;
        var resizeLRMiddleWidth = 0;

        if (patLeftWidth > borderLeftWidth)
            patLeftWidth = borderLeftWidth;
        if (patRightWidth > borderRightWidth)
            patRightWidth = borderRightWidth;
        if (patTopHeight > borderTopHeight)
            patTopHeight = borderTopHeight;
        if (patBottomHeight > borderBottomHeight)
            patBottomHeight = borderBottomHeight;

        // if not enough empty space for the border for the left
        // calculate extra space needed
        if (patLeftWidth < borderLeftWidth)
            resizeLeftWidth = borderLeftWidth - patLeftWidth;

        // if not enough empty space for the border for the left
        // calculate extra space needed
        if (patRightWidth < borderRightWidth)
            resizeRightWidth = borderRightWidth - patRightWidth;

        // This is a special case where we do not want to make sure there 
        // is a least on left-right middle
        // calculate the space in the pattern for the center part of the border
        // if not enough space
        var patLRWidth = _cols - patLeftWidth - patRightWidth;
        if (patLRWidth < borderMiddleLRWidth) {
            // calculate the extra space needed for the center part of the border
            rlMiddle = false;
        }

        var resizeTopHeight = 0;
        var resizeBottomHeight = 0;
        var resizeTBMiddleHeight = 0;

        // if not enough empty space for the border for the top
        // calculate extra space needed
        if (patTopHeight < borderTopHeight)
            resizeTopHeight = borderTopHeight - patTopHeight;

        // if not enough empty space for the border for the bottom
        // calculate extra space needed
        if (patBottomHeight < borderBottomHeight)
            resizeBottomHeight = borderBottomHeight - patBottomHeight;

        // calculate the space in the pattern for the center part of the border
        // if not enough space
        var patTBHeight = _rows - patTopHeight - patBottomHeight;

        if (patTBHeight < borderMiddleTBHeight) {
            // calculate the extra space needed for the center part of the border
            resizeTBMiddleHeight = borderMiddleTBHeight - patTBHeight;
            patTBHeight += resizeTBMiddleHeight;
        }

        var repeateLRCenter = 0;

        // make an exact amount for the center border to repeate by adding
        // to it till it is evenly divisible to  resizeLRMiddleWidth
        if (rlMiddle) {
            if (borderMiddleLRWidth > 0) {
                repeateLRCenter = Math.floor(patLRWidth / borderMiddleLRWidth);
                var rem = patLRWidth % borderMiddleLRWidth;
                if (rem > 0) {
                    resizeLRMiddleWidth += borderMiddleLRWidth - rem;
                    repeateLRCenter++;
                }
            }
        }

        var repeateTBCenter = 0;
        // make an exact amount for the center border to repeate by adding
        // to it till it is evenly divisible to  resizeTBMiddleHeight
        if (borderMiddleTBHeight > 0) {
            repeateTBCenter = Math.floor(patTBHeight / borderMiddleTBHeight);
            var rem = patTBHeight % borderMiddleTBHeight;
            if (rem > 0) {
                resizeTBMiddleHeight += borderMiddleTBHeight - rem;
                repeateTBCenter++;
            }
        }

        // the resize amount
        var resizeWidth = resizeLeftWidth + resizeRightWidth + resizeLRMiddleWidth;
        var resizeHeight = resizeTopHeight + resizeBottomHeight + resizeTBMiddleHeight;

        var error = false;
        if (resizeHeight > 0 || resizeWidth > 0) {
            var newRows = _rows + resizeHeight;
            var newCols = _cols + resizeWidth;

            error = this.resizePattern(newRows, newCols);
            if (!error) {
                // right, left, up, down
                if (resizeLeftWidth != 0 || resizeTopHeight != 0 || resizeLRMiddleWidth != 0 || resizeTBMiddleHeight != 0) {
                    if (resizeLeftWidth != 0 || resizeLRMiddleWidth != 0) {
                        var moveRight = Math.floor(resizeWidth / 2);
                        if (resizeWidth % 2 > 0 && resizeLeftWidth > resizeRightWidth)
                            moveRight++;
                        this.moveSqrs(moveRight, 0, 0, 0);
                    }
                    if (resizeTopHeight != 0 || resizeTBMiddleHeight != 0) {
                        var moveDown = Math.floor(resizeHeight / 2);
                        if (resizeHeight % 2 > 0 && borderTopHeight > borderBottomHeight)
                            moveDown++;
                        this.moveSqrs(0, 0, 0, moveDown);
                    }
                }
            }
        }
        if (!error) {
            this.pasteBorder(rlMiddle, patLeftWidth, patRightWidth,
										 patTopHeight, patBottomHeight,
										 borderLeftWidth, borderRightWidth, borderMiddleLRWidth,
										 borderTopHeight, borderBottomHeight, borderMiddleTBHeight,
										 repeateLRCenter, repeateTBCenter, btns);
        }

        this.drawPattern();
    },

    this.pasteBorder = function (rlMiddle, patLeftWidth, patRightWidth,
										 patTopHeight, patBottomHeight,
										 borderLeftWidth, borderRightWidth, borderMiddleLRWidth,
										 borderTopHeight, borderBottomHeight, borderMiddleTBHeight,
										 repeateLRCenter, repeateTBCenter, btns) {
        // left top
        for (var i = 0; i < borderTopHeight; i++) {
            for (var j = 0; j < borderLeftWidth; j++) {
                var btn = btns[i][j];
                _btns[i][j] = btn === _emptySqr ? _emptySqr : _filledSqr;
            }
        }

        // right top
        var startPatCol = _cols - borderRightWidth;
        var startBtnCol = borderLeftWidth + borderMiddleLRWidth;
        for (var i = 0; i < borderTopHeight; i++) {
            for (var j = 0; j < borderRightWidth; j++) {
                var btn = btns[i][j + startBtnCol];
                _btns[i][j + startPatCol] = btn === _emptySqr ? _emptySqr : _filledSqr;
            }
        }
        // left bottom
        var startPatRow = _rows - borderBottomHeight;
        var startBtnRow = borderTopHeight + borderMiddleTBHeight;
        for (var i = 0; i < borderBottomHeight; i++) {
            for (var j = 0; j < borderLeftWidth; j++) {
                var btn = btns[i + startBtnRow][j];

                _btns[i + startPatRow][j] = btn === _emptySqr ? _emptySqr : _filledSqr;
            }
        }

        // right bottom
        startPatRow = _rows - borderBottomHeight;
        startBtnRow = borderTopHeight + borderMiddleTBHeight;
        startPatCol = _cols - borderRightWidth;
        startBtnCol = borderLeftWidth + borderMiddleLRWidth;
        for (var i = 0; i < borderBottomHeight; i++) {
            for (var j = 0; j < borderRightWidth; j++) {
                var btn = btns[i + startBtnRow][j + startBtnCol];
                _btns[i + startPatRow][j + startPatCol] = btn === _emptySqr ? _emptySqr : _filledSqr;
            }
        }

        // middle top and middle bottom
        startPatCol = borderLeftWidth;
        startBtnCol = borderLeftWidth;
        if (rlMiddle) {

            for (var k = 0; k < repeateLRCenter; k++) {
                for (var i = 0; i < borderTopHeight; i++) {
                    for (var j = 0; j < borderMiddleLRWidth; j++) {
                        var btn = btns[i][j + startBtnCol];
                        _btns[i][j + startPatCol] = btn === _emptySqr ? _emptySqr : _filledSqr;
                    }
                }
                startBtnRow = borderTopHeight + borderMiddleTBHeight;
                startPatRow = _rows - borderBottomHeight;
                for (var i = 0; i < borderBottomHeight; i++) {
                    for (var j = 0; j < borderMiddleLRWidth; j++) {
                        var btn = btns[i + startBtnRow][j + startBtnCol];
                        _btns[i + startPatRow][j + startPatCol] = btn === _emptySqr ? _emptySqr : _filledSqr;
                    }
                }
                startPatCol += borderMiddleLRWidth;
            }
        }
        // middle right and middle left
        startPatRow = borderTopHeight;
        startBtnRow = borderTopHeight;

        for (var k = 0; k < repeateTBCenter; k++) {

            // middle left
            for (var i = 0; i < borderMiddleTBHeight; i++) {
                for (var j = 0; j < borderLeftWidth; j++) {
                    btn = btns[i + startBtnRow][j];
                    _btns[i + startPatRow][j] = btn === _emptySqr ? _emptySqr : _filledSqr;
                }
            }
            // middle right
            startBtnCol = borderLeftWidth + borderMiddleLRWidth;
            startPatCol = _cols - borderRightWidth;
            for (var i = 0; i < borderMiddleTBHeight; i++) {
                for (var j = 0; j < borderRightWidth; j++) {
                    btn = btns[i + startBtnRow][j + startBtnCol];
                    _btns[i + startPatRow][j + startPatCol] = btn === _emptySqr ? _emptySqr : _filledSqr;
                }
            }
            startPatRow += borderMiddleTBHeight;
        }

    },

    this.resizePattern = function (r, c) {
        if (r > _maxRows || c > _maxCols) {
            alert('Too many rows and columns');
            return true;
        }
        else if (r <= 0 || c <= 0) {
            alert('Rows and Columns must be greater than zero');
            return true;
        }
        else {
            var newState = _emptySqr;
            var tmpBtns = [];

            // initialize tmpBtns
            for (var i = 0; i < r; i++) {
                tmpBtns[i] = [];
                for (var j = 0; j < c; j++) {
                    tmpBtns[i][j] = 0;
                }
            }

            // make the rows of pin buttons
            var btn = _emptySqr;
            for (var i = 0; i < r; i++) {
                for (var j = 0; j < c; j++) {
                    if (i < _rows && j < _cols) {
                        btn = _btns[i][j];
                        if (i == (r - 1) && (btn == _fourSqrTopLeft || btn == _fourSqrTopRight)) {
                            btn = newState;
                        }
                        else if ((j == (c - 1)) && (btn == _fourSqrTopLeft || btn == _fourSqrBotLeft)) {
                            btn = newState;
                        }
                    }
                    else {
                        btn = newState;
                    }
                    tmpBtns[i][j] = btn;
                }
            }
            _btns = tmpBtns;
            _rows = r;
            _cols = c;
        }
        return false;
    },

    this.centerPattern = function () {

        var loc1 = this.locateTopBotSpace();
        var loc2 = this.locateLeftRightSpace();
        if (loc2.locations.lMiddle > 0 || loc2.locations.rMiddle > 0)
            this.moveSqrs(loc2.locations.rMiddle, loc2.locations.lMiddle, 0, 0);
        if (loc1.locations.upM > 0 || loc1.locations.downM > 0)
            this.moveSqrs(0, 0, loc1.locations.upM, loc1.locations.downM);
    },

    this.moveSqrs = function (right, left, up, down) {

        var movedRight = false;
        var movedLeft = false;
        var movedUp = false;
        var movedDown = false;

        var w = (_squareW * _cols) + 1;
        var x = right - left;
        var y = down - up;
        var tmpBtns = [];

        // initialize tmpBtns
        for (var i = 0; i < _rows; i++) {
            tmpBtns[i] = [];
            for (var j = 0; j < _cols; j++) {
                tmpBtns[i][j] = _btns[i][j];
            }
        }

        // if we are moving right
        if (x > 0 && x < _cols) {

            movedRight = true;

            for (var i = 0; i < _rows; i++) {
                for (j = _cols - x; j > 0; j--) {
                    var btn = _btns[i][j - 1];

                    if (j == (_cols - right) && (btn == _fourSqrTopLeft || btn == _fourSqrBotLeft || btn == _twoSqrLeft)) {
                        btn = _emptySqr;
                    }
                    tmpBtns[i][j - 1 + x] = btn;
                }
            }

            // make moved left cols blank
            for (var i = 0; i < _rows; i++) {
                for (j = 0; j < x; j++) {
                    tmpBtns[i][j] = _emptySqr;
                }
            }
        }

        // if we are moving left    
        else if (x < 0 && x > -_cols) {
            movedLeft = true;

            // for all rows and cols except rightmost col
            // move one pin to the left
            x = Math.abs(x);
            for (var i = 0; i < _rows; i++) {
                for (var j = 0; j < _cols - x; j++) {
                    var btn = _btns[i][j + x];
                    if (j == (x - left) && (btn == _fourSqrTopRight || btn == _fourSqrBotRight || btn == _twoSqrRight)) {
                        btn = _emptySqr;
                    }
                    tmpBtns[i][j] = btn;
                }
            }
            // make moved right cols blank
            for (var i = 0; i < _rows; i++) {
                for (var j = _cols - 1; j >= _cols - x; j--) {
                    tmpBtns[i][j] = _emptySqr;
                }
            }
        }
        // if we are moving up
        if (y < 0 && y > -_rows) {
            movedUp = true;

            // for all rows and cols except top row
            // move one pin up
            y = Math.abs(y);
            for (var i = 0; i < _rows - y; i++) {
                for (var j = 0; j < _cols; j++) {
                    var btn = _btns[i + y][j];
                    if (i == (y - up) && (btn == _fourSqrBotLeft || btn == _fourSqrBotRight)) {
                        btn = _emptySqr;
                    }
                    tmpBtns[i][j] = btn;
                }
            }
            // make moved bottom cols blank
            for (var i = _rows - 1; i >= _rows - y; i--) {
                for (j = 0; j < _cols; j++) {
                    tmpBtns[i][j] = _emptySqr;
                }
            }
        }
        // if we are moving down
        else if (y > 0 && y < _cols) {
            movedDown = true;

            // for all rows and cols except bottom row
            // move one pin down
            for (var i = _rows - y; i > 0; i--) {
                for (var j = 0; j < _cols; j++) {
                    var btn = _btns[i - 1][j];
                    if (i == (_rows - down) && (btn == _fourSqrTopLeft || btn == _fourSqrTopRight)) {
                        btn = _emptySqr;
                    }
                    tmpBtns[i - 1 + y][j] = btn;
                }
            }

            // make moved left cols blank
            for (var i = 0; i < y; i++) {
                for (var j = 0; j < _cols; j++) {
                    tmpBtns[i][j] = _emptySqr;
                }
            }
        }
        _btns = tmpBtns;
    },

    this.locateTopBotSpace = function () {
        var rTop = -1;
        var rBottom = -1;
        var uMiddle = 0;
        var dMiddle = 0;

        var done = false;
        var i = 0;

        while (i < _rows && !done) {
            var j = 0;
            while (j < _cols && !done) {
                // not PNull and not off
                if (_btns[i][j] !== _pnull && _btns[i][j] !== _emptySqr) {
                    done = true;
                }
                j++;
            }
            i++;
        }

        // if found non-empty row
        if (done) {
            done = false;
            rTop = --i;
            i = _rows - 1;

            // starting from bottom find first row that is not empty
            while (i >= 0 && !done) {
                var j = 0;
                while (j < _cols && !done) {
                    if (_btns[i][j] != _pnull && _btns[i][j] != _emptySqr) {
                        done = true;
                    }
                    j++;
                }
                i--;
            }
        }
        // if found top and bottom first non empty rows
        if (done) {

            // count rows starting from bottom
            rBottom = (_rows - 1) - (i + 1);

            // total empty rows above and below pattern / 2
            var delta = Math.floor((rTop + rBottom) / 2);

            // number of rows we need to move pattern
            var m = rTop - delta;
            if (m > 0) {
                uMiddle = m;
            }
            else {
                dMiddle = -m;
            }
        }
        return { 'locations': { 'rTop': rTop, 'rBottom': rBottom, 'upM': uMiddle, 'downM': dMiddle} };
    },

    this.locateLeftRightSpace = function () {
        var cLeft = -1;
        var cRight = -1;
        var rMiddle = 0;
        var lMiddle = 0;

        var done = false;
        var j = 0;

        // starting from top workding down the pattern find first col that is not empty
        while (j < _cols && !done) {
            var i = 0;
            while (i < _rows && !done) {
                if (_btns[i][j] != _pnull && _btns[i][j] != _emptySqr)
                    done = true;
                i++;
            }
            j++;
        }
        // if found non empty row
        if (done) {
            done = false;
            cLeft = --j;
            j = _cols - 1;

            // starting from  find first col that is not empty
            while (j >= 0 && !done) {
                var i = 0;
                while (i < _rows && !done) {
                    if (_btns[i][j] != _pnull && _btns[i][j] != _emptySqr)
                        done = true;
                    i++;
                }
                j--;
            }
        }
        // if found top and bottom first non empty rows
        if (done) {
            // count rows starting from bottom
            cRight = (_cols - 1) - (j + 1);

            // total empty rows above and below pattern / 2
            var delta = Math.floor((cLeft + cRight) / 2);

            // number of rows we need to move pattern
            var m = cLeft - delta;
            if (m > 0) {
                lMiddle = m;
            }
            else {
                rMiddle = -m;
            }
        }
        return { 'locations': { 'cLeft': cLeft, 'cRight': cRight, 'lMiddle': lMiddle, 'rMiddle': rMiddle} };
    },
    this.createLocBox = function () {
        var locCanvas = $("#locCanvas");
        var w = _squareW;
        var h = _squareH;
        locCanvas[0].width = w
        locCanvas[0].height = h;
        locCanvas.width(w);
        locCanvas.width(h);
        var ctx = locCanvas[0].getContext('2d');
        ctx.clearRect(0, 0, w, w);
        ctx.fillStyle = "red";
        ctx.fillRect(0, 0, w, h);
    }
};


