// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var paypal = {

    title: "",
    filename: "",

    initPayPal: function () {
        // start to initialize PayPalMobile library
        paypal.initPaymentUI();
    },
    initPaymentUI: function () {
        var clientIDs = {
            "PayPalEnvironmentProduction": "AX3pQhDRcLeJyN_pspno8MsLhBpRoRShHQKrnuHEQjJ9J3Z85r2cmoVGw_rs",
            "PayPalEnvironmentSandbox": "AWEk6BDF0ov4WAPG22BimLO6duOCxgdGDXRXyQkI-w3piQY-l3_23LhS_NYB"
        };
        PayPalMobile.init(clientIDs, paypal.onPayPalMobileInit);
    },
    onPayPalMobileInit: function () {
        // use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
        //PayPalMobile.prepareToRender("PayPalEnvironmentNoNetwork", paypal.configuration(), paypal.onPrepareRender);

        // use for production
        //PayPalMobile.prepareToRender("PayPalEnvironmentProduction", paypal.configuration(), paypal.onPrepareRender);
        PayPalMobile.prepareToRender("PayPalEnvironmentSandbox", paypal.configuration(), paypal.onPrepareRender);
    },
    configuration: function () {
        // for more options see `paypal-mobile-js-helper.js`
        // sandbox account username:janet@crochetdesigns.com pass:blue1moon
        var config = new PayPalConfiguration(
            {
                //  default will accept credit, user will be remembered, no shipping address required

                // not used in this app
                // only used when requesting conset via PayPalFuturePaymentViewController
                // to allow future payments without having to log into paypal
                merchantName: "Sand Castle Designs, Inc.",

                // not used in this app
                // only used when requesting conset via PayPalFuturePaymentViewController
                // to allow future payments without having to log into paypal
                merchantPrivacyPolicyURL: "http://www.crochetdesigns.com/about/privacy.htm",

                // not used in this app
                // only used when requesting conset via PayPalFuturePaymentViewController
                // to allow future payments without having to log into paypal
                merchantUserAgreementURL: "http://www.crochetdesigns.com/about/privacy.htm",


                /// Sandbox credentials can be difficult to type on a mobile device. Setting this flag to YES will 
                /// cause the sandboxUserPassword and sandboxUserPin to always be pre-populated into login fields. 
                /// 
                /// This setting will have no effect if the operation mode is production. 
                forceDefaultsInSandbox: true,
                sandboxUserPassword: "blue2moon"
                /// PIN to use for sandbox if 'forceDefaultsInSandbox' is set. 
                //sandboxUserPin: null 

            });
        return config;
    },

    createInvoiceNumber: function () {
        var now = new Date();
        var month = (now.getMonth() + 1).toString();
        month = month.length === 2 ? month : '0' + month;
        var day = now.getDay().toString();
        day = day.length === 2 ? day : '0' + day;
        var hours = now.getHours().toString();
        hours = hours === 2 ? hours : '0' + hours;
        var mins = now.getMinutes();
        mins = mins === 2 ? mins : '0' + mins;
        var invoiceNumber = 'PPM' + now.getFullYear().toString() + month +
                            day + hours + mins + now.getSeconds();
        return invoiceNumber;
    },

    // nothing to do here
    onPrepareRender: function () {
    },

    // user clicked button to Enable Create pattern button
    createEnableCreatePayment: function (btn) {
        PayPalMobile.renderSinglePaymentUI(paypal.createEnableCreatePaypalPayment(), paypal.onEnableCreatePayment, paypal.onUserCanceled);
    },

    createEnableCreatePaypalPayment: function () {
        paypal.title = "";

        // for simplicity use predefined amount
        // optional payment details for more information check [helper js file](https://github.com/paypal/PayPal-Cordova-Plugin/blob/master/www/paypal-mobile-js-helper.js)
        // subtotal, shipping, tax
        var paymentDetails = new PayPalPaymentDetails("2.99", "0.00", "0.00");

        // you can set intent to Sale, Auth for authorization only or Order for order. We want Sale here.
        var payment = new PayPalPayment("2.99", "USD", "Bead Loom Pattern Creator Mobile", "Sale", paymentDetails);

        // create a unique invoice number
        var invoiceNumber = paypal.createInvoiceNumber();
        payment.invoiceNumber(invoiceNumber);

        // add the pattern title and the pattern filename
        var custom = { 'Bead Loom Pattern Creator Mobile': 'Create patterns' };
        payment.custom(JSON.stringify(custom, null, 4));

        // passed along to buyers credit card statement
        payment.softDescriptor("CrochetDesigns.com");
        return payment;
    },

    onEnableCreatePayment: function (payment) {
        // verify payment
        var state = payment.response.state;
        var intent = payment.response.intent;
        var type = payment.response_type;

        // https://developer.paypal.com/docs/integration/mobile/verify-mobile-payment/
        // look for state approved.
        if (state.toLowerCase() === "approved" && intent.toLowerCase() === "sale" && type.toLowerCase() === "payment") {
            alert("Congratulations, you can now create Bead Loom patterns using Bead Loom Pattern Creator. ");
            buy.updateEnableCreateFile();
        }
        else {
            alert('Sorry received state: ' + state);
        }
    },
    onUserCanceled: function (result) {

        // if user cancels the payment result = " payment canceled"
        alert(result);
    }
};    