﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

var save = {

    fileName: "",
    title: "",
    patFileUri: "",
    paletteFileUri: "",
    content: "",
    patImage: null,
    goToPage: "",
    canvasId: null,

    init: function () {
        save.fileName = "";
        save.title = "";
        save.patFileUri = "";
        save.patImage = null;
        save.goToPage = "";
        save.canvasId = null;
        $("#savetitle").val("");
        $("#savefilename").val("");
        $("#savepattitle").val("");
        $("#savepatname").val("");
    },

    displayProdPic: function (canvasId) {
        save.canvasId = canvasId;
        var canvas = $(canvasId);
        _pat.drawFinishedProdPic(canvas);
    },

    // return base-64 encoded image (ascii)
    //http://www.tech.theplayhub.com/phonegap_plugin_to_convert_base64_string_to_a_png_image_in_android/
    convertPatToPng: function () {
        var canvas = $(save.canvasId);
        var dataURL = canvas[0].toDataURL("image/png");
        dataURL = dataURL.replace(/^data:image\/(png|jpg);base64,/, "");
        return dataURL;
    },


    // remove special char for pattern file name
    savePattern: function (btn) {

        save.title = "";
        if (btn.id == "savebutton") {
            save.title = $("#savetitle").val().replace(/\s/g, '_');
            save.fileName = $("#savefilename").val().replace(/\s/g, '_');
        }
        else {
            save.title = $("#savepattitle").val().replace(/\s/g, '_');
            save.fileName = $("#savepatname").val().replace(/\s/g, '_');

        }

        save.fileName = save.fileName.replace(/[\x00-\x20]/g, '').replace(/[\x7F-\xFF]/g, '')
        _pat.setTitle(save.title);

        save.fileName = save.fileName.toLowerCase();
        // save.filename get set in app.showPattern
        if (save.fileName === "" || save.fileName === ".cht") {
            var now = new Date();
            save.fileName = "c" + now.getFullYear() + now.getMonth() + now.getDate() + now.getHours() + now.getMinutes() + now.getSeconds() + ".cht"; ;
        }

        save.fileName = save.fileName.toLowerCase();
        if (save.fileName.substring(save.fileName.length - 4) !== ".cht") {
            save.fileName += ".cht";
        }

        save.content = _pat.createPatternContent();

        // get the color palette (only colors user has added)
        var colorSymbols = ColorSelector.getColorsSymbols();

        if (colorSymbols.length > 0) {
            save.content += "USERCOLORS FOLLOW\n";
            for (var i = 0; i < colorSymbols.length; i++) {
                save.content += colorSymbols[i].color + " " + colorSymbols[i].symbol + "\n";
            }
        }

        // create an image of the pattern
        var image = save.convertPatToPng();
        save.patImage = save.b64toBlob(image, 'image\png', 512);
        try {
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, save.writePatternFile, save.fail);
        }
        catch (err) {
            alert('Error saving pattern ' + err.message);
        }

        try {
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, save.writeColorPalette, save.fail);
        }
        catch (err) {
            alert('Error saving pattern ' + err.message);
        }

        return true;
    },

    writeColorPalette: function (fileSystem) {
        fileSystem.root.getFile(app.patFolder + '/color.palette', { create: true, exclusive: false }, save.writeColorPaletteFile, save.fail);
    },

    writeColorPaletteFile: function (fileEntry) {

        save.paletteFileUri = fileEntry.toURI();
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function (evt) {
                try {
                    // get list of bought patterns and create list of bought patterns
                }
                catch (err) {
                    alert('Error saving pattern ' + err.message);
                    return false;
                }
            }
            var content = ColorSelector.getPaletteFileContents();
            fileWriter.write(content);
        }, save.fail);

    },

    writePatternFile: function (fileSystem) {
        fileSystem.root.getFile(app.patFolder + '/' + save.fileName, { create: true, exclusive: false }, save.writePatFile, save.fail);
    },

    writePatFile: function (fileEntry) {
        save.patFileUri = fileEntry.toURI();
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function (evt) {
                try {
                    // get list of bought patterns and create list of bought patterns
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, save.writePatternImageFile, save.fail);
                }
                catch (err) {
                    alert('Error saving pattern ' + err.message);
                    return false;
                }
            }
            fileWriter.write(save.content);
        }, save.fail);

    },
    writePatternImageFile: function (fileSystem) {
        var patternImageFilename = save.fileName.toLowerCase().replace(".cht", "pattern.png");
        fileSystem.root.getFile(app.patFolder + '/' + patternImageFilename, { create: true, exclusive: false }, save.writePatImageFile, save.fail);
    },

    writePatImageFile: function (fileEntry) {
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function (evt) {

                // if back icon button pressed, we need to go to main page if no errors
                if (save.goToPage === "main-page") {
                    save.goToPage = "";
                    $.mobile.changePage("#main-page", null, true, true);
                }

                // use phone back-button pressed, just need to reload the main page.
                else {
                    window.location.reload();
                }
            }
            fileWriter.write(save.patImage);
        }, save.fail);

    },
    fail: function (error) {
        var msg = app.getFileErrorCode(error);
        alert("Error saving pattern : " + msg);
    },
    encode_utf8: function (s) {
        return unescape(encodeURIComponent(s));
    },
    b64toBlob: function (b64Data, contentType, sliceSize) {
        contentType = contentType;
        sliceSize = sliceSize;
        var byteCharacters;
        try {
            byteCharacters = atob(b64Data);
        }
        catch (e) {
            alert(e.message);
        }
        var byteArrays = [];
        try {
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
        }
        catch (e) {
            alert(e.message);
            return null;
        }
        var blob;
        try {

            blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }
        catch (e) {
            // TypeError old chrome and FF
            window.BlobBuilder = window.BlobBuilder ||
                         window.WebKitBlobBuilder ||
                         window.MozBlobBuilder ||
                         window.MSBlobBuilder;
            if (e.name == 'TypeError' && window.BlobBuilder) {
                var bb = new BlobBuilder();
                for (var i = 0; i < byteArrays.length; i++) {
                    bb.append(byteArrays[i].buffer);
                }
                blob = bb.getBlob(contentType);
                return blob;
            }
            else if (e.name == "InvalidStateError") {
                // InvalidStateError (tested on FF13 WinXP)
                blob = new Blob(byteArrays, { type: contentType });
                return blob;
            }
            else {
                // We're screwed, blob constructor unsupported entirely   
            }
        }
        return null;
    }
};