// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
//https: //www.w3schools.com/howto/tryit.asp?filename=tryhow_js_sidenav
var selectionBox = {
    boxCanvas: null,
    width: 0,
    height: 0,
    size: { 'x1': 0, 'y1': 0, 'x2': 0, 'y2': 0 },
    sizeSqrs: { 'r1': 0, 'c1': 0, 'r2': 0, 'c2': 0 },
    canvasOffset: { "top": 0, "left": 0 },
    mode: "",
    pat: null,
    moveBox: { 'left': 0, 'top': 0, 'bottom': 0, 'right': 0 },
    dragBoxAborted: false,
    displayBox: function (x, y) {

        // remove the canvas if it exits and create a new one
        selectionBox.removeBoxCanvas();
        selectionBox.dragBoxAborted = false;
        // display outline rubberband box
        var thumbnail = $("#thumbnail");
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();
        var patternDiv = $("#patternPage");
        var offset = patternDiv.offset();
        selectionBox.canvasOffset.top = top + offset.top;
        selectionBox.canvasOffset.left = left + offset.left;
        thumbnail.css('top', selectionBox.canvasOffset.top.toString() + "px");
        thumbnail.css('left', selectionBox.canvasOffset.left.toString() + "px");

        selectionBox.createBoxCanvas();
        selectionBox.width = _pat.getWidth();
        selectionBox.height = _pat.getHeight();

        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        selectionBox.boxCanvas.width(selectionBox.width);
        selectionBox.boxCanvas.height(selectionBox.height);

        var bCanvas = selectionBox.boxCanvas[0];
        bCanvas.width = selectionBox.width;
        bCanvas.height = selectionBox.height;

        // x1, y1, x2,y2 are in pixels
        selectionBox.size.x1 = x - selectionBox.canvasOffset.left;
        selectionBox.size.y1 = y - selectionBox.canvasOffset.top;

        // r1,c1, r2,c2 are in number of rows/cols
        selectionBox.sizeSqrs.c1 = Math.floor(selectionBox.size.x1 / sqrW);
        selectionBox.sizeSqrs.c2 = selectionBox.sizeSqrs.c1 + 1;
        selectionBox.size.x1 = selectionBox.sizeSqrs.c1 * sqrW;
        selectionBox.size.x2 = selectionBox.size.x1 + sqrW;

        selectionBox.sizeSqrs.r1 = Math.floor(selectionBox.size.y1 / sqrH);
        selectionBox.sizeSqrs.r2 = selectionBox.sizeSqrs.r1 + 1;
        selectionBox.size.y1 = selectionBox.sizeSqrs.r1 * sqrH;
        selectionBox.size.y2 = selectionBox.size.y1 * sqrH;

        var context = bCanvas.getContext('2d');
        context.fillStyle = "rgba(0, 0, 200, 0.5)";
        context.strokeStyle = "#1b7ec1";
        context.lineWidth = 3;
        context.beginPath();
        context.rect(selectionBox.size.x1, selectionBox.size.y1, sqrW, sqrH);
        context.stroke();
        context.closePath();
        selectionBox.mode = "dragbox";
    },

    // drag the rubberband box
    dragBox: function (x, y) {
        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        var bCanvas = selectionBox.boxCanvas[0];
        var context = bCanvas.getContext('2d');

        context.clearRect(0, 0, selectionBox.width, selectionBox.height);

        context.fillStyle = "rgba(0, 0, 200, 0.5)";
        context.strokeStyle = "#1b7ec1";
        context.lineWidth = 3;

        var c1 = selectionBox.size.x1 / sqrW;
        var r1 = selectionBox.size.y1 / sqrH;

        var c2 = x - selectionBox.canvasOffset.left;
        var r2 = y - selectionBox.canvasOffset.top;

        c2 = Math.floor(c2 / sqrW);
        selectionBox.size.x2 = c2 * sqrW;

        r2 = Math.floor(r2 / sqrH);
        selectionBox.size.y2 = r2 * sqrH;

        // make sure the drag box does not go off the pattern
        if (c1 < c2) {
            if (c1 < 0) {
                selectionBox.size.x1 = 0;
            }
            if (c2 > _pat.getCols()) {
                selectionBox.size.x2 = _pat.getCols() * sqrW;
            }
        }
        else {
            if (c1 > _pat.getCols()) {
                selectionBox.size.x1 = _pat.getCols() * sqrW;
            }
            if (c2 < 0) {
                selectionBox.size.x2 = 0;
            }
        }

        if (r1 < r2) {
            if (r1 < 0) {
                selectionBox.size.y1 = 0;
            }
            if (r2 > _pat.getRows()) {
                selectionBox.size.y2 = _pat.getRows() * sqrH;
            }
        }
        else {
            if (r1 > _pat.getRows()) {
                selectionBox.size.y1 = _pat.getRows() * sqrH;
            }
            if (r2 < 0) {
                selectionBox.size.y2 = 0;
            }
        }
        context.beginPath();
        context.rect(selectionBox.size.x1, selectionBox.size.y1, selectionBox.size.x2 - selectionBox.size.x1, selectionBox.size.y2 - selectionBox.size.y1);
        context.stroke();
        context.closePath();
    },

    // done dragging the rubberband box
    dragBoxEnd: function () {
        selectionBox.mode = "dragboxend";
        selectionBox.saveRowColCoordinates();
    },

    // check if user selected inside the rubberband box
    insideBox: function (x, y) {
        if (selectionBox.mode === "dragboxend" && !selectionBox.dragBoxAborted) {
            x = x - selectionBox.canvasOffset.left;
            y = y - selectionBox.canvasOffset.top;
            var boxLeftX = selectionBox.size.x1 < selectionBox.size.x2 ? selectionBox.size.x1 : selectionBox.size.x2;
            var boxRightX = selectionBox.size.x2 > selectionBox.size.x1 ? selectionBox.size.x2 : selectionBox.size.x1;
            var boxTopY = selectionBox.size.y1 < selectionBox.size.y2 ? selectionBox.size.y1 : selectionBox.size.y2;
            var boxBotY = selectionBox.size.y2 > selectionBox.size.y1 ? selectionBox.size.y2 : selectionBox.size.y1;

            var inside = x >= boxLeftX && x <= boxRightX && y >= boxTopY && y <= boxBotY;
            return (inside);
        }
        return false;
    },

    // create a move box
    createMoveBox: function (x, y) {
        // use has stop dragging the outline box and now selected inside the outline box to move it
        if (selectionBox.mode === "dragboxend") {

            // copy the btns on the pattern inside the drag box
            var btns = _pat.getBtns();
            var rows = _pat.getRows();
            var cols = _pat.getCols();
            var btnsBox = [];
            var btnsRows = selectionBox.sizeSqrs.r2 - selectionBox.sizeSqrs.r1;
            var btnsCols = selectionBox.sizeSqrs.c2 - selectionBox.sizeSqrs.c1;
            for (var i = 0; i < btnsRows; i++) {
                btnsBox[i] = [];
                for (var j = 0; j < btnsCols; j++) {
                    btnsBox[i][j] = btns[selectionBox.sizeSqrs.r1 + i][selectionBox.sizeSqrs.c1 + j];
                }
            }

            var left = selectionBox.size.x1 < selectionBox.size.x2 ? selectionBox.size.x1 : selectionBox.size.x2;
            var right = selectionBox.size.x2 > selectionBox.size.x1 ? selectionBox.size.x2 : selectionBox.size.x1;
            var top = selectionBox.size.y1 < selectionBox.size.y2 ? selectionBox.size.y1 : selectionBox.size.y2;
            var bottom = selectionBox.size.y2 > selectionBox.size.y1 ? selectionBox.size.y2 : selectionBox.size.y1;
            selectionBox.drawMoveBox(btnsBox, btnsRows, btnsCols,
                                     left, top, right, bottom, true);
        }
    },

    drawMoveBox: function (btnsBox, btnsRows, btnsCols, left, top, right, bottom, clearBtns) {

        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        selectionBox.sizeSqrs.c1 = Math.floor(left / sqrW);
        selectionBox.sizeSqrs.c2 = Math.floor(right / sqrW);
        selectionBox.sizeSqrs.r1 = Math.floor(top / sqrH);
        selectionBox.sizeSqrs.r2 = Math.floor(bottom / sqrH);

        selectionBox.createBoxCanvas();
        selectionBox.pat = new Pattern(selectionBox.boxCanvas);
        selectionBox.moveBox.left = left;
        selectionBox.moveBox.right = right;
        selectionBox.moveBox.top = top;
        selectionBox.moveBox.bottom = bottom;

        // create the move box
        selectionBox.pat.readBtns(btnsBox, btnsRows, btnsCols);
        var thumbnail = $("#thumbnail");
        var bCanvas = selectionBox.boxCanvas[0];
        var context = bCanvas.getContext('2d');
        context.clearRect(0, 0, selectionBox.width, selectionBox.height);
        thumbnail.css('left', (left + selectionBox.canvasOffset.left).toString() + "px");
        thumbnail.css('top', (top + selectionBox.canvasOffset.top).toString() + "px");
        selectionBox.pat.drawMovePat(selectionBox.boxCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());
        selectionBox.mode = "movebox";

        // clear the btns inside the drag box
        if (clearBtns) {
            _pat.ClearRowsColsRange(selectionBox.sizeSqrs.r1, selectionBox.sizeSqrs.c1, btnsRows, btnsCols);
            _pat.drawGridPattern();
        }
    },

    // done moving the move box, paste the pins to the pattern
    moveBoxEnd: function (x, y) {
        var thumbnailDiv = $("#thumbnail");
        var offset = thumbnailDiv.offset();

        var pat = selectionBox.pat;
        var btns = pat.getBtns();
        var rows = pat.getRows();
        var cols = pat.getCols();

        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();

        var patDivOffset = $("#patternPage").offset();
        var startRow = Math.floor((offset.top - patDivOffset.top - _pat.getTopOffset()) / sqrH);
        var startCol = Math.floor((offset.left - patDivOffset.left - _pat.getLeftOffset()) / sqrW);

        _pat.insertStamp(startRow, startCol, btns, rows, cols);

        // remove the stamp canavs
        selectionBox.removeBoxCanvas();
        thumbnailDiv.css('top', "0px");
        thumbnailDiv.css('left', "0px");

        _pat.drawGridPattern();
        editor.modified = true;
        editor.setSelected('');
        selectionBox.mode = "";
    },
    removeBoxCanvas: function () {
        // if canvas exist set size to zero
        if (selectionBox.boxCanvas !== null) {
            selectionBox.boxCanvas.height(0);
            selectionBox.boxCanvas.width(0);
        }
    },
    createBoxCanvas: function () {
        var width = _pat.getWidth();
        var height = _pat.getHeight();
        var create = false;

        // first time create canvas 
        if (selectionBox.boxCanvas === null) {
            selectionBox.boxCanvas = $('<canvas id="boxCanvas" style="opacity:0.5;"></canvas>');
            create = true;
        }
        selectionBox.boxCanvas.height(height);
        selectionBox.boxCanvas.width(width);

        selectionBox.boxCanvas[0].width = width;
        selectionBox.boxCanvas[0].height = height;
        if (create) {
            var thumbnail = $("#thumbnail");
            thumbnail.append(selectionBox.boxCanvas);
        }
    },
    saveRowColCoordinates: function () {
        var sqrW = _pat.getSqrW();
        var sqrH = _pat.getSqrH();
        var boxLeftX = selectionBox.size.x1 < selectionBox.size.x2 ? selectionBox.size.x1 : selectionBox.size.x2;
        var boxRightX = selectionBox.size.x2 > selectionBox.size.x1 ? selectionBox.size.x2 : selectionBox.size.x1;
        var boxTopY = selectionBox.size.y1 < selectionBox.size.y2 ? selectionBox.size.y1 : selectionBox.size.y2;
        var boxBotY = selectionBox.size.y2 > selectionBox.size.y1 ? selectionBox.size.y2 : selectionBox.size.y1;
        selectionBox.sizeSqrs.c1 = Math.floor(boxLeftX / sqrW);
        selectionBox.sizeSqrs.c2 = Math.floor(boxRightX / sqrW);
        selectionBox.sizeSqrs.r1 = Math.floor(boxTopY / sqrH);
        selectionBox.sizeSqrs.r2 = Math.floor(boxBotY / sqrH);
    },

    abortDragbox: function () {
        selectionBox.removeBoxCanvas();
        selectionBox.dragBoxAborted = true;
    }
};
