﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var settings = {

    // gridColors
    grayGrid: 'GRAY',
    blackGrid: 'BLACK',

    // row column counter
    yesRC: 'YES',
    noRC: 'NO',

    beadSolid: 'SOLID',
    beadBead: 'BEAD',

    // default settings
    gridColor: 'BLACK',
    displayRC: 'YES',
    beadStyle: 'BEAD',


    // read the settings from file content and store in object
    storeSettings: function (content) {
        var lines = content.split(/\r\n|\r|\n/g);
        for (var i = 0; i < lines.length; i++) {
            var line = lines[i].split(' ');
            var param = line[0];
            var value = line[1];

            switch (param.toUpperCase()) {
                case 'GRID':
                    if (value.toUpperCase() === this.grayGrid) {
                        this.gridColor = this.grayGrid;
                    }
                    break;
                case 'COUNTER':
                    if (value.toUpperCase() === this.noRC) {
                        this.displayRC = this.noRC;
                    }
                case 'BEAD':
                    if (value.toUpperCase() === this.beadSolid) {
                        this.beadStyle = this.beadSolid;
                    }
                    break;
            }
        }
    },

    // display list of possible setting choices in dialog box
    displaySettings: function () {
        var grayGridBox = $("#grid-color-gray");
        var blackGridBox = $("#grid-color-black");
        var displayCounterBox = $("#display-counter");

        var beadStyleBead = $("#bead-style-bead");
        var beadStyleSoild = $("#bead-style-solid");

        grayGridBox.prop("checked", false).checkboxradio("refresh");
        blackGridBox.prop("checked", false).checkboxradio("refresh");
        displayCounterBox.prop("checked", false).checkboxradio("refresh");
        beadStyleBead.prop("checked", false).checkboxradio("refresh");
        beadStyleSoild.prop("checked", false).checkboxradio("refresh");

        if (this.gridColor === this.grayGrid)
            grayGridBox.prop("checked", true).checkboxradio("refresh");
        else
            blackGridBox.prop("checked", true).checkboxradio("refresh");

        if (this.displayRC === this.yesRC)
            displayCounterBox.prop("checked", true).checkboxradio("refresh");

        if (this.beadStyle === this.beadSolid)
            beadStyleSoild.prop("checked", true).checkboxradio("refresh");
        else
            beadStyleBead.prop("checked", true).checkboxradio("refresh");
    },

    // user selected save button 
    // save the setting choices to file 
    saveSettings: function () {

        this.gridColor = this.grayGrid;
        var radio = $("#grid-color-black");
        if (radio.prop('checked'))
            this.gridColor = this.blackGrid;

        this.displayRC = this.yesRC;
        var checkbox = $("#display-counter");
        if (!checkbox.prop('checked'))
            this.displayRC = this.noRC;

        this.beadStyle = this.beadBead;
        var checkbox = $("#bead-style-solid");
        if (checkbox.prop('checked'))
            this.beadStyle = this.beadSolid;

        // create text content to save to file
        var content = "";
        content += "GRID " + this.gridColor + "\n";
        content += "COUNTER " + this.displayRC + "\n";
        content += "BEAD " + this.beadStyle + "\n";

        // save the content to file
        LoomPatternDef.saveLoomPatternDef(content);

        // go back to previous screen
        history.back();
        return false;
    }
};