// Bead Loom Pattern Creator Mobile
// Copyright 2017-2020 Sand Castle Designs.Inc
// All Rights Reserved
var trace = {
    // thumbnail on pattern page top, left
    canvasOffset: { "top": 50, "left": 50 },
    initCanvasOffset: { "top": 50, "left": 50 },
    currentCanvasId: "",
    dragImage: false,
    rawCanvasId: "traceCanvastb",
    resizHandle: "",
    tracing: false,
    traceBtnSelected : false,

    displayImageUriOnPattern: function (result) {
        // convert JSON string to JSON Object
        var thisResult = JSON.parse(result);

        // convert json_metadata JSON string to JSON Object 
        // debug code for browser
        //var metadata = JSON.parse(thisResult.json_metadata);

        var img = new Image();
        img.onload = function () {
            trace.setupImageCanvas(this.naturalWidth, this.naturalHeight);
            var imageCanvas = $("#" + trace.currentCanvasId);
            var canvas = imageCanvas[0];
            var ctx = canvas.getContext("2d");
            ctx.fillStyle = "transparent";
            ctx.globalAlpha = 0.5;
            ctx.drawImage(img, 0, 0, this.naturalWidth, this.naturalHeight);
            importImage.imageState = "rawImage";
            var thumbnail = $("#thumbnail");
            thumbnail.css('top', trace.canvasOffset.top.toString() + "px");
            thumbnail.css('left', trace.canvasOffset.left.toString() + "px");
        };
        img.src = thisResult.filename;
    },
    displayImageUriOnPatternTest: function () {
        var img = new Image();
        img.onload = function () {
            trace.setupImageCanvas(this.naturalWidth, this.naturalHeight);
            var imageCanvas = $("#" + trace.currentCanvasId);
            var canvas = imageCanvas[0];
            var ctx = canvas.getContext("2d");
            ctx.globalAlpha = 0.5;
            ctx.fillStyle = "transparent";
            ctx.drawImage(img, 0, 0, this.naturalWidth, this.naturalHeight);
            importImage.imageState = "rawImage";
            var thumbnail = $("#thumbnail");
            thumbnail.css('top', trace.canvasOffset.top.toString() + "px");
            thumbnail.css('left', trace.canvasOffset.left.toString() + "px");
        };
        img.src = 'img/logo.png';
    },

    setupImageCanvas: function (width, height) {
        trace.initImageOffset();

        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();

        var thumbnail = $("#thumbnail");
        thumbnail.css('top', trace.canvasOffset.top.toString() + "px");
        thumbnail.css('left', trace.canvasOffset.left.toString() + "px");
        var gridOverlay = $("#gridOverlay");

        trace.currentCanvasId = trace.rawCanvasId;
        var imageCanvas = $('<canvas id="' + trace.currentCanvasId + '" style="z-index:2"></canvas>');
        thumbnail.append(imageCanvas);

        var canvas = imageCanvas[0];
        canvas.width = width;
        canvas.height = height;
        imageCanvas.width(width);
        imageCanvas.height(height);
        trace.tracing = true;
        // add handles to camera picture

        var handleud = $("<div id='camerahandleud' style='position:absolute; top:" + (height - 8) + "px; left:" + (width - 55) + "px;z-index:3' data-title='' data-theme='c'>" +
            "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleudImg' src='img/handleud.png' />" +
                "</div>");
        thumbnail.append(handleud);


        var handlelr = $("<div id='camerahandlelr' style='position:absolute; top:" + (height - 55) + "px;  left:" + (width - 8) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handlelrImg' src='img/handlelr.png' />" +
                        "</div>");
        thumbnail.append(handlelr);
        var handle = $("<div id='camerahandle' style='position:absolute;  top:" + (height - 20) + "px; left:" + (width - 20) + "px;z-index:3' data-title='' data-theme='c'>" +
                        "<img style='border-width:0; border-style:solid; border-color:Teal' id='handleImg' src='img/handle.png' />" +
                        "</div>");
        thumbnail.append(handle);

        var moveIcon = $("<div id='camerahandlemove' style='position:absolute; top:-40px; left:-40px;z-index:3' data-title='' data-theme='c'>" +
            "<img style='border-width:0; border-style:solid; border-color:Teal' id='handlemoveImg' src='img/moveicon.png' />" +
                "</div>");
        thumbnail.append(moveIcon);
        var closeIcon = $("<div id='camerahandleclose' style='position:absolute; top:-40px; left:" + (width - 40) + "px;z-index:3' data-title='' data-theme='c' onclick='trace.close();'>" +
            "<img style='border-width:0; border-style:solid; border-color:Teal' id='handlemoveImg' src='img/close.png' />" +
                "</div>");
        thumbnail.append(closeIcon);
    },
    initImageOffset: function () {
        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();
        trace.canvasOffset.top = top + patDivOffset.top + trace.initCanvasOffset.top;
        trace.canvasOffset.left = left + patDivOffset.left + trace.initCanvasOffset.left;
    },
    setImageOffset: function () {
        var thumbnail = $("#thumbnail");
        var thumbnailOffset = thumbnail.offset();
        trace.canvasOffset.top = thumbnailOffset.top;
        trace.canvasOffset.left = thumbnailOffset.left;
    },
    setGridOveryOffset: function () {
        var patternDiv = $("#patternPage");
        var patDivOffset = patternDiv.offset();

        // canvas margin top
        var top = _pat.getTopOffset();
        var left = _pat.getLeftOffset();

        var gridOverlay = $("#gridOverlay");
        gridOverlay.css('top', (top + patDivOffset.top) + "px");
        gridOverlay.css('left', (left + patDivOffset.left) + "px");
    },
    displayGridOnImage: function (gridCanvas) {
        var patCanvas = _pat.getCanvas();

        gridCanvas.width(patCanvas.width);
        gridCanvas.height(patCanvas.height);

        var rows = _pat.getRows();
        var cols = _pat.getCols();
        var sqrWH = _pat.getSqrWH();
        var grid = new Pattern(gridCanvas);
        grid.setCanvas(gridCanvas[0]);
        grid.setSqrWH(sqrWH);
        grid.setTopOffset(0);
        grid.setRows(rows);
        grid.setCols(cols);
        grid.setLeftOffset(0);
        grid.drawGrid(1);

    },
    insideImage: function (x, y) {
        var canvas = $("#" + trace.currentCanvasId);
        var width = canvas.width();
        var height = canvas.height();
        var thumbnailDiv = $("#thumbnail");
        var offset = thumbnailDiv.offset();
        return (x > offset.left && y > offset.top && x < offset.left + width && y < offset.top + height);
    },
    resizeImage: function (deltaX, deltaY) {
        if (deltaX !== 0 || deltaY !== 0) {
            var imageCanvas = $("#" + trace.currentCanvasId);
            var upHandle = $("#camerahandleud");
            var lrHandle = $("#camerahandlelr");
            var handle = $("#camerahandle");

            var upHandleOffset = upHandle.offset();
            var lrHandleOffset = lrHandle.offset();
            var handleOffset = handle.offset();

            var newWidth = imageCanvas.width() + deltaX;
            var newHeight = imageCanvas.height() + deltaY;

            lrHandle.css("left", newWidth - 8);
            lrHandle.css("top", newHeight - 55);

            upHandle.css("left", newWidth - 55);
            upHandle.css("top", newHeight - 8);

            handle.css("left", newWidth - 20)
            handle.css("top", newHeight - 20);

            if (trace.resizHandle === "resizeBoth") {
                imageCanvas.width(newWidth);
                imageCanvas.height(newHeight);
            }
            else if (trace.resizHandle === "resizeUpDown") {
                imageCanvas.height(newHeight);
            }
            else if (trace.resizHandle === "resizeLeftRight") {
                imageCanvas.width(newWidth);
            }
        }
    },


    moveImage: function (deltaX, deltaY) {
        try {
            var thumbnailDiv = $("#thumbnail");
            var newTop = deltaY + trace.canvasOffset.top;
            var newLeft = deltaX + trace.canvasOffset.left;
            thumbnailDiv.css("top", newTop);
            thumbnailDiv.css("left", newLeft);
        }
        catch (err) {
        }
    },
    close: function () {
        var image = $("#" + trace.currentCanvasId);
        image.hide();
        image.remove();
        var handle = $("#camerahandleud");
        handle.hide();
        handle.remove();
        handle = $("#camerahandlelr");
        handle.hide();
        handle.remove();
        handle = $("#camerahandle");
        handle.hide();
        handle.remove();
        handle = $("#camerahandlemove");
        handle.hide();
        handle.remove();
        handle = $("#camerahandleclose");
        handle.hide();
        handle.remove();
        trace.dragImage = false;
        trace.tracing = false;
        trace.traceBtnSelected = false;
    }
};